PRO alt_wedge,filename=filename,path=path,filter=filter

  ;----------------------------------------------------
  ; this version of the wedge routine will read in an
  ; alternate wedge file. gsd 1/24/03
  ;----------------------------------------------------
  ; this script will read in the specified wedge file
  ; rotate it 180 degrees and write it out to structure .
  ; then, the pe_cal routine will be called and the output
  ; will be to str=3 and an ascii file will be writen with
  ; a .vida extension. finally, a fit with wdfit3 will be
  ; performed and the file will be saved to be used against
  ; the calibration data.
  ; first close all pff files and delete wdf arrays
  closepff,0
  delwdf
  delstr

  print,'Open the step wedge file you wish to fit'
  hak,mes='r to c'
  if n_elements(path) eq 0 then path ='/remote/jarmij/jebaile/'
  if path eq 1 then pwd,current=path
  if path eq 2 then path='/remote/jarmij/jebaile/'
  if path eq 3 then path='/remote/rehawn/z_shots/'
  if n_elements(filter) eq 0 then openpff,path=path
  if n_elements(filter) eq 1 then openpff,path=path,filter=filter
  readstr,1

  check_rotation:
  plotstr,1,cn=2
  print,'does image need to be rotated or flipped? (r or f)'
  ans=''
  read,ans
  if(ans eq 'r')then begin
    read,'enter rotation code: (1-90, 2-180, 3-270, counter clockwise) ',r
    flipstr,1,rotate=r
    xfrstr,2,1
    goto,check_rotation
  endif else $
  if(ans eq 'f')then begin
    read,'flip in x or y? (x or y) ',ans
    if ans eq 'x' then flipstr,1,/xflip
    if ans eq 'y' then flipstr,1,/yflip
    goto,check_rotation
  endif

  xfrstr,1,2
  plotstr,2,cn=2
  print,'does image need to be croped? (y/n)'
  read,ans
  if(ans eq 'y')then begin winstr,2
    endif else begin xfrstr,2,3
  endelse

  print,'We will use the winstr command to get an average background level in the film'
  hak,mes='r to c'
  winstr,3,ave=fog
  ;remove background fog level from image
  substr,3,0,fog ; reduce to net fog level
  print,'fog level was: ',fog

  ; put user in exposure_values directory
  pwd,cur=here,/q
  ;cd,'/remote/gsdunha/Jim/exposure_values'
  ;cd,'C:\Gregs_IDL\programs\Exposure_Values'
  ;cd,'C:\Program Files\Exelis\pfidl\programs\Exposure_Values'
  ;cd,'/Network/Servers/copland.as.utexas.edu/Volumes/HD2/UGrads/nam263/datareduction/Exposure_Values'
  cd,'/Users/mikemon/idl_sandia/Exposure_Values'
  pe_cal,str=3,out=4,cal='A'
  done=0 ; init done flag to false
  ; use cal = 1, green, which is default in the D2E routine
  print,'Did pe_cal routine get lineouts to your satisfaction? (y/n)'
  read,ans
  ans_width = ''
  width=1000.0
  if ans ne 'n' then done = 1
  while not done do begin
    print,'width used will be ',strtrim(string(width),2),'. Is this ok? (y/n)'
    read,ans_width
    if ans_width eq 'n' then begin
      print,'enter width'
      read,width
    endif
    pe_cal,str=3,out=4,cal='A',width=width,/manual
    print,'Did pe_cal routine get lineouts to your satisfaction? (y/n)'
    read,ans
    if ans eq 'y' then done = 1
  endwhile
  wdedit,5

  ; return to wherever it was we came from
  cd,here

  wdfit3,5,6,/yl,xydata=0,zoom=0
  ;wdfit3,5,6,/yl,xydata=0,zoom=1

  print,'What file name for the vida file?'
  filename=' '
  read,filename
  wriasc,filename+'.vida',5,/vida

return
end
