FUNCTION Array, contams, Wave
; Takes in contams array that contains all the contaminants' xpp 
; values and also takes in the Wave array from SPowArr.

; This function will return an array that contains the range of
; indices where the contaminants are in the shots.
; NewArr will be used for plot,Wave(newArr),SPowArr(newArr,time)
; to plot a range of wavelengths in a window

; GE means 'greater than or equal to'
; LE means 'less than or equal to'

newArr=[]
start=contams[0]-50
finish=contams[-1]+50 

FOR i=0,size(Wave,/N_ELEMENTS)-1 DO BEGIN
  IF Wave[i] GE start AND Wave[i] LE finish THEN BEGIN
    newArr=[newArr,i]
  ENDIF
ENDFOR

RETURN, newArr

END