PRO Exray_Backdivide,MainWidget

Widget_Control,MainWidget,get_uvalue=exraystr

;open the background data file
dataOK='No'
while (dataOK ne 'Yes') do begin
   nametemp = ''
   path=''
   nametemp = dialog_pickfile(/must_exist,title='Select the data file',filter='*.ufo', $
                              path=exraystr.path,get_path=path)
   if (nametemp eq '') then return

   exraystr.path=path
   if strpos(nametemp,'.ufo') ne -1 then begin
      rufo,xdat,ydat,file=nametemp
   endif else begin
      err = 1
      count = 0
      while ((err ne 0)and(count lt 50)) do begin
         readasc,nametemp,2,xdat,ydat,error=err,skip=count
         count=count+1
      endwhile
      if count ge 50 then begin
         err=dialog_message('There was an error opening the data file.  '$
                           +'Please verify that the file is in ufo or ascii format.',/error)
      return
      endif
   endelse
   plot,xdat,ydat,pos=[0.15,0.1,0.95,0.957],title=nametemp
   dataOK = dialog_message('Is this the appropriate background data?',/Question)
endwhile


;wdf array 103 is a scratch array
i2w,xdat,ydat,103,/xy
;use wdf array 104 to temporarily hold the data information
if (exraystr.plotflag eq 3) then $
   xfr,exraystr.datawdf(exraystr.activedata),104 $
else if (exraystr.plotflag eq 4) then $
   xfr,exraystr.scaledwdf(exraystr.activedata),104

div,104,103,105

;put the result into the data (or scaled data) wdf array (104 still holds original)
if (exraystr.plotflag eq 3) then $
   xfr,105,exraystr.datawdf(exraystr.activedata) $
else if (exraystr.plotflag eq 4) then $
   xfr,105,exraystr.scaledwdf(exraystr.activedata)

;Hand control to a widget which allows the result to be multiplied by a scaler
Widget_Control,MainWidget,set_uvalue=exraystr
exray_scaletrans,MainWidget

;plot the result in the GUI window
;exraystr.plotflag=exraystr.plotflag-1
;Widget_Control,MainWidget,set_uvalue=exraystr
;widget_control,exraystr.widget.plotlist,send_event=$
;    { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:MainWidget, $
;     HANDLER:MainWidget, INDEX:exraystr.plotflag + 1 }


return
end
