PRO exray_d2i, MainWidget

widget_control, MainWidget,get_uvalue=exraystr

pic=exraystr.wfilm.filmtype


if (exraystr.plotflag eq 4) then $
   data=exraystr.scaledwdf(exraystr.activedata) $
else $
   data=exraystr.datawdf(exraystr.activedata)

Error_Status=0
CATCH,Error_Status
if Error_status NE 0 THEN begin
    whoops=dialog_message('There is a problem subtracting the fog.'$
             +' Please verify the settings',/ERROR)
    CATCH,/CANCEL
    return
endif
if (exraystr.wfilm.fogflag eq 1) then $
   sub,data,exraystr.wfilm.fogwdf,103 $
else $
   sub,data,0,exraystr.wfilm.fog,103
w2i,lamda,lineout_data,103
CATCH,/CANCEL

film = pic - 1

ang=!pi/2.0

henke_film_resp, film, lamda, lineout_data, ang, spect_data, $
    exraystr.wfilm.tension,exraystr.wfilm.interpolflag,0


; Plot it and ask if user is satisfied

yrange=[min(spect_data),max(spect_data)]

plot,lamda,spect_data,col=0,line=0,xrange=exraystr.xrange,yrange=yrange $
       ,xtitle='Wavelength (Angstroms)',pos=[0.15,0.1,0.95,0.957],xstyle=1,ystyle=1 $
       ,psym=0,ytitle='Intensity photons/um^2'

wait,0.0
check=dialog_message('Is this acceptable?',/Question)
if (check eq 'Yes') then begin
   ;permanently overwrite the active scaledwdf
   if (exraystr.plotflag eq 4) then $
      i2w,lamda,spect_data,exraystr.scaledwdf(exraystr.activedata),/xy $
   else $
      i2w,lamda,spect_data,exraystr.datawdf(exraystr.activedata),/xy
endif
plotflag=exraystr.plotflag
exraystr.plotflag = 0
widget_control,MainWidget,set_uvalue=exraystr
widget_control,exraystr.widget.plotlist,send_event=$
      { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:MainWidget, $
         HANDLER:MainWidget, INDEX:plotflag }

return
end
