PRO exray_opendata, exraystr, wdf=wdf, file=filename

nametemp = ''
path=''
nametemp = dialog_pickfile(/must_exist,title='Select the data file',filter='*.ufo', $
                           path=exraystr.path,get_path=path)
if (nametemp eq '') then return

exraystr.path=path
if strpos(nametemp,'.ufo') ne -1 then begin
   rufo,xdat,ydat,file=nametemp
endif else begin
   err = 1
   count = 0
   while ((err ne 0)and(count lt 50)) do begin
      readasc,nametemp,2,xdat,ydat,error=err,skip=count
      count=count+1
   endwhile
   if count ge 50 then begin
      err=dialog_message('There was an error opening the data file.  '$
                        +'Please verify that the file is in ufo or ascii format.',/error)
      return
   endif
endelse


i2w,xdat,ydat,60,/xy
index=where(get_wdf() eq 60)
delwdf,60
if (index(0) lt 0) then begin
   err=dialog_message('There was an error opening the data file.  '$
              +'Please verify that the file contains data in ufo or ascii format.',/error)
   return
endif

if (n_elements(wdf) ne 0) then begin
   i2w,xdat,ydat,wdf,/xy
   if (n_elements(filename) ne 0) then $
      filename=nametemp
   return
endif

exraystr.numdata=exraystr.numdata+1
if (exraystr.numdata gt 10) then begin
   whoops=dialog_message('There are too many data sets open.  Please remove '$
         +'one before opening another set.',/Error)
   exraystr.numdata=exraystr.numdata-1
   return
endif else begin
   exraystr.activedata=exraystr.numdata-1
   i2w,xdat,ydat,exraystr.datawdf(exraystr.activedata),/xy
   exraystr.datafile(exraystr.activedata) = nametemp
endelse


return
end
