

pro Exray_TransWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = transtr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Element_DROPLIST'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
         i=event.index
         ;if the transition file does not exist, then make the button insensitive
         ;also check to see if the user has already selected a transition
         if (transtr.optstr.exraystr.element(i).Ly.lambda(0) eq 0.) then $
            widget_control,transtr.Ly,Sensitive=0 $
         else if (transtr.whichtrans(i,0) gt 0) then $
            widget_control,transtr.Ly,set_button=1
         if (transtr.optstr.exraystr.element(i).He.lambda(0) eq 0.) then $
            widget_control,transtr.He,Sensitive=0 $
         else if (transtr.whichtrans(i,1) gt 0) then  $
            widget_control,transtr.He,set_button=1
         if (transtr.optstr.exraystr.element(i).Li.lambda(0) eq 0.) then $
            widget_control,transtr.Li,Sensitive=0 $
         else if (transtr.whichtrans(i,2) gt 0) then $
            widget_control,transtr.Li,set_button=1
         if (transtr.optstr.exraystr.element(i).Ka.lambda(0) eq 0.) then $
            widget_control,transtr.Ka,Sensitive=0 $
         else if (transtr.whichtrans(i,3) gt 0) then $
            widget_control,transtr.Ka,set_button=1
         if (transtr.optstr.exraystr.element(i).Kb.lambda(0) eq 0.) then $
            widget_control,transtr.Kb,Sensitive=0 $
         else if (transtr.whichtrans(i,4) gt 0) then $
            widget_control,transtr.Kb,set_button=1
         if (transtr.optstr.exraystr.element(i).Kg.lambda(0) eq 0.) then $
            widget_control,transtr.Kg,Sensitive=0 $
         else if (transtr.whichtrans(i,5) gt 0) then $
            widget_control,transtr.Kg,set_button=1
         ;if the user has already asked to include this element, then set the button
         if transtr.whichelements(i) gt 0 then widget_control,transtr.include,set_button=1 $
         else widget_control,transtr.include,set_button=0
         transtr.index=i
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Include_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichelements(transtr.index) =0
        endif else begin
           transtr.whichelements(transtr.index) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='LySeries_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichtrans(transtr.index,0) =0
        endif else begin
           transtr.whichtrans(transtr.index,0) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='HeSeries_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichtrans(transtr.index,1) =0
        endif else begin
           transtr.whichtrans(transtr.index,1) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='LiSeries_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichtrans(transtr.index,2) =0
        endif else begin
           transtr.whichtrans(transtr.index,2) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='KaSeries_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichtrans(transtr.index,3) =0
        endif else begin
           transtr.whichtrans(transtr.index,3) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='KbSeries_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichtrans(transtr.index,4) =0
        endif else begin
           transtr.whichtrans(transtr.index,4) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='KgSeries_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           transtr.whichtrans(transtr.index,5) =0
        endif else begin
           transtr.whichtrans(transtr.index,5) =1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Done_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables and calculate the result
        transtr.optstr.exraystr.whichelements=transtr.whichelements
        transtr.optstr.exraystr.whichtrans=transtr.whichtrans
        ;if no elements selected, then turn off button in scaleopt widget
        index=where(transtr.whichelements gt 0)
        if (index(0) lt 0) then widget_control,transtr.optstr.transitions,set_button=0 $
        else widget_control,transtr.optstr.transitions,set_button=1
        widget_control,transtr.MainWidget,set_uvalue=transtr.optstr
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        ;if no elements selected, then turn off button in scaleopt widget
        index=where(transtr.optstr.exraystr.whichelements gt 0)
        if (index(0) lt 0) then widget_control,transtr.optstr.transitions,set_button=0 $
        else widget_control,transtr.optstr.transitions,set_button=1
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = transtr


end

pro Exray_TransWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control,MainWidget,get_uvalue=optstr

  Exray_TransWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_TransWidget_BASE',Column=1,$
      TITLE='Atomic Transitions' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  Element_Base = Widget_Base(Exray_TransWidget_BASE, Column=2)

  Element_DROPLIST = Widget_Droplist(Element_Base,  $
      UNAME='Element_DROPLIST' ,SENSITIVE=1,TITLE='Element' , $
      VALUE=optstr.exraystr.element(*).symbol)

  ElementButton_BASE = Widget_Base(Element_Base, UNAME='ElementButton_BASE', $
      COLUMN=1 ,/NonEXCLUSIVE,/Align_Right)

  Include_Button = Widget_Button(ElementButton_Base, UNAME='Include_Button'  $
      ,/ALIGN_Right,SENSITIVE=1 ,VALUE='Include')

  KP_LABEL = Widget_Label(Exray_TransWidget_BASE,  $
      UNAME='KP_LABEL',/ALIGN_Left,VALUE='Kelley/Pelumbo Known Transitions')

  KPTrans_Base = Widget_Base(Exray_TransWidget_BASE, UNAME='KPTrans_BASE' $
      ,frame=1,column=1)

  KPView_Button = Widget_Button(KPTrans_BASE, UNAME='KPView_Button'  $
      ,/ALIGN_Center,SENSITIVE=1 ,VALUE='View',XSIZE=80)

  KPSpec_Base = Widget_Base(KPTrans_BASE, UNAME='KPSpec_BASE' $
      ,/NonEXCLUSIVE,column=3)

  LySeries_Button = Widget_Button(KPSpec_BASE, UNAME='LySeries_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Ly Series')

  HeSeries_Button = Widget_Button(KPSpec_BASE, UNAME='HeSeries_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='He Series')

  LiSeries_Button = Widget_Button(KPSpec_BASE, UNAME='HeSeries_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Li Series')

  S3D_LABEL = Widget_Label(Exray_TransWidget_Base,  $
      UNAME='S3D_LABEL',/ALIGN_Left,VALUE='SPECT3D Calculated Transitions')

  S3DTrans_Base = Widget_Base(Exray_TransWidget_BASE, UNAME='S3DTrans_BASE' $
      ,frame=1,column=1)

  S3DView_Button = Widget_Button(S3DTrans_BASE, UNAME='S3DView_Button'  $
      ,/ALIGN_Center,SENSITIVE=1 ,VALUE='View',XSIZE=80)

  S3DSpec_Base = Widget_Base(S3DTrans_BASE, UNAME='S3DSpec_BASE' $
      ,/NonEXCLUSIVE,column=3)

  KaSeries_Button = Widget_Button(S3DSpec_BASE, UNAME='KaSeries_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='K-alpha')

  KbSeries_Button = Widget_Button(S3DSpec_BASE, UNAME='KbSeries_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='K-beta')

  KgSeries_Button = Widget_Button(S3DSpec_BASE, UNAME='KgSeries_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='K-gamma')

  Quit_BASE = Widget_Base(Exray_TransWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60 ,SCR_YSIZE=36 ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Done_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Done_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60 ,SCR_YSIZE=36 ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  transtr = {NAME: 'Transitions_Structure',$
              include:Include_Button,$
              Ly:LySeries_Button,$
              He:HeSeries_Button,$
              Li:LiSeries_Button,$
              Ka:KaSeries_Button,$
              Kb:KbSeries_Button,$
              Kg:KgSeries_Button,$
              index:long(0),$  ;the current droplist index
              whichelements:optstr.exraystr.whichelements,$ ;the elements the user wants
              whichtrans:optstr.exraystr.whichtrans,$ ;the transitions the user wants
              optstr:optstr,$
              MainWidget:MainWidget}

;************************************************************************************
;Initialize some buttons
;************************************************************************************
  if (optstr.exraystr.whichelements(0) gt 0) then widget_control,Include_BUTTON,set_button=1

  if (optstr.exraystr.element(0).Ly.lambda(0) eq 0.) then $
     widget_control,LySeries_BUTTON,Sensitive=0 $
  else if (optstr.exraystr.whichtrans(0,0) gt 0) then $
     widget_control,LySeries_BUTTON,set_button=1
  if (optstr.exraystr.element(0).He.lambda(0) eq 0.) then $
     widget_control,HeSeries_BUTTON,Sensitive=0 $
  else if (optstr.exraystr.whichtrans(0,1) gt 0) then  $
     widget_control,HeSeries_BUTTON,set_button=1
  if (optstr.exraystr.element(0).Li.lambda(0) eq 0.) then $
     widget_control,LiSeries_BUTTON,Sensitive=0 $
  else if (optstr.exraystr.whichtrans(0,2) gt 0) then $
     widget_control,LiSeries_BUTTON,set_button=1
  if (optstr.exraystr.element(0).Ka.lambda(0) eq 0.) then $
     widget_control,KaSeries_BUTTON,Sensitive=0 $
  else if (optstr.exraystr.whichtrans(0,3) gt 0) then $
     widget_control,KaSeries_BUTTON,set_button=1
  if (optstr.exraystr.element(0).Kb.lambda(0) eq 0.) then $
     widget_control,KbSeries_BUTTON,Sensitive=0 $
  else if (exraystr.whichtrans(0,4) gt 0) then $
     widget_control,KbSeries_BUTTON,set_button=1
  if (optstr.exraystr.element(0).Kg.lambda(0) eq 0.) then $
     widget_control,KgSeries_BUTTON,Sensitive=0 $
  else if (optstr.exraystr.whichtrans(0,5) gt 0) then $
     widget_control,KgSeries_BUTTON,set_button=1


 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_TransWidget_BASE

  Widget_Control, Exray_TransWidget_BASE, set_uvalue = transtr


  XManager, 'Exray_TransWidget_BASE', Exray_TransWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_TransWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_TransWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
