PRO exray_alpham, exrayptr,rot,LOS,alpham,R0m,trex

;find the xstal parameters associated with the mean ray (betam)
numxstals=(*exrayptr).numxstals
betam=(*exrayptr).film.phi - !pi
betamax=(*exrayptr).xstal(*).betamax
betamin=(*exrayptr).xstal(*).betamin
index=where((betamax gt betam) and (betamin lt betam))
if (index(0) lt 0) then index(0)=0
eccm=(*exrayptr).xstal(index(0)).ecc
R0m=(*exrayptr).xstal(index(0)).R0
hm=(*exrayptr).xstal(index(0)).h

;calculate alpham
xbm=-hm*cos(betam)/(1.-eccm*cos(betam))
ybm=hm*sin(betam)/(1.-eccm*cos(betam))
alpham=atan(ybm/(R0m+xbm))+rot

if (trex eq 2) then begin
;RT spectrometer has a fixed cross-over, set alpham to the
; appropriate rotation to put the cross-over at that spot
   alpham=asin(4.5/380.)+rot
endif

return
end