

pro Exray_EffWidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = effstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Filter_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           effstr.filtflag = 0
           widget_control,effstr.filtbase,sensitive=0
        endif else begin
           effstr.filtflag = 1
           widget_control,effstr.filtbase,sensitive=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Filter1_xover_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           effstr.xoverflag(0) = 0
        endif else begin
           effstr.xoverflag(0) = 1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Filter2_xover_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           effstr.xoverflag(1) = 0
        endif else begin
           effstr.xoverflag(1) = 1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Filter3_xover_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           effstr.xoverflag(2) = 0
        endif else begin
           effstr.xoverflag(2) = 1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='MCP_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           effstr.mcpflag = 0
           widget_control,effstr.mcpbase,sensitive=0
        endif else begin
           effstr.mcpflag = 1
           widget_control,effstr.mcpbase,sensitive=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='PC_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           effstr.pcflag = 0
           widget_control,effstr.pc,sensitive=0
        endif else begin
           effstr.pcflag = 1
           widget_control,effstr.pc,sensitive=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Angle_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           effstr.mcpangflag = 0
           widget_control,effstr.anglefield,sensitive=0
        endif else if (effstr.rayflag ne 0) then begin
           effstr.mcpangflag = 1
           widget_control,effstr.anglefield,sensitive=1
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Geo_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           effstr.geoflag = 0
           widget_control,effstr.geobase,sensitive=0
        endif else begin
          if (effstr.exraystr.plotOK ne 1) then begin
             whoops=dialog_message('There are not enough parameters set '$
                               +'to make that calculation',/Error)
             widget_control,effstr.geobutton,set_button = 0
             return
          endif
           effstr.geoflag = 1
           widget_control,effstr.geobase,sensitive=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Xstal_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           effstr.xstalflag = 0
           widget_control,effstr.xstalbase,sensitive=0
        endif else begin
          if (effstr.exraystr.plotOK ne 1) then begin
             whoops=dialog_message('There are not enough parameters set '$
                               +'to make that calculation',/Error)
             widget_control,effstr.xstalbutton,set_button = 0
             return
          endif
;          if (effstr.exraystr.convexflag eq 0) then $ ;elliptical geometry
;             whichXstal=widget_info(effstr.exraystr.widget.Xstals,/Droplist_Select) $
;          else $ ;convex geometry
;             whichXstal=widget_info(effstr.exraystr.widget.XstalC,/Droplist_Select)
;          if ((whichXstal ne 1) and (whichXstal ne 2) and (whichXstal ne 3) $
;               and (whichXstal ne 6) and (whichXstal ne 7)) then begin
;             whoops = dialog_message('There are no available reflectivities'$
;                                     +' for the selected crystal',/Error)
;          endif else begin
             effstr.xstalflag = 1
             widget_control,effstr.xstalbase,sensitive=1
;          endelse
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Average_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 1) then begin
          if (effstr.exraystr.convexflag eq 0) then $ ;elliptical geometry
             whichXstal=widget_info(effstr.exraystr.widget.Xstals,/Droplist_Select) $
          else $ ;convex geometry
             whichXstal=widget_info(effstr.exraystr.widget.XstalC,/Droplist_Select)
          if ((whichXstal ne 1) and (whichXstal ne 2) and (whichXstal ne 3) $
               and (whichXstal ne 6) and (whichXstal ne 7)) then begin
             whoops = dialog_message('There are no available reflectivities'$
                                     +' for the selected crystal',/Error)
             effstr.refflag=3
             widget_control,effstr.nonebutton,set_button = 1
          endif else begin
             effstr.refflag = 0
             widget_control,effstr.xstalrefbutton,sensitive = 1
             widget_control,effstr.xstalsavebutton,sensitive = 1
             effstr.xstalflag = 1
          endelse
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Prins_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 1) then begin
          if (effstr.exraystr.convexflag eq 0) then $ ;elliptical geometry
             whichXstal=widget_info(effstr.exraystr.widget.Xstals,/Droplist_Select) $
          else $ ;convex geometry
             whichXstal=widget_info(effstr.exraystr.widget.XstalC,/Droplist_Select)
          if ((whichXstal ne 1) and (whichXstal ne 2) and (whichXstal ne 3) $
               and (whichXstal ne 6) and (whichXstal ne 7)) then begin
             whoops = dialog_message('There are no available reflectivities'$
                                     +' for the selected crystal',/Error)
             effstr.refflag=3
             widget_control,effstr.nonebutton,set_button = 1
          endif else begin
             effstr.refflag = 1
             widget_control,effstr.xstalrefbutton,sensitive = 1
             widget_control,effstr.xstalsavebutton,sensitive = 1
             effstr.xstalflag = 1
          endelse
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Mosaic_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 1) then begin
          if (effstr.exraystr.convexflag eq 0) then $ ;elliptical geometry
             whichXstal=widget_info(effstr.exraystr.widget.Xstals,/Droplist_Select) $
          else $ ;convex geometry
             whichXstal=widget_info(effstr.exraystr.widget.XstalC,/Droplist_Select)
          if ((whichXstal ne 1) and (whichXstal ne 2) and (whichXstal ne 3) $
               and (whichXstal ne 6) and (whichXstal ne 7)) then begin
             whoops = dialog_message('There are no available reflectivities'$
                                     +' for the selected crystal',/Error)
             effstr.refflag=3
             widget_control,effstr.nonebutton,set_button = 1
          endif else begin
             effstr.refflag = 2
             widget_control,effstr.xstalrefbutton,sensitive = 1
             widget_control,effstr.xstalsavebutton,sensitive = 1
             effstr.xstalflag = 1
          endelse
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='None_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 1) then $
           effstr.xstalflag = 1
           effstr.refflag = 3
           widget_control,effstr.xstalrefbutton,sensitive = 0
           widget_control,effstr.xstalsavebutton,sensitive = 0
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='FilterTrans_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;Plot the filter transmissions
        exray_plotfilters, effstr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='FilterSave_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;Save the total filter transmission
        exray_plotfilters, effstr,/save
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='XstalRef_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;Plot the crystal reflectivities
        exray_plotref, effstr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='XstalSave_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;Plot the crystal reflectivities
        exray_plotref, effstr, /save
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Save_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        goto,jump1
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Go_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables and calculate the result
       dosave=0
       jump1: wait,0.0
       if (n_elements(dosave) eq 0) then dosave=1  ;jumped into from save
       filter=0
       filter=widget_info(effstr.filt1,/Droplist_Select)
       effstr.exraystr.wfilm.filter(0)=filter
       filter=widget_info(effstr.filt2,/Droplist_Select)
       effstr.exraystr.wfilm.filter(1)=filter
       filter=widget_info(effstr.filt3,/Droplist_Select)
       effstr.exraystr.wfilm.filter(2)=filter

       filtwidth=0.
       widget_control,effstr.thick1,get_value=filtwidth
       effstr.exraystr.wfilm.filtwidth(0)=filtwidth
       widget_control,effstr.thick2,get_value=filtwidth
       effstr.exraystr.wfilm.filtwidth(1)=filtwidth
       widget_control,effstr.thick3,get_value=filtwidth
       effstr.exraystr.wfilm.filtwidth(2)=filtwidth

       dummy=0.
       widget_control,effstr.magfield,get_value=dummy
       effstr.exraystr.wfilm.mag=dummy
       widget_control,effstr.slitfield,get_value=dummy
       effstr.exraystr.wfilm.slit=dummy
       widget_control,effstr.lineoutfield,get_value=dummy
       effstr.exraystr.wfilm.lineout=dummy

       ;pc=0
       ;pc=widget_info(effstr.pc,/Droplist_Select)
       ;effstr.exraystr.wfilm.photocath=pc
       widget_control,effstr.anglefield,get_value=dummy
       effstr.exraystr.wfilm.poreangle=dummy*!pi/180.

       units=0
       units=widget_info(effstr.units,/Droplist_Select)
       effstr.exraystr.wfilm.units=units

       effstr.exraystr.wfilm.filtflag=effstr.filtflag
       effstr.exraystr.wfilm.xoverflag=effstr.xoverflag
       effstr.exraystr.wfilm.geoflag=effstr.geoflag
       effstr.exraystr.wfilm.xstalflag=effstr.xstalflag
       effstr.exraystr.wfilm.refflag=effstr.refflag
       effstr.exraystr.wfilm.mcpflag=effstr.mcpflag
       ;effstr.exraystr.wfilm.pcflag=effstr.pcflag
       ;effstr.exraystr.wfilm.mcpangflag=effstr.mcpangflag

       widget_control,effstr.MainWidget,set_uvalue=effstr.exraystr
       ;wdelete,30
       widget_control, Event.top, /DESTROY
       exray_eff,effstr.MainWidget,save=dosave
       return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        ;wdelete,30
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = effstr


end

pro Exray_EffWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  filtermats=['none','Al','Be','Kapton','Kimfol (Polycarbonate)','Mylar','Parylene N', $
              'Polystyrene','Ta','Ti','W']

  photocathodes=['Au','MgF2','SiO2']

  Exray_EffWidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_EffWidget_BASE', Column = 1, $
      TITLE='Efficiency Conversion Options' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  FilterButton_BASE = Widget_Base(Exray_EffWidget_BASE, UNAME='FilterButton_BASE', $
      COLUMN=1,/NonExclusive)

  Filter_Button = Widget_Button(FilterButton_BASE, UNAME='Filter_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Filters')

  Filter_BASE = Widget_Base(Exray_EffWidget_BASE, UNAME='Filter_BASE', $
      COLUMN=1,Frame=1,Title='Filters')

  Filter1_BASE = Widget_Base(Filter_BASE, UNAME='Filter1_BASE',COLUMN=3)

  Filter1_DROPLIST = Widget_Droplist(Filter1_BASE,  $
      UNAME='Filter1_DROPLIST' ,SENSITIVE=1,TITLE='#1' , $
      VALUE=filtermats)

  Filter1_Field = CW_Field(Filter1_BASE,UNAME='Filter1_FIELD' $
                        ,Title='Thickness (microns)',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.filtwidth(0))
                        
  Filter1_xover_BASE = Widget_Base(Filter1_BASE, UNAME='Filter1_xover_BASE', $
      COLUMN=1,/NonExclusive)
 
  Filter1_xover_Button=Widget_Button(Filter1_xover_BASE, UNAME='Filter1_xover_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Crossover')

  Filter2_BASE = Widget_Base(Filter_BASE, UNAME='Filter2_BASE',COLUMN=3)

  Filter2_DROPLIST = Widget_Droplist(Filter2_BASE,  $
      UNAME='Filter2_DROPLIST' ,SENSITIVE=1,TITLE='#2' , $
      VALUE=filtermats)

  Filter2_Field = CW_Field(Filter2_BASE,UNAME='Filter2_FIELD' $
                        ,Title='Thickness (microns)',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.filtwidth(1))

  Filter2_xover_BASE = Widget_Base(Filter2_BASE, UNAME='Filter2_xover_BASE', $
      COLUMN=1,/NonExclusive)

  Filter2_xover_Button=Widget_Button(Filter2_xover_BASE, UNAME='Filter2_xover_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Crossover')

  Filter3_BASE = Widget_Base(Filter_BASE, UNAME='Filter3_BASE',COLUMN=3)

  Filter3_DROPLIST = Widget_Droplist(Filter3_BASE,  $
      UNAME='Filter3_DROPLIST' ,SENSITIVE=1,TITLE='#3' , $
      VALUE=filtermats)

  Filter3_Field = CW_Field(Filter3_BASE,UNAME='Filter3_FIELD' $
                        ,Title='Thickness (microns)',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.filtwidth(2))

  Filter3_xover_BASE = Widget_Base(Filter3_BASE, UNAME='Filter3_xover_BASE', $
      COLUMN=1,/NonExclusive)

  Filter3_xover_Button=Widget_Button(Filter3_xover_BASE, UNAME='Filter3_xover_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Crossover')

  FilterSave_BASE = Widget_Base(Filter_BASE, UNAME='FilterSave_BASE',COLUMN=2,/Align_Center)
  FilterTrans_Button = Widget_Button(FilterSave_BASE, UNAME='FilterTrans_Button'  $
      ,SENSITIVE=1 ,VALUE='Plot Transmission')
  FilterSave_Button = Widget_Button(FilterSave_BASE, UNAME='FilterSave_Button'  $
      ,SENSITIVE=1 ,VALUE='Save Total Transmission')

  MCPButton_BASE = Widget_Base(Exray_EffWidget_BASE, UNAME='MCPButton_BASE', $
      COLUMN=1,/NonExclusive)

  MCP_Button = Widget_Button(MCPButton_BASE, UNAME='MCP_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='MCP')

  MCP_BASE = Widget_Base(Exray_EffWidget_BASE, UNAME='MCP_BASE', $
      COLUMN=2,Frame=1,Title='Geometry')

  ;PCButton_BASE = Widget_Base(MCP_BASE, UNAME='PCButton_BASE', $
  ;    COLUMN=1,/NonExclusive)

  ;PC_Button = Widget_Button(PCButton_BASE, UNAME='PC_Button'  $
  ;    ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Photocathode QE')

  ;PC_DROPLIST = Widget_Droplist(MCP_BASE,  $
  ;    UNAME='PC_DROPLIST' ,SENSITIVE=0,TITLE='   -Material:  ' , $
  ;    VALUE=photocathodes)

  ;AngleButton_BASE = Widget_Base(MCP_BASE, UNAME='AngleButton_BASE', $
  ;    COLUMN=1,/NonExclusive)

  ;Angle_Button = Widget_Button(AngleButton_BASE, UNAME='Angle_Button'  $
  ;    ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='SiO2 Q(theta,E)')

  Angle_Field = CW_Field(MCP_BASE,UNAME='Angle_FIELD'  $
                        ,Title='Pore Angle =',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.poreangle*180./!pi)

  XstalButton_BASE = Widget_Base(Exray_EffWidget_BASE, UNAME='XstalButton_BASE', $
      COLUMN=1,/NonExclusive)

  Xstal_Button = Widget_Button(XstalButton_BASE, UNAME='Xstal_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Crystal Reflectivity and Spectrometer Geometry')

  Xstal_BASE = Widget_Base(Exray_EffWidget_BASE, UNAME='Xstal_BASE', $
      COLUMN=1,Frame=1,Title='Geometry')

  Xstal2_BASE = Widget_Base(Xstal_BASE, UNAME='XstalL_BASE',COLUMN=2)

  XstalE_BASE = Widget_Base(Xstal2_BASE, UNAME='XstalE_BASE', $
      COLUMN=1,/Exclusive)

  Prins_Button = Widget_Button(XstalE_BASE, UNAME='Prins_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Prins')

  Mosaic_Button = Widget_Button(XstalE_BASE, UNAME='Mosaic_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Mosaic')

  Average_Button = Widget_Button(XstalE_BASE, UNAME='Average_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Average')

  None_Button = Widget_Button(XstalE_BASE, UNAME='None_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='R = const.')

  XstalR_BASE = Widget_Base(Xstal2_BASE, UNAME='XstalL_BASE',COLUMN=1)

  Units_DROPLIST = Widget_Droplist(XstalR_BASE,  $
      UNAME='Units_DROPLIST' ,SENSITIVE=1,TITLE='  Data units:  ' , $
      VALUE=['photons/micron^2','photons/mm^2','photons/cm^2'])

  Units_LABEL = Widget_Label(XstalR_BASE,Value='(Output in J/cm^2/A/sr)')

  XstalSave_BASE = Widget_Base(Xstal_BASE, UNAME='XstalSave_BASE',COLUMN=2,/Align_Center)
  XstalRef_Button = Widget_Button(XstalSave_BASE, UNAME='XstalRef_Button'  $
      ,SENSITIVE=1 ,VALUE='Plot Reflectivity')
  XstalSave_Button = Widget_Button(XstalSave_BASE, UNAME='XstalSave_Button'  $
      ,SENSITIVE=1 ,VALUE='Save Selected Reflectivity')

  GeoButton_BASE = Widget_Base(Exray_EffWidget_BASE, UNAME='GeoButton_BASE', $
      COLUMN=1,/NonExclusive)

  Geo_Button = Widget_Button(GeoButton_BASE, UNAME='Geo_Button'  $
      ,/ALIGN_LEFT,SENSITIVE=1 ,VALUE='Solid Angle Correction')

  Geo_BASE = Widget_Base(Exray_EffWidget_BASE, UNAME='Geo_BASE', $
      COLUMN=1,Frame=1,Title='Geometry',/BASE_ALIGN_RIGHT)

  Mag_Field = CW_Field(Geo_BASE,UNAME='Mag_FIELD' $
                        ,Title='Magnification =',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.mag)

  Slit_Field = CW_Field(Geo_BASE,UNAME='Slit_FIELD' $
                        ,Title='Slit Width (microns) =',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.slit)

  Lineout_Field = CW_Field(Geo_BASE,UNAME='Lineout_FIELD' $
                        ,Title='Lineout Width (microns) =',/Return_Events,/float,xsize=8 $
                        ,Value=exraystr.wfilm.lineout)

  Quit_BASE = Widget_Base(Exray_EffWidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=3,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')

  Save_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Save_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=100*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Save Correction')

  Go_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Go_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Calculate')


;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  geo=widget_info(Exray_EffWidget_BASE,/Geo)

  effstr = {NAME: 'Efficiency_Structure',$
              filtbase:Filter_BASE,$
              geobase:Geo_BASE,$
              xstalbase:Xstal_BASE,$
              mcpbase:MCP_BASE,$
              filt1:Filter1_DROPLIST,$
              filt2:Filter2_DROPLIST,$
              filt3:Filter3_DROPLIST,$
              ;pc:PC_DROPLIST,$
              units:Units_DROPLIST,$
              thick1:Filter1_FIELD,$
              thick2:Filter2_FIELD,$
              thick3:Filter3_FIELD,$
              anglefield:Angle_FIELD,$
              slitfield:Slit_FIELD,$
              magfield:Mag_FIELD,$
              lineoutfield:Lineout_FIELD,$
              xstalbutton:Xstal_Button,$
              nonebutton:None_Button,$
              xstalrefbutton:XstalRef_Button,$
              xstalsavebutton:XstalSave_Button,$
              geobutton:Geo_Button,$
              filtflag:exraystr.wfilm.filtflag,$
              xoverflag:exraystr.wfilm.xoverflag,$
              xstalflag:exraystr.wfilm.xstalflag,$
              refflag:exraystr.wfilm.refflag,$
              geoflag:exraystr.wfilm.geoflag,$
              mcpflag:exraystr.wfilm.mcpflag,$
              pcflag:exraystr.wfilm.pcflag,$
              mcpangflag:exraystr.wfilm.mcpangflag,$
              rayflag:exraystr.plotOK,$
              plotflag:long(0),$
              geo:geo,$
              exraystr:exraystr,$
              MainWidget:MainWidget}

  widget_control,Filter1_DROPLIST, set_droplist_select=exraystr.wfilm.filter(0)
  widget_control,Filter2_DROPLIST, set_droplist_select=exraystr.wfilm.filter(1)
  widget_control,Filter3_DROPLIST, set_droplist_select=exraystr.wfilm.filter(2)
  ;widget_control,PC_DROPLIST, set_droplist_select=exraystr.wfilm.photocath
  widget_control,Units_DROPLIST, set_droplist_select=exraystr.wfilm.units
  ;widget_control,effstr.anglefield,sensitive=0

  if (exraystr.wfilm.filtflag eq 0) then begin
     widget_control,Filter_Button,set_button = 0
     widget_control,Filter_Base,Sensitive=0
  endif else widget_control,Filter_Button,set_button = 1
  if (exraystr.wfilm.xoverflag(0) eq 0) then begin
     widget_control,Filter1_xover_Button,set_button = 0
  endif else widget_control,Filter1_xover_Button,set_button = 1
  if (exraystr.wfilm.xoverflag(1) eq 0) then begin
     widget_control,Filter2_xover_Button,set_button = 0
  endif else widget_control,Filter2_xover_Button,set_button = 1
  if (exraystr.wfilm.xoverflag(2) eq 0) then begin
     widget_control,Filter3_xover_Button,set_button = 0
  endif else widget_control,Filter3_xover_Button,set_button = 1
  if (exraystr.wfilm.xstalflag eq 0) then begin
     widget_control,Xstal_Button,set_button = 0
     widget_control,Xstal_Base,Sensitive=0
  endif else widget_control,Xstal_Button,set_button = 1
  if (exraystr.wfilm.geoflag eq 0) then begin
     widget_control,Geo_Button,set_button = 0
     widget_control,Geo_Base,Sensitive=0
  endif else widget_control,Geo_Button,set_button = 1
  if (exraystr.wfilm.mcpflag eq 0) then begin
     widget_control,MCP_Button,set_button = 0
     widget_control,MCP_Base,Sensitive=0
  endif else begin
     widget_control,MCP_Button,set_button = 1
     if (exraystr.wfilm.pcflag eq 1) then begin
        widget_control,PC_DROPLIST,Sensitive=1
        widget_control,PC_Button,set_button = 1
     endif
     if (exraystr.wfilm.mcpangflag eq 1) then begin
        widget_control,Angle_FIELD,Sensitive=1
        ;widget_control,Angle_Button,set_button = 1
     endif
  endelse

  if (exraystr.wfilm.refflag eq 0) then widget_control,Average_Button,set_button = 1 $
  else if (exraystr.wfilm.refflag eq 1) then widget_control,Prins_Button,set_button = 1 $
  else if (exraystr.wfilm.refflag eq 2) then widget_control,Mosaic_Button,set_button = 1 $
  else if (exraystr.wfilm.refflag eq 3) then begin
     widget_control,None_Button,set_button = 1
     widget_control,XstalRef_Button,sensitive = 0
     widget_control,XstalSave_Button,sensitive = 0
  endif
  if (exraystr.convexflag eq 0) then $ ;elliptical geometry
     whichXstal=widget_info(exraystr.widget.Xstals,/Droplist_Select) $
  else $ ;convex geometry
     whichXstal=widget_info(exraystr.widget.XstalC,/Droplist_Select)
  if ((whichXstal ne 1) and (whichXstal ne 2) and (whichXstal ne 3) $
        and (whichXstal ne 6) and (whichXstal ne 7)) then begin
     widget_control,None_Button,set_button = 1
     widget_control,XstalRef_Button,sensitive = 0
     widget_control,XstalSave_Button,sensitive = 0
  endif

  if (effstr.exraystr.plotOK ne 1) then begin
     ;widget_control,Angle_Button,set_button = 0
     ;widget_control,Angle_Button,Sensitive = 0
     ;widget_control,Angle_FIELD,Sensitive = 0
     widget_control,MCP_Button,Sensitive = 0
     widget_control,MCP_Base,Sensitive = 0
     effstr.mcpangflag=0
     widget_control,Geo_Button,set_button = 0
     widget_control,Geo_Base,Sensitive=0
     effstr.geoflag=0
     widget_control,Xstal_Button,set_button = 0
     widget_control,Xstal_Base,Sensitive=0
     effstr.xstalflag=0
  endif

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_EffWidget_BASE

  Widget_Control, Exray_EffWidget_BASE, set_uvalue = effstr


  XManager, 'Exray_EffWidget_BASE', Exray_EffWidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro Exray_EffWidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_EffWidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
