PRO Exray_GetConfig, exraystr

if (exraystr.convexflag ne 1) then begin
   xstalid=exraystr.widget.xstals
   configid=exraystr.widget.configs
   ;figure out the configuration
   R0=exraystr.wxstal(0).R0
   LOS=exraystr.wLOS
;   case exraystr.wxstal(0).h of
;   9.100: if (round(R0) eq 406 and round(LOS) eq 391) then $
;               widget_control,configid,set_droplist_select=0 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   3.500: if (round(R0) eq 414 and round(LOS) eq 391) then $
;               widget_control,configid,set_droplist_select=1 $
;          else if (round(R0) eq 410 and round(LOS) eq 391) then $
;               widget_control,configid,set_droplist_select=3 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   3.000: if (round(R0) eq 410 and round(LOS) eq 391) then $
;               widget_control,configid,set_droplist_select=2 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   5.073: if (round(R0) eq 406 and round(LOS) eq 391) then $
;               widget_control,configid,set_droplist_select=4 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   9.000: if (round(R0) eq 260 and round(LOS) eq 245) then $
;               widget_control,configid,set_droplist_select=5 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   3.105: if (round(R0) eq 264 and round(LOS) eq 245) then $
;               widget_control,configid,set_droplist_select=6 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   5.000: if (round(R0) eq 260 and round(LOS) eq 245) then $
;               widget_control,configid,set_droplist_select=7 $
;          else if (round(R0) eq 288 and round(LOS) eq 273) then $
;               widget_control,configid,set_droplist_select=10 $
;          else if (round(R0) eq 410 and round(LOS) eq 391) then $
;               widget_control,configid,set_droplist_select=11 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   4.000: if (round(R0) eq 292 and round(LOS) eq 245) then $
;               widget_control,configid,set_droplist_select=9 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   7.000: if (round(R0) eq 410 and round(LOS) eq 391) then $
;               widget_control,configid,set_droplist_select=8 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   2.000: if (round(R0) eq 180 and round(LOS) eq 168) then $
;               widget_control,configid,set_droplist_select=13 $
;          else if (round(R0) eq 410 and round(LOS) eq 398) then $
;               widget_control,configid,set_droplist_select=15 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   6.000: if (round(R0) eq 180 and round(LOS) eq 168) then $
;               widget_control,configid,set_droplist_select=14 $
;          else if (round(R0) eq 410 and round(LOS) eq 398) then $
;               widget_control,configid,set_droplist_select=16 $
;          else $
;               widget_control,configid,set_droplist_select=18
;   else: widget_control,configid,set_droplist_select=18
;   endcase
   case exraystr.wxstal(0).h of
   3.000: if (round(R0) eq 410 and round(LOS) eq 391) then $ ;TREX-t
               widget_control,configid,set_droplist_select=0 $
           else $
               widget_control,configid,set_droplist_select=5              
   3.500: if (round(R0) eq 410 and round(LOS) eq 391) then $ ;TREX-u
               widget_control,configid,set_droplist_select=1 $
          else $
               widget_control,configid,set_droplist_select=5
   5.000: if (round(R0) eq 410 and round(LOS) eq 391) then $ ;TREX-hh
               widget_control,configid,set_droplist_select=2 $
          else $
               widget_control,configid,set_droplist_select=5
   2.000: if (round(R0) eq 180 and round(LOS) eq 168) then $ ;PODD-H2R180
               widget_control,configid,set_droplist_select=3 $
          else $
               widget_control,configid,set_droplist_select=5
   10.000: if (round(R0) eq 180 and round(LOS) eq 168) then $ ;PODD-H10R180
               widget_control,configid,set_droplist_select=4 $
          else $
               widget_control,configid,set_droplist_select=5
   endcase
endif else begin
   wedgeid=exraystr.widget.wedge
   if (exraystr.wfilm.circleflag eq 1) then $
      widget_control,wedgeid,set_droplist_select=10 $
   else begin
      case exraystr.wfilm.phi*180./!pi of
      28.: widget_control,wedgeid,set_droplist_select=0
      30.: widget_control,wedgeid,set_droplist_select=1
      39.: widget_control,wedgeid,set_droplist_select=2
      42.: widget_control,wedgeid,set_droplist_select=3
      54.: widget_control,wedgeid,set_droplist_select=4
      64.: widget_control,wedgeid,set_droplist_select=5
      70.: widget_control,wedgeid,set_droplist_select=6
      76.: widget_control,wedgeid,set_droplist_select=7
      80.: widget_control,wedgeid,set_droplist_select=8
      90.: widget_control,wedgeid,set_droplist_select=9
      else: widget_control,wedgeid,set_droplist_select=11
      endcase
   endelse
   xstalid=exraystr.widget.xstalC
endelse

;figure out the crystal being used
twodround=round(exraystr.wxstal(0).twod*100.)
case twodround of
1064: widget_control,xstalid,set_droplist_select=0
2663: widget_control,xstalid,set_droplist_select=1
1984: widget_control,xstalid,set_droplist_select=2
874:  widget_control,xstalid,set_droplist_select=3
851: widget_control,xstalid,set_droplist_select=4
669: widget_control,xstalid,set_droplist_select=5
285:  widget_control,xstalid,set_droplist_select=6
403:  widget_control,xstalid,set_droplist_select=7
400:  widget_control,xstalid,set_droplist_select=8
else:   widget_control,xstalid,set_droplist_select=9
endcase

return
end