

pro Exray_robsave_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = robsavestr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='robsave1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           robsavestr.robset(0)=0
        endif else begin
           robsavestr.robset(0)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='robsave2_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           robsavestr.robset(1)=0
        endif else begin
           robsavestr.robset(1)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='robsave3_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           robsavestr.robset(2)=0
        endif else begin
           robsavestr.robset(2)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='robsave4_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           robsavestr.robset(3)=0
        endif else begin
           robsavestr.robset(3)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='robsave5_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           robsavestr.robset(4)=0
        endif else begin
           robsavestr.robset(4)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        tmp=double(0.)
        robsavestr.exraystr.robset=robsavestr.robset
        filebase=''
        filebase=dialog_pickfile(title='Select Location and Base Filename for ROBFIT segments',/write,filter='(.*)')
        ;filebase=strsplit(filebase,'.',/extract)
        ;filebase=filebase(0)
        if (filebase eq '') then begin
           ;quit without saving anything
           ;widget_control, Event.top, /DESTROY
           return
        endif
        for i=0,4 do begin
            ;get the limits
          widget_control,robsavestr.x1(i),get_value=tmp
          robsavestr.exraystr.roblims(2*i) = tmp
          widget_control,robsavestr.x2(i),get_value=tmp
          robsavestr.exraystr.roblims(2*i+1) = tmp
          if (robsavestr.robset(i) eq 1) then begin
             if (robsavestr.exraystr.plotflag eq 4) then begin
               xfr,robsavestr.exraystr.scaledwdf(robsavestr.exraystr.activedata),61
             endif else begin
               xfr,robsavestr.exraystr.datawdf(robsavestr.exraystr.activedata),61
             endelse
             lim,61,robsavestr.exraystr.roblims(2*i),robsavestr.exraystr.roblims(2*i+1)
             w2i,x,y,61
             wufo,x,y/1.e6,file=filebase+'_'+strtrim(string(i+1),2)+'.ufo'
          endif
        endfor
        Widget_Control, robsavestr.MainWidget, set_uvalue = robsavestr.exraystr
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = robsavestr


end

pro Exray_robsave_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  numrobsave=5

  Exray_robsave_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_robsave_BASE' ,XOFFSET=5 ,YOFFSET=5,COLUMN=5 $
      ,TITLE='ROBFIT Save' ,SPACE=3 ,XPAD=3 ,YPAD=3)


;***********************************************************************************
;robsave 1

  robsave1_BASE = Widget_Base(Exray_robsave_BASE, UNAME='robsave1_BASE'  $
      ,COLUMN=1)

  robsave1Button_BASE = Widget_Base(robsave1_BASE, UNAME='robsave1Button_BASE'  $
      ,COLUMN=1,/Nonexclusive)

  robsave1_Button = Widget_Button(robsave1Button_BASE, UNAME='robsave1_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Segment 1')

  Value1_LABEL = Widget_Label(robsave1_BASE,  $
      UNAME='Value1_LABEL' ,/ALIGN_LEFT,VALUE='Limits')

  X1_Field = CW_Field(robsave1_BASE,UNAME='X1_FIELD' $
                        ,Title='X1 = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.roblims(0)])

  Y1_Field = CW_Field(robsave1_BASE,UNAME='Y1_FIELD' $
                        ,Title='X2 = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.roblims(1)])


;***********************************************************************************
;robsave 2

  robsave2_BASE = Widget_Base(Exray_robsave_BASE, UNAME='robsave2_BASE'  $
      ,COLUMN=1)

  robsave2Button_BASE = Widget_Base(robsave2_BASE, UNAME='robsave2Button_BASE'  $
      ,COLUMN=1,/Nonexclusive)

  robsave2_Button = Widget_Button(robsave2Button_BASE, UNAME='robsave2_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Segment 2')

  Value2_LABEL = Widget_Label(robsave2_BASE,  $
      UNAME='Value2_LABEL' ,/ALIGN_LEFT,VALUE='Limits')

  X2_Field = CW_Field(robsave2_BASE,UNAME='X2_FIELD' $
                        ,Title='X1 = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.roblims(2)])

  Y2_Field = CW_Field(robsave2_BASE,UNAME='Y2_FIELD' $
                        ,Title='X2 = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.roblims(3)])

;***********************************************************************************
;robsave 3

  robsave3_BASE = Widget_Base(Exray_robsave_BASE, UNAME='robsave3_BASE'  $
      ,COLUMN=1)

  robsave3Button_BASE = Widget_Base(robsave3_BASE, UNAME='robsave3Button_BASE'  $
      ,COLUMN=1,/Nonexclusive)

  robsave3_Button = Widget_Button(robsave3Button_BASE, UNAME='robsave3_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Segment 3')

  Value3_LABEL = Widget_Label(robsave3_BASE,  $
      UNAME='Value3_LABEL' ,/ALIGN_LEFT,VALUE='Limits')

  X3_Field = CW_Field(robsave3_BASE,UNAME='X3_FIELD' $
                        ,Title='X1 = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.roblims(4)])

  Y3_Field = CW_Field(robsave3_BASE,UNAME='Y3_FIELD' $
                        ,Title='X2 = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.roblims(5)])

;***********************************************************************************
;robsave 4

  robsave4_BASE = Widget_Base(Exray_robsave_BASE, UNAME='robsave4_BASE'  $
      ,COLUMN=1)

  robsave4Button_BASE = Widget_Base(robsave4_BASE, UNAME='robsave4Button_BASE'  $
      ,COLUMN=1,/Nonexclusive)

  robsave4_Button = Widget_Button(robsave4Button_BASE, UNAME='robsave4_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Segment 4')

  Value4_LABEL = Widget_Label(robsave4_BASE,  $
      UNAME='Value4_LABEL' ,/ALIGN_LEFT,VALUE='Limits')

  X4_Field = CW_Field(robsave4_BASE,UNAME='X4_FIELD' $
                        ,Title='X1 = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.roblims(6)])

  Y4_Field = CW_Field(robsave4_BASE,UNAME='Y4_FIELD' $
                        ,Title='X2 = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.roblims(7)])

;***********************************************************************************
;robsave 5

  robsave5_BASE = Widget_Base(Exray_robsave_BASE, UNAME='robsave5_BASE'  $
      ,COLUMN=1)

  robsave5Button_BASE = Widget_Base(robsave5_BASE, UNAME='robsave5Button_BASE'  $
      ,COLUMN=1,/Nonexclusive)

  robsave5_Button = Widget_Button(robsave5Button_BASE, UNAME='robsave5_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Segment 5')

  Value5_LABEL = Widget_Label(robsave5_BASE,  $
      UNAME='Value5_LABEL' ,/ALIGN_LEFT,VALUE='Limits')

  X5_Field = CW_Field(robsave5_BASE,UNAME='X5_FIELD' $
                        ,Title='X1 = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.roblims(8)])

  Y5_Field = CW_Field(robsave5_BASE,UNAME='Y5_FIELD' $
                        ,Title='X2 = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.roblims(9)])


  Quit_BASE = Widget_Base(robsave5_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Save')


;************************************************************************************
;Set the appropriate values and buttons
;************************************************************************************
if exraystr.robset(0) gt 0 then begin
   Widget_Control, robsave1_Button,SET_BUTTON = 1
endif
if exraystr.robset(1) gt 0 then begin
   Widget_Control, robsave2_Button,SET_BUTTON = 1
endif
if exraystr.robset(2) gt 0 then begin
   Widget_Control, robsave3_Button,SET_BUTTON = 1
endif
if exraystr.robset(3) gt 0 then begin
   Widget_Control, robsave4_Button,SET_BUTTON = 1
endif
if exraystr.robset(4) gt 0 then begin
   Widget_Control, robsave5_Button,SET_BUTTON = 1
endif

;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  robsavestr = {NAME: 'Group_Structure',$
              x1:[X1_FIELD,X2_FIELD,X3_FIELD,X4_FIELD,X5_FIELD], $
              x2:[Y1_FIELD,Y2_FIELD,Y3_FIELD,Y4_FIELD,Y5_FIELD], $
              robset:lonarr(numrobsave),$ ;A flag to determine if the robsave is set
              exraystr:exraystr,$
              MainWidget:MainWidget}

  robsavestr.robset(*)=exraystr.robset(*)

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_robsave_BASE

  Widget_Control, Exray_robsave_BASE, set_uvalue = robsavestr


  XManager, 'Exray_robsave_BASE', Exray_robsave_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_robsave, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_robsave_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end