

pro Exray_source_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = sourcestr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='Source1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           sourcestr.sorset(1)=0
        endif else begin
           sourcestr.sorset(1)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Source2_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           sourcestr.sorset(2)=0
        endif else begin
           sourcestr.sorset(2)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Source3_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           sourcestr.sorset(3)=0
        endif else begin
           sourcestr.sorset(3)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Source4_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           sourcestr.sorset(4)=0
        endif else begin
           sourcestr.sorset(4)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Source5_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           sourcestr.sorset(5)=0
        endif else begin
           sourcestr.sorset(5)=1
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        numsource=sourcestr.exraystr.wnumsource
        tmp=double(0.)
        flag = 0
        for i=1,numsource-1 do begin
          if (sourcestr.sorset(i) gt 0) then begin
            ;If the source is specified, then save the values
             widget_control, sourcestr.exraystr.widget.AtXY,SET_BUTTON = 1
             widget_control, sourcestr.exraystr.widget.AtXYc,SET_BUTTON = 1
             flag = 1
             sourcestr.exraystr.sorset(i) = 1
             widget_control,sourcestr.x(i-1),get_value=tmp
             sourcestr.exraystr.wsource(i).a = -abs(tmp)
             widget_control,sourcestr.y(i-1),get_value=tmp
             sourcestr.exraystr.wsource(i).b = tmp
          endif else begin
             sourcestr.exraystr.sorset(i) = 0
             sourcestr.exraystr.wsource(i).a = 0.
             sourcestr.exraystr.wsource(i).b = 0.
          endelse
        endfor
        if flag eq 0 then $
           widget_control, sourcestr.exraystr.widget.AtXY,SET_BUTTON = 0
        Widget_Control, sourcestr.MainWidget, set_uvalue = sourcestr.exraystr
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        numsource=sourcestr.exraystr.wnumsource
        flag=0
        for i=1,numsource-1 do if sourcestr.sorset(i) gt 0 then flag = 1
        if flag eq 0 then begin
           widget_control, sourcestr.exraystr.widget.AtXY,SET_BUTTON = 0
           widget_control, sourcestr.exraystr.widget.AtXYc,SET_BUTTON = 0
        endif
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = sourcestr


end

pro Exray_Source_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  numsource=exraystr.wnumsource
  Initarr=dblarr(numsource,2)
  for i=0,numsource-1 do begin
    Initarr(i,0)=exraystr.wsource(i).a
    Initarr(i,1)=exraystr.wsource(i).b
  endfor


  Exray_Source_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_Source_BASE' ,XOFFSET=5 ,YOFFSET=5,COLUMN=5 $
      ,TITLE='Source Definitions' ,SPACE=3 ,XPAD=3 ,YPAD=3)


;***********************************************************************************
;Source 1

  Source1_BASE = Widget_Base(Exray_Source_BASE, UNAME='Source1_BASE'  $
      ,COLUMN=1)

  Source1Button_BASE = Widget_Base(Source1_BASE, UNAME='Source1Button_BASE'  $
      ,COLUMN=1,/Nonexclusive)

  Source1_Button = Widget_Button(Source1Button_BASE, UNAME='Source1_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Source 1')

  Value1_LABEL = Widget_Label(Source1_BASE,  $
      UNAME='Value1_LABEL' ,/ALIGN_LEFT,VALUE='Coordinates')

  X1_Field = CW_Field(Source1_BASE,UNAME='X1_FIELD' $
                        ,Title='X = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(1).a])

  Y1_Field = CW_Field(Source1_BASE,UNAME='Y1_FIELD' $
                        ,Title='Y = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(1).b])


;***********************************************************************************
;Source 2

  Source2_BASE = Widget_Base(Exray_Source_BASE, UNAME='Source2_BASE'  $
      ,COLUMN=1)

  Source2Button_BASE = Widget_Base(Source2_BASE, UNAME='Source2Button_BASE'  $
      ,COLUMN=1,/Nonexclusive)

  Source2_Button = Widget_Button(Source2Button_BASE, UNAME='Source2_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Source 2')

  Value2_LABEL = Widget_Label(Source2_BASE,  $
      UNAME='Value2_LABEL' ,/ALIGN_LEFT,VALUE='Coordinates')

  X2_Field = CW_Field(Source2_BASE,UNAME='X2_FIELD' $
                        ,Title='X = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(2).a])

  Y2_Field = CW_Field(Source2_BASE,UNAME='Y2_FIELD' $
                        ,Title='Y = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(2).b])

;***********************************************************************************
;Source 3

  Source3_BASE = Widget_Base(Exray_Source_BASE, UNAME='Source3_BASE'  $
      ,COLUMN=1)

  Source3Button_BASE = Widget_Base(Source3_BASE, UNAME='Source3Button_BASE'  $
      ,COLUMN=1,/Nonexclusive)

  Source3_Button = Widget_Button(Source3Button_BASE, UNAME='Source3_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Source 3')

  Value3_LABEL = Widget_Label(Source3_BASE,  $
      UNAME='Value3_LABEL' ,/ALIGN_LEFT,VALUE='Coordinates')

  X3_Field = CW_Field(Source3_BASE,UNAME='X3_FIELD' $
                        ,Title='X = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(3).a])

  Y3_Field = CW_Field(Source3_BASE,UNAME='Y3_FIELD' $
                        ,Title='Y = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(3).b])

;***********************************************************************************
;Source 4

  Source4_BASE = Widget_Base(Exray_Source_BASE, UNAME='Source4_BASE'  $
      ,COLUMN=1)

  Source4Button_BASE = Widget_Base(Source4_BASE, UNAME='Source4Button_BASE'  $
      ,COLUMN=1,/Nonexclusive)

  Source4_Button = Widget_Button(Source4Button_BASE, UNAME='Source4_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Source 4')

  Value4_LABEL = Widget_Label(Source4_BASE,  $
      UNAME='Value4_LABEL' ,/ALIGN_LEFT,VALUE='Coordinates')

  X4_Field = CW_Field(Source4_BASE,UNAME='X4_FIELD' $
                        ,Title='X = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(4).a])

  Y4_Field = CW_Field(Source4_BASE,UNAME='Y4_FIELD' $
                        ,Title='Y = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(4).b])

;***********************************************************************************
;Source 5

  Source5_BASE = Widget_Base(Exray_Source_BASE, UNAME='Source5_BASE'  $
      ,COLUMN=1)

  Source5Button_BASE = Widget_Base(Source5_BASE, UNAME='Source5Button_BASE'  $
      ,COLUMN=1,/Nonexclusive)

  Source5_Button = Widget_Button(Source5Button_BASE, UNAME='Source5_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Source 5')

  Value5_LABEL = Widget_Label(Source5_BASE,  $
      UNAME='Value5_LABEL' ,/ALIGN_LEFT,VALUE='Coordinates')

  X5_Field = CW_Field(Source5_BASE,UNAME='X5_FIELD' $
                        ,Title='X = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(5).a])

  Y5_Field = CW_Field(Source5_BASE,UNAME='Y5_FIELD' $
                        ,Title='Y = ',/Return_Events,/float,xsize=exraystr.formats.fieldsize $
                        ,Value=[exraystr.wsource(5).b])


  Quit_BASE = Widget_Base(Source5_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')


;************************************************************************************
;Set the appropriate values and buttons
;************************************************************************************
if exraystr.sorset(1) gt 0 then begin
   Widget_Control, Source1_Button,SET_BUTTON = 1
endif
if exraystr.sorset(2) gt 0 then begin
   Widget_Control, Source2_Button,SET_BUTTON = 1
endif
if exraystr.sorset(3) gt 0 then begin
   Widget_Control, Source3_Button,SET_BUTTON = 1
endif
if exraystr.sorset(4) gt 0 then begin
   Widget_Control, Source4_Button,SET_BUTTON = 1
endif
if exraystr.sorset(5) gt 0 then begin
   Widget_Control, Source5_Button,SET_BUTTON = 1
endif

;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  sourcestr = {NAME: 'Group_Structure',$
              x:[X1_FIELD,X2_FIELD,X3_FIELD,X4_FIELD,X5_FIELD], $
              y:[Y1_FIELD,Y2_FIELD,Y3_FIELD,Y4_FIELD,Y5_FIELD], $
              sorset:lonarr(numsource),$ ;A flag to determine if the source is set
              exraystr:exraystr,$
              MainWidget:MainWidget}

  sourcestr.sorset(*)=exraystr.sorset(*)

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_Source_BASE

  Widget_Control, Exray_Source_BASE, set_uvalue = sourcestr


  XManager, 'Exray_Source_BASE', Exray_Source_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_source, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_Source_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end