PRO exray_xstal, exraystr,$
   adp=adp,kap=kap,mica=mica,pet=pet,quartz1010=quartz1010, quartz1011=quartz1011,$
   lif220=lif220,lif200=lif200,ge220=ge220,new=new

if keyword_set(adp) then begin
   exraystr.wxstal(0).twod  = 10.64
endif else if keyword_set(kap) then begin
   exraystr.wxstal(0).twod  = 26.63
endif else if keyword_set(mica) then begin
   exraystr.wxstal(0).twod  = 19.84
endif else if keyword_set(pet) then begin
   exraystr.wxstal(0).twod  = 8.742
endif else if keyword_set(quartz1010) then begin
   exraystr.wxstal(0).twod  = 8.5096
endif else if keyword_set(quartz1011) then begin
   exraystr.wxstal(0).twod  = 6.6862
endif else if keyword_set(lif220) then begin
   exraystr.wxstal(0).twod  = 2.848
endif else if keyword_set(lif200) then begin
   exraystr.wxstal(0).twod  = 4.026
endif else if keyword_set(ge220) then begin
   exraystr.wxstal(0).twod  = 4.000
endif



;check to see if all crystal parameters are valid
if (exraystr.wxstal(0).h ne 0.) and (exraystr.wxstal(0).R0 ne 0.) $
   and (exraystr.wxstal(0).betamin ne 0.) and (exraystr.wxstal(0).betamin ne 0.) then $
   exraystr.xstalset(0)=1 $
else exraystr.xstalset(0)=0

if keyword_set(new) then begin
   exraystr.wxstal(0).twod  = 0.
   exraystr.xstalset(0) = 0
endif

return
end