pro exray_convex_betacalc,convexptr,whichxstal,whichsource,whichorder,whichlambda,limit

  a=(*convexptr).source(whichsource).a(whichxstal)
  b=(*convexptr).source(whichsource).b(whichxstal)
  theta=(*convexptr).xstal(whichxstal).theta(whichsource,whichorder,whichlambda)
  rc=(*convexptr).xstal(whichxstal).rc
  rc0=(*convexptr).xstal(0).rc
  chi=(*convexptr).xstal(whichxstal).chi
  chi0=(*convexptr).xstal(0).chi
  p=(*convexptr).xstal(0).p
  delta_r=rc-rc0
  delta_chi=chi-chi0

; **************************************************************
; this part calculates where the ray strikes the crystal.

psi=atan(b/abs(a))
omega=asin(rc*sin(!pi/2.-theta)/sqrt(a^2+b^2))
;***ADDED '+p' on 12/7/2009 to properly account for diffraction of rotated lattice
phi=!pi/2.-theta-omega+p
xc=-rc*cos(phi+psi)
yc=rc*sin(phi+psi)
;***ADDED '-p' on 12/7/2009 to properly account for diffraction of rotated lattice
beta=!pi/2.+psi+phi-theta-p

  ;***************************************************************
  ; Save the final solution in xc, yc, and beta
  ;***************************************************************

(*convexptr).xstal(whichxstal).xc(whichsource,whichorder,whichlambda)=xc
(*convexptr).xstal(whichxstal).yc(whichsource,whichorder,whichlambda)=yc
(*convexptr).xstal(whichxstal).beta(whichorder,whichlambda)=beta

return
end
