PRO exray_config, exraystr, wWidget,initialize=initialize,$
   dds=dds,xs=xs,ts=ts,dde=dde,ss=ss,us=us,ve=ve,xe=xe,$
   ee=ee,ff=ff,gg=gg,hh=hh,RT2=RT2,RT3=RT3,RT4=RT4,RT5=RT5,RT6=RT6,$
   h2R180=h2R180,h6R180=h6R180,h2R410=h2R410,h6R410=h6R410,new=new

if keyword_set(initialize) then begin
   exraystr.wxstal(0).h  = 9.1
   exraystr.wxstal(0).R0 = 405.96
   exraystr.wxstal(0).betamin = 78.0*!pi/180.
   exraystr.wxstal(0).betamax = 125.0*!pi/180.
   exraystr.wfilm.rf = 7.400
   exraystr.wfilm.phi = 279.3704*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 153.937*2.54
   exraystr.LOSFlag=0
endif else if keyword_set(dds) then begin
   exraystr.wxstal(0).h  = 9.1
   exraystr.wxstal(0).R0 = 405.96
   exraystr.wxstal(0).betamin = 78.0*!pi/180.
   exraystr.wxstal(0).betamax = 125.0*!pi/180.
   exraystr.wfilm.rf = 7.400
   exraystr.wfilm.phi = 279.3704*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 153.937*2.54
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=0
endif else if keyword_set(xs) then begin
   exraystr.wxstal(0).h  = 5.073
   exraystr.wxstal(0).R0 = 405.95
   exraystr.wxstal(0).betamin = 50.*!pi/180.
   exraystr.wxstal(0).betamax = 90.*!pi/180.
   exraystr.wfilm.rf = 7.63
   exraystr.wfilm.phi = 247.53*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 153.937*2.54
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=0
endif else if keyword_set(ts) then begin
   exraystr.wxstal(0).h  = 3.0
   exraystr.wxstal(0).R0 = 410.
   exraystr.wxstal(0).betamin = 34.7537*!pi/180.
   exraystr.wxstal(0).betamax = 60.9572*!pi/180.
   exraystr.wfilm.rf = 8.5924
   exraystr.wfilm.phi = 227.86*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 153.937*2.54
   exraystr.wrot = 0.0893*!pi/180.
      widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=0
endif else if keyword_set(dde) then begin
   exraystr.wxstal(0).h  = 9.0
   exraystr.wxstal(0).R0 = 260.0
   exraystr.wxstal(0).betamin = 78.0*!pi/180.
   exraystr.wxstal(0).betamax = 125.0*!pi/180.
   exraystr.wfilm.rf = 7.386
   exraystr.wfilm.phi = 278.75*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 96.4567*2.54
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=1
endif else if keyword_set(ss) then begin
   exraystr.wxstal(0).h  = 3.5
   exraystr.wxstal(0).R0 = 414.
   exraystr.wxstal(0).betamin = 28.4*!pi/180.
   exraystr.wxstal(0).betamax = 47.0*!pi/180.
   exraystr.wfilm.rf = 15.277
   exraystr.wfilm.phi = 217.263*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 153.937*2.54
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=0
endif else if keyword_set(us) then begin
   exraystr.wxstal(0).h  = 3.5
   exraystr.wxstal(0).R0 = 410.0
   exraystr.wxstal(0).betamin = 38.0*!pi/180.
   exraystr.wxstal(0).betamax = 78.0*!pi/180.
   exraystr.wfilm.rf = 7.83163
   exraystr.wfilm.phi = 234.858*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 153.937*2.54
   exraystr.wrot = 0.079*!pi/180.
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=0
endif else if keyword_set(ve) then begin
   exraystr.wxstal(0).h  = 3.105
   exraystr.wxstal(0).R0 = 264.045
   exraystr.wxstal(0).betamin = 33.0*!pi/180.
   exraystr.wxstal(0).betamax = 68.0*!pi/180.
   exraystr.wfilm.rf = 8.7624
   exraystr.wfilm.phi = 227.260*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 96.4567*2.54
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=1
endif else if keyword_set(xe) then begin
   exraystr.wxstal(0).h  = 5.0
   exraystr.wxstal(0).R0 = 260.
   exraystr.wxstal(0).betamin = 50.0*!pi/180.
   exraystr.wxstal(0).betamax = 90.0*!pi/180.
   exraystr.wfilm.rf = 7.630
   exraystr.wfilm.phi = 246.933*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 96.4567*2.54
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=1
endif else if keyword_set(ee) then begin
   exraystr.wxstal(0).h  = 7.0
   exraystr.wxstal(0).R0 = 288.
   exraystr.wxstal(0).betamin = 69.647*!pi/180.
   exraystr.wxstal(0).betamax = 100.519*!pi/180.
   exraystr.wfilm.rf = 7.242
   exraystr.wfilm.phi = 268.448*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 153.937*2.54
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=0
endif else if keyword_set(ff) then begin
   exraystr.wxstal(0).h  = 4.0
   exraystr.wxstal(0).R0 = 291.84
   exraystr.wxstal(0).betamin = 45.533*!pi/180.
   exraystr.wxstal(0).betamax = 76.195*!pi/180.
   exraystr.wfilm.rf = 7.294
   exraystr.wfilm.phi = 242.265*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 96.4567*2.54
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=1
endif else if keyword_set(gg) then begin
   exraystr.wxstal(0).h  = 5.0
   exraystr.wxstal(0).R0 = 288.0
   exraystr.wxstal(0).betamin = 65.35*!pi/180.
   exraystr.wxstal(0).betamax = 108.65*!pi/180.
   exraystr.wfilm.rf = 5.038
   exraystr.wfilm.phi = 267.0*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 272.8
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=1
endif else if keyword_set(hh) then begin
   exraystr.wxstal(0).h  = 5.0
   exraystr.wxstal(0).R0 = 410.0
   exraystr.wxstal(0).betamin = 55.68*!pi/180.
   exraystr.wxstal(0).betamax = 100.82*!pi/180.
   exraystr.wfilm.rf = 6.31904
   exraystr.wfilm.phi = 256.321*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 391.
   exraystr.wrot = 0.06*!pi/180.
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.LOSFlag=1
endif else if keyword_set(h2R180) then begin
   exraystr.wxstal(0).h  = 2.0
   exraystr.wxstal(0).R0 = 180.
   exraystr.wxstal(0).betamin = 33.0*!pi/180.
   exraystr.wxstal(0).betamax = 70.0*!pi/180.
   exraystr.wfilm.rf = 7.0
   exraystr.wLOS = 167.945
   exraystr.wrot = 1.2315*!pi/180.
   exraystr.LOSFlag=3
   exraystr.wfilm.phi = 230.5*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.3
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
endif else if keyword_set(h6R180) then begin
   exraystr.wxstal(0).h  = 6.0
   exraystr.wxstal(0).R0 = 180.
   exraystr.wxstal(0).betamin = 71.0*!pi/180.
   exraystr.wxstal(0).betamax = 128.0*!pi/180.
   exraystr.wfilm.rf = 5.0
   exraystr.wLOS = 167.945
   exraystr.wrot = 1.2315*!pi/180.
   exraystr.LOSFlag=3
   exraystr.wfilm.phi = 274.0*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.3
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
endif else if keyword_set(h2R410) then begin
   exraystr.wxstal(0).h  = 2.0
   exraystr.wxstal(0).R0 = 410.
   exraystr.wxstal(0).betamin = 33.0*!pi/180.
   exraystr.wxstal(0).betamax = 70.0*!pi/180.
   exraystr.wfilm.rf = 7.0
   exraystr.wLOS = 398.0
   exraystr.wrot = 0.16*!pi/180.
   exraystr.LOSFlag=3
   exraystr.wfilm.phi = 231.5*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.3
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
endif else if keyword_set(h6R410) then begin
   exraystr.wxstal(0).h  = 6.0
   exraystr.wxstal(0).R0 = 410.
   exraystr.wxstal(0).betamin = 71.0*!pi/180.
   exraystr.wxstal(0).betamax = 128.0*!pi/180.
   exraystr.wfilm.rf = 5.0
   exraystr.wLOS = 398.0
   exraystr.wrot = 0.16*!pi/180.
   exraystr.LOSFlag=3
   exraystr.wfilm.phi = 275.0*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.3
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
endif



widget_control,exraystr.widget.fspecific,SET_BUTTON=1
widget_control,exraystr.widget.JLine,SET_BUTTON=0
widget_control,exraystr.widget.JLocus,SET_BUTTON=0
exraystr.wfilm.JFlag=0

if keyword_set(RT2) then begin
   exraystr.wxstal(0).h  = 2.0
   exraystr.wxstal(0).R0 = 380.
   exraystr.wxstal(0).betamin = 33.0*!pi/180.
   exraystr.wxstal(0).betamax = 70.0*!pi/180.
   exraystr.wfilm.rf = -1.
   exraystr.wLOS = 368.0
   exraystr.wrot = 0.2*!pi/180.
   exraystr.LOSFlag=3
   widget_control,exraystr.widget.fspecific,SET_BUTTON=0
   widget_control,exraystr.widget.JLine,SET_BUTTON=0
   widget_control,exraystr.widget.JLocus,SET_BUTTON=1
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:1 }
   exraystr.wfilm.JFlag=2
endif else if keyword_set(RT3) then begin
   exraystr.wxstal(0).h  = 3.0
   exraystr.wxstal(0).R0 = 380.
   exraystr.wxstal(0).betamin = 39.0*!pi/180.
   exraystr.wxstal(0).betamax = 91.0*!pi/180.
   exraystr.wfilm.rf = -1.
   exraystr.wLOS = 368.0
   exraystr.wrot = 0.2*!pi/180.
   exraystr.LOSFlag=3
   widget_control,exraystr.widget.fspecific,SET_BUTTON=0
   widget_control,exraystr.widget.JLine,SET_BUTTON=0
   widget_control,exraystr.widget.JLocus,SET_BUTTON=1
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:1 }
   exraystr.wfilm.JFlag=2
endif else if keyword_set(RT4) then begin
   exraystr.wxstal(0).h  = 4.0
   exraystr.wxstal(0).R0 = 380.
   exraystr.wxstal(0).betamin = 50.0*!pi/180.
   exraystr.wxstal(0).betamax = 109.0*!pi/180.
   exraystr.wfilm.rf = -1.
   exraystr.wLOS = 368.0
   exraystr.wrot = 0.2*!pi/180.
   exraystr.LOSFlag=3
   widget_control,exraystr.widget.fspecific,SET_BUTTON=0
   widget_control,exraystr.widget.JLine,SET_BUTTON=0
   widget_control,exraystr.widget.JLocus,SET_BUTTON=1
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:1 }
   exraystr.wfilm.JFlag=2
endif else if keyword_set(RT5) then begin
   exraystr.wxstal(0).h  = 5.0
   exraystr.wxstal(0).R0 = 380.
   exraystr.wxstal(0).betamin = 61.0*!pi/180.
   exraystr.wxstal(0).betamax = 120.0*!pi/180.
   exraystr.wfilm.rf = -1.
   exraystr.wLOS = 368.0
   exraystr.wrot = 0.2*!pi/180.
   exraystr.LOSFlag=3
   widget_control,exraystr.widget.fspecific,SET_BUTTON=0
   widget_control,exraystr.widget.JLine,SET_BUTTON=0
   widget_control,exraystr.widget.JLocus,SET_BUTTON=1
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:1 }
   exraystr.wfilm.JFlag=2
endif else if keyword_set(RT6) then begin
   exraystr.wxstal(0).h  = 6.0
   exraystr.wxstal(0).R0 = 380.
   exraystr.wxstal(0).betamin = 71.0*!pi/180.
   exraystr.wxstal(0).betamax = 128.0*!pi/180.
   exraystr.wfilm.rf = -1.
   exraystr.wLOS = 368.0
   exraystr.wrot = 0.2*!pi/180.
   exraystr.LOSFlag=3
   widget_control,exraystr.widget.fspecific,SET_BUTTON=0
   widget_control,exraystr.widget.JLine,SET_BUTTON=0
   widget_control,exraystr.widget.JLocus,SET_BUTTON=1
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:1 }
   exraystr.wfilm.JFlag=2
endif 

h=exraystr.wxstal(0).h
R0=exraystr.wxstal(0).R0
exraystr.wxstal(0).ecc=sqrt(1+(h/R0)^2)-h/R0
exraystr.filmOK = 1
if (exraystr.wxstal(0).twod ne 0.) then exraystr.xstalset(0)=1 $
else exraystr.xstalset(0)=0

if keyword_set(new) then begin
   exraystr.wxstal(0).h  = 0.0
   exraystr.wxstal(0).R0 = 0.
   exraystr.wxstal(0).betamin = 0.0*!pi/180.
   exraystr.wxstal(0).betamax = 0.0*!pi/180.
   exraystr.wfilm.rf = 0.
   exraystr.wfilm.phi = 0.*!pi/180.
   exraystr.wfilm.mu=(exraystr.wfilm.phi-!pi/2.)
   exraystr.wfilm.L = 4.0
   exraystr.wLOS = 0.
   exraystr.wxstal(0).ecc=0.
   exraystr.filmOK = 0
   exraystr.xstalset(0)=0
   exraystr.LOSFlag=2
   widget_control,exraystr.widget.fspecific,SET_BUTTON=0
   widget_control,exraystr.widget.JLine,SET_BUTTON=0
   widget_control,exraystr.widget.JLocus,SET_BUTTON=0
   widget_control,exraystr.widget.JLocus,send_event=$
          { WIDGET_BUTTON, ID:exraystr.widget.JLocus, TOP:wWidget, $
             HANDLER:wWidget, Select:0 }
   exraystr.wfilm.JFlag=0
endif

if (exraystr.sorset(0) eq 1) then begin
;readjust the source location for this crystal's coordinate system
   exraystr.wsource(0).a = -exraystr.wxstal(0).R0
   exraystr.wsource(0).b = 0.
endif

return
end