PRO EXRAY_PLOTJOHANN,exrayptr,trex,LOS,alpham,R0m,windID=winID,xj=xjohann,yj=yjohann

numxstals=(*exrayptr).numxstals
numsource=(*exrayptr).numsource
numorders=(*exrayptr).numorders
numlambda=(*exrayptr).numlambda

if (n_elements(winID) ne 0) then wset,winID

for l=0,numxstals-1 do begin
   xjohann=dblarr(numsource*numorders*numlambda)
   yjohann=dblarr(numsource*numorders*numlambda)
   for i=0,numsource-1 do begin
      for j=0,numorders-1 do begin
          for k=0,numlambda-1 do begin
              theta=(*exrayptr).xstal(l).theta(i,j,k)
              if (theta gt 0.) then begin
                 xxover=(*exrayptr).film.xxover(l,i,j,k)
                 yxover=(*exrayptr).film.yxover(l,i,j,k)
                 xjohann(i*numorders*numlambda+j*numlambda+k)=xxover
                 yjohann(i*numorders*numlambda+j*numlambda+k)=yxover
              endif else begin
                 xjohann(i*numorders*numlambda+j*numlambda+k)=-1000.
                 yjohann(i*numorders*numlambda+j*numlambda+k)=-1000.
              endelse
          endfor
      endfor
   endfor
   index=where(xjohann gt -1000.)
   if (index(0) ne -1) then begin
       xjohann=xjohann(index)
       yjohann=yjohann(index)
   endif
   index=sort(xjohann)
   xjohann=xjohann(index)
   yjohann=yjohann(index)

   if (trex ne 0) then begin
      dist=sqrt((R0m+xjohann)^2+yjohann^2)
      xjohann=LOS-dist*cos(alpham+asin(-yjohann/dist))
      yjohann=dist*sin(alpham+asin(-yjohann/dist))
   endif

   oplot,xjohann,yjohann,thick=2.,col=l
endfor

return
end