

pro Exray_TREXwidget_BASE_event, Event


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = trexstr

  case Event.id of

    Widget_Info(wWidget, FIND_BY_UNAME='SideOn_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
        endif else begin
           ;Widget_Control,trexstr.origin,EDITABLE=0
           Widget_Control,trexstr.endon,SET_BUTTON = 0
           Widget_Control,trexstr.other,SET_BUTTON = 0
           Widget_Control,trexstr.rt,SET_BUTTON = 0
           trexstr.LOSflagt=0
           trexstr.origint=153.937*2.54
           Widget_Control,trexstr.origin,SET_VALUE=trexstr.origint
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='EndOn_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           Widget_Control,trexstr.sideon,SET_BUTTON = 1
           trexstr.LOSflagt=0
           trexstr.origint=153.937*2.54
           Widget_Control,trexstr.origin,SET_VALUE=trexstr.origint
        endif else begin
           ;Widget_Control,trexstr.origin,EDITABLE=0
           Widget_Control,trexstr.sideon,SET_BUTTON = 0
           Widget_Control,trexstr.other,SET_BUTTON = 0
           trexstr.LOSflagt=1
           trexstr.origint=96.4567*2.54
           Widget_Control,trexstr.origin,SET_VALUE=trexstr.origint
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RT_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           Widget_Control,trexstr.sideon,SET_BUTTON = 1
           trexstr.LOSflagt=0
           trexstr.origint=153.937*2.54
           Widget_Control,trexstr.origin,SET_VALUE=trexstr.origint
        endif else begin
           ;Widget_Control,trexstr.origin,EDITABLE=0
           Widget_Control,trexstr.sideon,SET_BUTTON = 0
           Widget_Control,trexstr.endon,SET_BUTTON = 0
           Widget_Control,trexstr.other,SET_BUTTON = 0
           trexstr.LOSflagt=3
           trexstr.origint=369.974
           Widget_Control,trexstr.origin,SET_VALUE=trexstr.origint
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Other_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           Widget_Control,trexstr.sideon,SET_BUTTON = 1
           ;Widget_Control,trexstr.origin,EDITABLE=0
           trexstr.LOSflagt=0
           trexstr.origint=153.937*2.54
           Widget_Control,trexstr.origin,SET_VALUE=trexstr.origint
        endif else begin
           Widget_Control,trexstr.sideon,SET_BUTTON = 0
           Widget_Control,trexstr.endon,SET_BUTTON = 0
           Widget_Control,trexstr.rt,SET_BUTTON = 0
           ;Widget_Control,trexstr.origin,EDITABLE=1
           trexstr.LOSflagt=2
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       ;save the values in 'global' variables
        trexstr.exraystr.LOSFlag=trexstr.losflagt
        tmp=double(0.)
        ;if (trexstr.losflagt eq 2) then begin
           Widget_Control, trexstr.origin, get_value = tmp
           trexstr.exraystr.wLOS=tmp
        ;endif else trexstr.exraystr.wLOS=trexstr.origint
        Widget_Control, trexstr.rot, get_value = tmp
        trexstr.exraystr.wrot=tmp*!pi/180.
        Widget_Control, trexstr.MainWidget, set_uvalue = trexstr.exraystr
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Cancel_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        ;quit without saving anything
        widget_control, Event.top, /DESTROY
        return
      endif
    end
    else:
  endcase

  Widget_Control, wWidget, set_uvalue = trexstr


end

pro Exray_TREXwidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Widget_Control, MainWidget, get_uvalue = exraystr
  mxy=exraystr.mxy

  Exray_TREXwidget_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_TREXwidget_BASE' ,XOFFSET=5 ,YOFFSET=5, COLUMN=1$
      ,TITLE='LOS Specs' ,SPACE=3 ,XPAD=3 ,YPAD=3)


  LOS_LABEL = Widget_Label(Exray_TREXwidget_BASE,  $
         UNAME='LOS_LABEL' ,/ALIGN_LEFT,VALUE='Location')


  LOS_BASE = Widget_Base(Exray_TREXwidget_BASE, UNAME='LOS_BASE'  $
       ,COLUMN=2 ,/NONEXCLUSIVE,/FRAME)


  SideOn_Button = Widget_Button(LOS_BASE, UNAME='SideOn_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='TREX side-on')


  EndOn_Button = Widget_Button(LOS_BASE, UNAME='EndOn_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='TREX end-on')

  RT_Button = Widget_Button(LOS_BASE, UNAME='RT_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='RT end-on')

  Other_Button = Widget_Button(LOS_BASE, UNAME='Other_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='other')


  Origin_LABEL = Widget_Label(Exray_TREXwidget_BASE,  $
         UNAME='Origin_LABEL' ,XOFFSET=10 ,YOFFSET=115 ,/ALIGN_Center  $
         ,VALUE='Origin')

  Origin_Field = CW_Field(Exray_TREXwidget_BASE,UNAME='Origin_FIELD' $
                        ,Title='Distance from source (cm) =',/Return_Events $
                        ,/float,xsize=8,Value=[exraystr.wLOS])

  Rot_LABEL = Widget_Label(Exray_TREXwidget_BASE,  $
         UNAME='Rot_LABEL' ,XOFFSET=10 ,YOFFSET=170 ,/ALIGN_Center  $
         ,VALUE='Additional Coordinate Rotation')
  Rot_Field = CW_Field(Exray_TREXwidget_BASE,UNAME='Rot_FIELD' $
                        ,Title='Degrees past avg. beta =',/Return_Events $
                        ,/float,xsize=8,Value=[exraystr.wrot*180./!pi])

  Quit_BASE = Widget_Base(Exray_TREXwidget_BASE, UNAME='Quit_BASE' $
      ,COLUMN=2,/ALIGN_RIGHT)

  Cancel_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Cancel_BUTTON' ,FRAME=1 ,XOFFSET=10  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Cancel')


  Quit_BUTTON = Widget_Button(Quit_BASE,  $
      UNAME='Quit_BUTTON' ,FRAME=1 ,XOFFSET=80  $
      ,YOFFSET=370 ,SCR_XSIZE=60*mxy ,SCR_YSIZE=36*mxy ,/ALIGN_CENTER  $
      ,VALUE='Done')



;***********************************************************************************
;Set the appropriate buttons and values
;***********************************************************************************

  if (exraystr.LOSFlag eq 0) then begin
     Widget_Control,SideOn_BUTTON,SET_BUTTON=1
  endif else if (exraystr.LOSFlag eq 1) then begin
     Widget_Control,EndOn_BUTTON,SET_BUTTON=1
  endif else if (exraystr.LOSFlag eq 3) then begin
     Widget_Control,RT_BUTTON,SET_BUTTON=1
  endif else begin
     Widget_Control,Other_BUTTON,SET_BUTTON=1
  endelse

;************************************************************************************
;Define the structure to be passed around
;************************************************************************************

  TREXstr = {NAME: 'TREX_Structure',$
              SideOn:SideOn_BUTTON,$
              EndOn:EndOn_BUTTON,$
              RT:RT_BUTTON,$
              Other:Other_BUTTON,$
              Origin:Origin_FIELD,$
              Rot:Rot_FIELD,$
              origint:double(0.),$ ;temporary holder of origin information
              LOSflagt:long(0),$ ;temporary flag to say which LOS coordinates
              exraystr:exraystr,$
              MainWidget:MainWidget}

  trexstr.origint=exraystr.wLOS
  trexstr.LOSflagt=exraystr.LOSFlag

 ;******************************************************************************************
 ;Realize the widget, and send control to the xmanager
 ;******************************************************************************************

  Widget_Control, /REALIZE, Exray_TREXwidget_BASE

  Widget_Control, Exray_TREXwidget_BASE, set_uvalue = trexstr


  XManager, 'Exray_TREXwidget_BASE', Exray_TREXwidget_BASE

end
;
; Empty stub procedure used for autoloading.
;
pro exray_TREXwidget, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  Exray_TREXwidget_BASE, MainWidget, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
