; ------------------------------------------------------------------------ 
; $Id: atgrid.pro,v 1.2 2005/03/09 22:21:40 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2005 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro atgrid, flip=flip, _extra=extra
;
; plot ATHETA grid
;
common at_grid
;
if (n_elements(grid_nx) eq 0) or (n_elements(grid_ny) eq 0) then return
;
if not keyword_set(flip) then flip = 0
;
mx = grid_nx-2
my = grid_ny-2
;
if flip then begin
  for i=1, my do begin
    oplot, [grid_y(i),grid_y(i)], [grid_x(1),grid_x(mx)], _extra=extra
  endfor
  for i=1, mx do begin
    oplot, [grid_y(1),grid_y(my)], [grid_x(i),grid_x(i)], _extra=extra
  endfor
endif else begin
  for i=1, mx do begin
    oplot, [grid_x(i),grid_x(i)], [grid_y(1),grid_y(my)], _extra=extra
  endfor
  for i=1, my do begin
    oplot, [grid_x(1),grid_x(mx)], [grid_y(i),grid_y(i)], _extra=extra
  endfor
endelse
return
end
