function noisestats_wiener  , image,halfwidth   ,POPULATION_ESTIMATE=POPULATION_ESTIMATE




n = halfWidth*2+1

    ; sample size
m = n^2
    
    ; temporary double image copy to prevent overflow
im = double(image)
 
    ; calc average
av_im = smooth(im, n, EDGE_TRUNCATE=1)
 
    ; calc squares image
sq_im = temporary(im)^2
 
    ; average squares
asq_im = smooth(sq_im, n, EDGE_TRUNCATE=1)

        ; remove centre pixel from estimate
        ; calc neighbourhood average (removing centre pixel)
     av_im = (av_im*m - image)/(m-1)
        ; calc neighbourhood average of squares (removing centre pixel)
     asq_im = (asq_im*m - temporary(sq_im))/(m-1)
        ; adjust sample size
     m = m-1


var_im =  temporary(asq_im) - (av_im^2)
IF keyword_set(POPULATION_ESTIMATE) THEN BEGIN
     var_im = var_im *( double(m)/(m-1))
ENDIF
;print,'mean var =  ',mean(var_im)
;print,'mean meansq =  ',mean(av_im^2)
;print,'mean var + meansq =  ',mean(var_im)+mean(av_im^2)

noisestats=total(var_im+av_im^2)

;print,'noisestats per pixel =  ',noisestats/n_elements(image)
return,noisestats
end
