 pro make_pact_connect, imat, tri, loctri
; Upper right hand corner material matrix has the material number 
; for a cell.  Eliminate cells without material.
; Bad are cells without material

on_error, 1
 ss = size(imat)
 if ss(0) lt 2 then begin
   print, 'MAKE_PACT_CONNECT: Error with region matrix'
   help, imag
   return
 endif
 nx = ss(1)
 ny = ss(2)
 tri = 0
 ndim = 2
; mapped mesh
      ok = where (imat[1:*, 1:*, 0] gt 0, nreg)
      nxm = nx-1 
      nym = ny-1
      row = make_array (4, nxm, /long)
      row(*, 0) =[ 0L, 1, nx+1, nx]
      i = 1L
      while (i lt nxm) do begin
        if (i+i) lt nxm then $
          row[*, i:i+i-1] = i+row[*, 0:i-1] $
        else row[*, i:nxm-1] = i + row[*, 0:nxm-1-i]
        i = i+i
      endwhile
      row = reform (row, 4*nxm, /overwrite)
      tri = make_array(4*nxm,nym, /long)
      tri(*, 0) = row
      for i = 1L, nym-1 do tri(*, i) = i*nx+row
      row =0
      tri = reform (tri, 4, nxm*nym, /overwrite)

      tri = reform (tri[*, ok], 4*nreg, /overwrite)
      loctri = 4*lindgen(nreg +1)
      imat = (imat[1:*, 1:*, 0])[ok]
 end

