; ------------------------------------------------------------------------ 
; $Id: add_training.pro,v 1.3 2007/06/06 20:03:44 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro add_training
;
;+
; Name: ADD_TRAINING
; 
; Description:
;       Add the training directory to a IDL session path.
;       Caution: Some routines in the training directory may conflict with
;                the IDL distribution.
;
; Format: add_training
;
;-
 a = '+'+getenv('IDL_DIR')+'/training'
 !path = !path + ':' + expand_path(a)
 print, ' The following training directory is added to the path:'
 print, a
end
