; ------------------------------------------------------------------------ 
; $Id: endp.pro,v 1.3 2007/06/06 20:03:46 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  pro endp
;+
;Close the printer device and set the graphics output to windows.
; 
;-
@switchpost.com
on_error,1
   if n_elements (lcopen) eq 0 then lcopen = 0
   if lcopen eq 0 then return
   if !d.name eq 'PRINTER' then begin
     !x.thick= oldxythick
     !y.thick= oldxythick
     !z.thick= oldxythick
     !p.thick= oldthick
     !p.charsize = oldpclfont(0)
     !p.charthick = oldpclfont(1)
   endif else set_plot, 'PRINTER'
   lcopen = 0
   device, /close
   if n_elements(olddevice) eq 0 then olddevice = 'WIN'
   set_plot, olddevice, copy = oldcopy, interpolate = oldinterpolate
   if n_elements(noloadsave) eq 0 then noloadsave = 0
   if noloadsave eq 0 then loadxyct, /quiet
   return
   end
