; ------------------------------------------------------------------------ 
; $Id: preset.pro,v 1.3 2007/06/06 20:03:50 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro  preset
;
;+
; NAME:
;       PRESET
;
; PURPOSE:
;       Reset font, line thicknesses, and multi plots.
; CATEGORY:
;       UTILITY 
; CALLING SEQUENCE:
;       PRESET
; OUTPUTS:
;       None
; EXAMPLES:
;       Reset default plot parameters
;             PRESET
; MODIFICATION HISTORY:
;      Original version, L. P. Mix, January 3, 1997
;-
;
;
      on_error, 1
   xythick = 1
   thick = 1
   !p.font = 1
   !x.thick = xythick
   !y.thick = xythick
   !z.thick = xythick
   !p.thick = thick
   !p.multi = 0
       return
       end
