; ------------------------------------------------------------------------ 
; $Id: xreset.pro,v 1.3 2007/06/06 20:03:56 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
Pro xreset,verbose = verbose
;+
; Name: Xreset
;   Function: enable the cursor keys of an xterminal
; Usage: xreset
; 
; Keywords:
;      Verbose:  If set will indicate:
;                '% XRESET: Resetting xterm cursor keys'
;
;-
if keyword_set (verbose) then print, '% XRESET: Resetting xterm cursor keys'
if getenv("TERM") eq "xterm" then $
       print,form='(a,$)',string(27B) + '>' + string(27B) + '[?1l'
end
