; ------------------------------------------------------------------------ 
; $Id: add_tqpnts.pro,v 1.3 2007/06/06 20:12:40 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 PRO  add_tqpnts, ival, coord
;
;  Common Blocks
;
; ival is the insertion point
; coord is the spatial point in 'COND' mode and the ij grid point in 
;  'INPUT' mode
@pfidltq.com
;
@tqeditevent.com
      on_error, 1
      ncon = cond.ncon
      if lcsegment lt 1 or lcsegment gt ncon then message, $
        'Bad conductor segment - '+ strtrim(lcsegment, 2) + string(ncon)
        old_cond = cond
      if lcmode eq 'COND' then begin
        loc = cond.locx
        np = loc(lcsegment)-loc(lcsegment-1)
        xx = cond.x
        yy = cond.y
        xxx = cond.x(loc(lcsegment-1):loc(lcsegment)-1)
        yyy = cond.y(loc(lcsegment-1):loc(lcsegment)-1)
        if ival lt np-1  then begin
          xxx= [xxx(0:ival), coord(0), xxx(ival+1: np-1)]
          yyy = [yyy(0:ival), coord(1), yyy(ival+1: np-1)]
        endif else begin
          xxx = [xxx, coord(0)]
          yyy = [yyy, coord(1)]
        endelse
        array2pack, lcsegment, ncon, loc, np+1, xx, xxx, yy, yyy
        cond = {ncon:ncon, lcfit:0, x:xx, y:yy, locx:loc, $
             ix:cond.ix, iy:cond.iy, loci:cond.loci, iplotx:cond.iplotx, $
             iploty:cond.iploty, locp:cond.locp, $
             badxy:cond.badxy, locb:cond.locb, nbad:cond.nbad }
      endif else begin
          loc = cond.loci
          np = loc(lcsegment)-loc(lcsegment-1)
        xx = cond.ix
        yy = cond.iy
        xxx = cond.ix(loc(lcsegment-1):loc(lcsegment)-1)
        yyy = cond.iy(loc(lcsegment-1):loc(lcsegment)-1)
        if ival lt np-1  then begin
          xxx = [xxx(0:ival), coord(0), xxx(ival+1: np-1)]
          yyy = [yyy(0:ival), coord(1), yyy(ival+1: np-1)]
        end else begin
          xxx = [xxx, coord(0)]
          yyy = [yyy, coord(1)]
        endelse
        array2pack, lcsegment, ncon, loc, np+1, xx, xxx, yy, yyy
        cond = {ncon:ncon, lcfit:cond.lcfit, x:cond.x, y:cond.y, $
             locx:cond.locx, ix:xx, iy:yy, loci:loc, iplotx:cond.iplotx, $
             iploty:cond.iploty, locp:cond.locp, $
             badxy:cond.badxy, locb:cond.locb, nbad:cond.nbad }
        get_tqplotpnts
        get_tqbad
      endelse
      return
      end
