; ------------------------------------------------------------------------ 
; $Id: get_icem_cond_info.pro,v 1.3 2007/06/06 20:12:41 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro get_icem_cond_info_event, event
    but = event.value
    case but of 

 'QUIT' : BEGIN
         Widget_control, event.top, get_uvalue= info,tlb_get_offset = offset, $
              /no_copy
         value = {varname: '', quit: 1, normal:0, type: 0, $
              dimen:0, maxf:0.0, minf:0.0, offset:offset}
          widget_control, info.ptr, set_uvalue = value, /no_copy
          widget_control, event.top, /destroy
          END
 'OK' : BEGIN
         Widget_control, event.top, get_uvalue= info,tlb_get_offset = offset, $
              /no_copy
          widget_control,info.var, get_value = varname 
          widget_control,info.type, get_value = type 
          value = {varname: varname, quit: 0, type:type, offset:offset}
          widget_control, info.ptr, set_uvalue = value, /no_copy
          widget_control, event.top, /destroy
          END
     ELSE: 
     endcase
     end
 Pro get_icem_cond_info, lcquit, name, type, offset
     on_error, 1
     base = widget_base(/column, title= 'Conductor Parameters')
     lcquit = 1
     if n_elements (name) eq 0 then string2 = ' ' else string2 = name
     Var = cw_field(base, title= 'Material Name',  $
           value = string2)
     if n_elements (type) eq 0 then type = 0 else type = (fix(type(0)) > 0) <2
    
     buttyp = cw_bgroup( base, /row, $
          ['Conductor' , 'Vacuum', 'Dielectric'], $
          /exclusive,  /NO_RELEASE, $
          label_top = 'Material Type', /frame, $
          button_uvalue= ['i' , 'j', 'k' ] , set_value = type)
     menu = make_array(2, /string)
     menu(0) = '             OK             ' 
     menu(1) = '  Skip this conductor  '
     but = cw_bgroup(base,menu,/row,/NO_RELEASE, button_uvalue =['OK','QUIT'])
  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, base, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1) 
     ptr = widget_base()
     info = {var: var, ptr:ptr, type:buttyp }
     widget_control, base, set_uvalue = info
     value = {varname: '', quit: 1, type:type, offset:offset}
     widget_control, ptr, set_uvalue = value
     widget_control, base, tlb_get_offset= offset_real
     offset_real = offset  - offset_real
     xmanager, 'get_icem_cond_info', base
     widget_control, ptr, get_uvalue = value
     widget_control, ptr, /destroy
     lcquit = value.quit
     offset = value.offset+ offset_real
     if lcquit eq 1 then return
     name = (strtrim(value.varname, 2))[0]
     type = (value.type)[0]
     end
