; ------------------------------------------------------------------------ 
; $Id: tqdelete_cond.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro tqdelete_cond, j
; join conductors
;
@pfidltq.com
@tqeditevent.com
;
      old_cond= cond
      xx = cond.x
      yy = cond.y
      loc = cond.locx
      ncon= cond.ncon
      if j lt 1 or j gt ncon then  message, 'Conductor value out of range'
        lcfit = cond.lcfit
        ix = cond.ix
        iy = cond.iy
        loci = cond.loci
        locp = cond.locp
        ipx = cond.iplotx
        ipy = cond.iploty
        nbad = cond.nbad
        badxy = cond.badxy
        locb  = cond.locb
        ixx = 0
        iyy = 0
        if n_elements (lcfit) lt ncon + 1 then $
          lcfit = make_array(ncon+1, /int, value = lcfit(0))
        if n_elements (nbad) lt ncon + 1 then $
          nbad = make_array(ncon+1, /int, value = nbad(0))

            array2pack, j, ncon, loc, 0, xx, ixx, yy, iyy
            ncon= ncon+1
            array2pack, j, ncon, loci, 0, ix, ixx, iy, iyy
            ncon= ncon+1
            array2pack, j, ncon, locp, 0, ipx, ixx, ipy, iyy
            ncon= ncon+1
            array1pack, j, ncon, locb, 0, badxy, ixx
            if j le ncon then begin
              lcfit = [lcfit(0:j-1), lcfit(j+1:*)]
              nbad = [nbad(0:j-1), nbad(j+1:*)]
            endif else begin
              nbad = nbad(0:ncon)
              lcfit = lcfit(0:ncon)
            endelse

        if ncon gt 0 then begin
          ok = where (lcfit(1:*) gt 0, nok)
          if nok eq ncon then lcfit (0) = 1 else lcfit(0) = 0
          nbad(0) = total(nbad(1:*))
        endif
        cond = {ncon:ncon, lcfit:lcfit, x:xx, y:yy, locx:loc, $
             ix:ix, iy:iy, loci:loci, iplotx:ipx, iploty:ipy, locp:locp, $
             badxy:badxy, locb:locb, nbad:nbad }
 
      return
      end
