; ------------------------------------------------------------------------ 
; $Id: tqplotgrid.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro tqplotgrid, gxin, gyin,color = color, over = over, _extra = extra
 on_error , 2
@pfidltq.com
  nx = min ([n_elements (gxin),  n_elements (gyin)])
  if nx eq 0 then begin
     nx = n_elements (gx) 
     if nx eq 0 then message, ' X grid array must be defined' else gxin = gx
     ny = n_elements (gy)
     if ny eq 0 then message, ' Y grid array must be defined' else gyin = gy
  endif else begin
     nx = n_elements (gxin) 
     ny = n_elements (gyin)
  endelse
  if n_elements (over) eq 0 then over = 0
  if over eq 0 then plot, gxin, gyin, /nodata, _extra = extra
  if n_elements (color) eq 0 then begin
  for i = 0, nx -1 do oplot, [gxin(i), gxin(i)], [gyin(0), gyin(ny-1)]
  for i = 0, ny -1 do oplot, [gxin(0), gxin(nx-1)], [gyin(i), gyin(i)]
  endif else begin
  for i = 0, nx -1 do $
     oplot, [gxin(i), gxin(i)], [gyin(0), gyin(ny-1)], color = color
  for i = 0, ny -1 do $
     oplot, [gxin(0), gxin(nx-1)], [gyin(i), gyin(i)], color = color
  endelse
  return
  end
