; ------------------------------------------------------------------------ 
; $Id: clear_structure.pro,v 1.4 2007/06/06 19:34:26 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro  clear_structure, ia
;
;+
;  clear the data values from a structure array
;-
;  Common block
@qsstrcom.dat
;
      if n_elements (structinit) eq 0 then qsstruct_init
;
      if ia ge 1 and  ia le maxstructure then begin
        i = ia-1
        lcvalidstr(i) = 0
        comment(i) = ''
        if strarraycom(i) gt 0 then handle_value, strarraycom(i), 0.0, /set
      endif
      return
      end
