; ------------------------------------------------------------------------ 
; $Id: delete_mitlpnts.pro,v 1.3 2007/06/06 19:34:26 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro delete_mitlpnts, i, nofill = nofill
;
@mitl_common.com
;
;
    if i lt 0 or i gt str.np-1 then begin
      print, 'Cannot delete point ', strtrim(i, 2)
      print, ' Structure contains ', strtrim(str.np, 2) , ' points'
    endif
    if i eq 0 then begin
      str = { np: str.np-1, x:str.x(1:*), zv:str.zv(1:*), zf:str.zf(1:*), $
             fit:str.fit(1:*), zfcon:str.zfcon(1:*), lcemit:str.lcemit(1:*), $
             zfdwn:str.zfdwn(1:*), npos:0L}
    endif else if i eq str.np-1 then begin
      n = str.np-2
      str = { np: str.np-1, x:str.x(0:n), zv:str.zv(0:n), zf:str.zf(0:n), $
             fit:str.fit(0:n), zfcon:str.zfcon(0:n), lcemit:str.lcemit(0:n), $
             zfdwn:str.zfdwn(0:n), npos:0L}
    endif else begin
      im = i-1
      ip = i+1
      str = { np: str.np-1, x:[str.x(0:im),str.x(ip:*)], $
             zv:[str.zv(0:im),str.zv(ip:*)],  zf:[str.zf(0:im), str.zf(ip:*)], $
             zfcon:[str.zfcon(0:im), str.zfcon(ip:*)], $
             zfdwn:[str.zfdwn(0:im), str.zfdwn(ip:*)], $
             lcemit:[str.lcemit(0:im), str.lcemit(ip:*)], $
             fit:[str.fit(0:im), str.fit(ip:*)], npos:0L}
    endelse
    if keyword_set(nofill) then return
    if str.np gt 1 then fillmitlstr
    return
    end
