; ------------------------------------------------------------------------ 
; $Id: get_fulldirname.pro,v 1.4 2009/02/17 17:03:16 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro get_fulldirname, file, filename, sep = sep
;
;+
;  purpose , Get a complete path name for a file
;         file is an appropriate file 
;         filename is the actual file
;         file is returned as the directory name
;  
;-
      file = strtrim(file,2)
      len = strlen(file)
      strb = byte(file)

      sep = (byte(path_sep()))[0]
      ok = where (strb eq sep, nok)
      if nok gt 0 then begin
        if ok(nok-1) gt 0 then begin
          if ok(nok-1) eq len-1 then file = '' else begin
            str = string(strb(0:ok(nok-1)-1))
            filename = string(strb(ok(nok-1)+1:*))
            if sep eq 47B then spawn, '( cd '+ str + '; pwd )', file, /sh $
               else file = str
;               cd,  current = current
          endelse
          return
        endif else filename = string(strb(1:*))
      endif else filename = file
      cd, current = file
      end
