; ------------------------------------------------------------------------ 
; $Id: get_reaction.pro,v 1.3 2007/06/06 19:34:28 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
PRO MAIN13_Event, Event
  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev
  CASE Ev OF 
  'BUTTON4': BEGIN
      widget_control, event.top, get_uvalue = info, /no_copy
      widget_control, info.but, get_value = value
      handle_value, info.ptr, value+1, /set
      widget_control, event.top, /destroy
      END
  'BUTTON5': BEGIN
      widget_control, event.top, /destroy
      END
   ELSE:
  ENDCASE
END

PRO get_reaction, GROUP=Group, react, value


  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      UVALUE='MAIN13')

  Btns100 = react
  BGROUP2 = CW_BGROUP( MAIN13, Btns100, $
      COLUMN=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      UVALUE='BGROUP2')

  BASE3 = WIDGET_BASE(MAIN13, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE3')

  BUTTON4 = WIDGET_BUTTON( BASE3, $
      UVALUE='BUTTON4', $
      VALUE='  Done  ')

  BUTTON5 = WIDGET_BUTTON( BASE3, $
      UVALUE='BUTTON5', $
      VALUE='Cancel')
  
  WIDGET_CONTROL, MAIN13, /REALIZE
  widget_control, bgroup2, set_value = 0
  ptr = handle_create()
  handle_value, ptr, 0L, /set
  widget_control, main13, set_uvalue = {ptr:ptr, but:bgroup2}

  XMANAGER, 'MAIN13', MAIN13
  handle_value, ptr, value
  handle_free, ptr

END
