; ------------------------------------------------------------------------ 
; $Id: get_scale_factors.pro,v 1.4 2011/01/06 20:01:20 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro get_scale_factors_event, event
 on_error ,1 
  widget_control, event.top, get_uvalue = info
  for i = 0, info.nval-1 do begin
    widget_control, (info.wid)[i], get_value = ss
    (*info.ptr)[i]= ss
  endfor
  widget_control, event.top, /destroy
end

pro get_scale_factors, labels, scales,  $
        modal = modal, group = group, text = text

common get_scale_factor_common, start_values
on_error, 1
tlb = widget_base(/column, modal = modal, group = group)

if n_elements(text) eq 0 then text = $
     'Enter the Scale Factors for the following signals:'

txt = widget_label(tlb, value = text)
nval = n_elements(labels)
if n_elements (start_values) lt nval then $
  start_values = [start_values, make_array(nval, value= 0.0)]
scales = start_values
wid = make_array(nval, /long)
for i = 0, nval-1 do $
wid [i] = cw_field (tlb, /float, value = start_values[i], /frame, xsize = 20, $
         title = labels[i]+':')

but = widget_button(tlb, /frame, value = ' Finished / Exit ')
widget_control, tlb, /realize

ptr = ptr_new(make_array(nval, value = 0.0 ))
info = {wid:wid, nval: nval, ptr: ptr}
widget_control, tlb, set_uvalue = info
xmanager, 'get_scale_factors', tlb

start_values= *ptr
scales = start_values[0:nval-1]
ptr_free, ptr

 end
