; ------------------------------------------------------------------------ 
; $Id: please_select.pro,v 1.4 2007/06/06 19:34:31 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

pro please_select_event, event
common please_select_common, sel_offset
 COMPILE_OPT hidden

widget_control, event.id, get_uvalue = uval
if uval eq 'DONE' then begin
  widget_control, event.top, get_uvalue = info
  widget_control, info.wfid, get_value = val
  (*info.ptr).value = val
  (*info.ptr).lcquit = 0
  widget_control, event.top, tlb_get_offset = sel_offset
  widget_control, event.top, /destroy
endif else if uval eq 'QUIT' then begin
  widget_control, event.top, get_uvalue = info
  widget_control, info.wfid, get_value = val
  (*info.ptr).value = val
  (*info.ptr).lcquit = 1
  widget_control, event.top, tlb_get_offset = sel_offset
  widget_control, event.top, /destroy
endif
end


pro please_select , lcquit, val, string_val, Instructions = instructions
common please_select_common, sel_offset
 COMPILE_OPT hidden

val = -1l
lcquit = 1L
tlb = widget_base(/col, title = 'Selection Widget')
nfil = n_elements (string_val)
if nfil eq 0 then return
if n_elements (instructions) eq 0 then $
  instructions = 'Please select one of the following'

tx = widget_label(tlb, /align_center, value = instructions)
wfid = cw_bgroup(tlb,string_val,/frame,  /exclusive, $
      /no_release, uvalue = 'LIST', set_value = nfil-1) 
wbut = widget_base(tlb, /row, /frame)
wb = widget_button(wbut, value = ' D O N E ' , uvalue = 'DONE')
wb2 = widget_button(wbut, value = ' Q U I T ' , uvalue = 'QUIT')
ptr = ptr_new({value: val, lcquit: lcquit})
info = {wfid: wfid, ptr:ptr}

if n_elements(sel_offset) eq 0 then begin
  if !d.window lt 0 then sel_offset = [10, 20] else begin
    device, get_window_position = sel_offset
    sel_offset = sel_offset+ 0.3*[!d.x_size, -!d.y_size]
  endelse
endif

WIDGET_CONTROL, tlb, /REALIZE, tlb_set_xoffset = sel_offset[0], $
            tlb_set_yoffset = sel_offset[1]

widget_control, tlb, set_uvalue = info
xmanager, 'please_select', tlb

lcquit = (*ptr).lcquit
if keyword_set(lcquit) then val = -1L else val = (*ptr).value
;
ptr_free, ptr
end
