; ------------------------------------------------------------------------ 
; $Id: select_dim.pro,v 1.3 2007/06/06 19:34:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Function select_dim, a, ndim, dim, val
;
      if n_elements (a) eq 0 then begin
        print , ' Error in SELECT_DIM -- Array is undefined'
        return, 0.0
      endif
      if ndim eq 4 then begin
        if dim eq 1 then return, a(val, *,*,*) $
        else if dim eq 2 then return, a(*, val, *,*) $
        else if dim eq 3 then return, a(*,*,val, *) $
        else if dim eq 4 then return, a(*,*,*, val) $
        else  return, 0.0
      endif else if ndim eq 3 then begin
        if dim eq 1 then return, a(val, *,*) $
        else if dim eq 2 then return, a(*, val, *) $
        else if dim eq 3 then return, a(*,*,val) $
        else  return, 0.0
      endif else if ndim eq 2 then begin
        if dim eq 1 then return, a(val, *) $
        else if dim eq 2 then return, a(*, val) $
        else  return, 0.0
      endif else return, 0.0
      end
