; ------------------------------------------------------------------------ 
; $Id: set_load_map.pro,v 1.3 2007/06/06 19:34:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro set_load_map, info, ltype
;
 if ltype eq 0 or ltype eq 5 then begin
   widget_control, info.base2, sensitive = 0
   widget_control, info.base4, sensitive = 0
   widget_control, info.base3, sensitive = 1
;  widget_control, info.base3, map = 1
   if ltype eq 0 then widget_control, info.zlabel, $
     set_value = 'Set value for peak or constant-Z value' $
     else  widget_control, info.zlabel, $
     set_value = 'Constant perveance model- Value at peak voltage'
 endif else if ltype eq 1 then begin
   widget_control, info.base2, sensitive = 1
   widget_control, info.base11, sensitive = 1
   widget_control, info.base12, sensitive = 0
   widget_control, info.base13, sensitive = 1
   widget_control, info.base15, sensitive = 0
   widget_control, info.base4, sensitive = 0
   widget_control, info.base3, sensitive = 1
 endif else if ltype eq 2 then begin
   widget_control, info.base2, sensitive = 1
   widget_control, info.base11, sensitive = 1
   widget_control, info.base12, sensitive = 1
   widget_control, info.base13, sensitive = 1
   widget_control, info.base15, sensitive = 0
   widget_control, info.base4, sensitive = 0
   widget_control, info.base3, sensitive = 1
 endif else if ltype eq 3 then begin
   widget_control, info.base2, sensitive = 0
   widget_control, info.base4, sensitive = 1
   widget_control, info.base3, sensitive = 1
 endif else if ltype eq 4 then begin
   widget_control, info.base2, sensitive = 1
   widget_control, info.base11, sensitive = 0
   widget_control, info.base15, sensitive = 1
   widget_control, info.base4, sensitive = 0
   widget_control, info.base3, sensitive = 0
 endif else Message, ' Cannot have a type of '+ strtrim(ltype, 2)
 return
 end
