; ------------------------------------------------------------------------ 
; $Id: sp2under.pro,v 1.3 2007/06/06 19:34:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function sp2under, wordin
;+
; Strip spaces from either side of word and replace any inner spaces with 
;   and underscore.
;
; format: New_word = sp2under('new word')
;-

on_error, 1
      if n_elements(wordin) eq 0 then return, ''
      word = strtrim(wordin, 2)
      if strlen(word) lt 3 then return, word
      ok = strpos(word, ' ')
      if ok lt 0 then return , word
      bword = byte(word)
      ok = where (bword eq 32B)
      bword(ok) = 95B
      return, string(bword)
      end
