; ------------------------------------------------------------------------ 
; $Id: winformation.pro,v 1.3 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
PRO winformation, message, offset = offset, xsize = xsize, ysize = ysize

;+
; This is the procedure that creates a message widget.
; format:
;       winformation, message
;            message may be a sting array
; example;
;     put the message up to 'Select a conductor', 'or push the exit'
;      winformation, ['Select a conductor', 'or push the exit']
;-
messbase = WIDGET_BASE(TITLE = '   PFIDL Information   ', $
	/COLUMN , xsize = xsize, ysize = ysize)

; A widget for instructional text is created

wdrlabel = WIDGET_LABEL(messbase, VALUE = ' ' )
if n_elements (message) gt 0 then begin
  for i = 0, n_elements (message)-1 do $
     wdrlabel = WIDGET_LABEL(messbase, VALUE = message(i))
endif else wdrlabel = WIDGET_LABEL(messbase, VALUE = message)
wdrlabel = WIDGET_LABEL(messbase, VALUE = ' ')
;
button = WIDGET_BUTTON(messbase, VALUE = 'OK', UVALUE = 'DONE')

 if n_elements (offset) lt 2  then begin
    offset = [0, 0]
    WIDGET_CONTROL, messbase, /REALIZE
  endif else $
  WIDGET_CONTROL, messBASE, /REALIZE, tlb_set_xoffset = offset(0)> 10, $
       tlb_set_yoffset= offset(1) > 10

  event = WIDGET_EVENT (messbase)
  widgET_CONTROL, event.top, /DESTROY
end
