PRO regrid,full=full
; This program will read a text input file to gather filenames
; then using the winstr command fog level will be determined and
; removed from the image.
; the images will then be regrided and written out with a _unp.pff suffix
;
; added keyword full to write out data using full precision 11/21/03, gsd

closepff,0
delstr

; while not eof, read input file and loop through files
print,'What is the filename of the text input file to be read?'
print,'(sample file in /remote/gsdunha/da_tools/templates/regrid_a.txt)'
fname=' ' 
line=' '
fit_file=' '
infile=' '
outfile=' '
out1=' '
i=0
fog=dblarr(20)
range=dblarr(20,2)
part=strarr(2)
read,fname
fname=strtrim(fname,2)
part=str_sep(fname,'.')
fname2=part(0)+'_bkg.txt'
ans=''
rgv=2
print,'Default regrid value is set to ',rgv
print,'Do you wish to change it? (y/n)'
read,ans
if(ans eq 'y') then begin
  print,'type in new value to regrid by'
  read,rgv
endif

openr,in,fname,/get
openw,out,fname2,/get
  readf,in,line
  if STRPOS(line,'fit file') NE -1 then readf,in,fit_file
  while(NOT eof(in)) do begin	
    readf,in,line
    if STRPOS(line,'in') NE -1 then readf,in,infile
    infile=strtrim(infile,2)
    readf,in,line
    if STRPOS(line,'out') NE -1 then readf,in,outfile 
    outfile=strtrim(outfile,2)
    out1=outfile
    openpff,infile,fileid=1
    readstr,1
    temp=maxstr(1,5,min=temp1)
    print,'Range is ',temp,' to ',temp1

    lvl2=5.0
    level_loop: plotstr,1,cn=2,lev=[0,lvl2],/therm
    print,'is this level acceptable? (y/n)'
    read,ans
    if(ans eq 'n') then begin
      print,'type in max level '
      read,lvl2
      goto,level_loop
    endif

    winstr,1,ave=temp2,lev=[0,lvl2]
    printf,out,'range for file ',infile,' was: '
    printf,out,temp,' to ',temp1,' background was :',temp2
    print,'fog is ',temp2
    ; added choice for user to specify fog level from stepwedge - gsd, 9/16/04
    read,'Use this level or a user specified value? (n to change) ',ans
    if ans eq 'n' then read,'What value of fog: ',temp2
    substr,1,0,temp2,2
    createpff,out1
    wristr,2
    closepff,0
    ; do regriding step here so we dont have to save filenames
    ; need to split filename at '_' so that we can rename files
    part=str_sep(outfile,'_')
    print,part[0]
    print,part[1]
    ; gsd 3/28/05
    ; add line to delete image so *_001 files are not created
    delete_file = part[0]+'_unp.pff'
    file_delete,delete_file,/quiet
    if not keyword_set(full) then begin
      pff_regrid,part[0]+'_sub.pff',fit_file, $
        out=part[0]+'_unp.pff',regrid=rgv,/zero_origin
    endif else begin
       pff_regrid,2,fit_file,/str,out=3,/zero,regrid=rgv
       createpff,part[0]+'_unp.pff'
       wristr,3,/full
       closepff
    endelse
       
    rname=part(0)+'_sub.pff'
    ;spawn,"rm -f "+rname
 ;   file_delete,rname
    i=i+1
  endwhile
close,in
close,out
free_lun,out
free_lun,in

return
end
