;
; IDL Widget Interface Procedures. This Code is automatically
;     generated and should not be modified.

;
; Generated on:	04/04/2006 21:51.42
;
pro WID_BASE_0_event, Event

  wTarget = (widget_info(Event.id,/NAME) eq 'TREE' ?  $
      widget_info(Event.id, /tree_root) : event.id)


  wWidget =  Event.top

  case wTarget of

    Widget_Info(wWidget, FIND_BY_UNAME='WID_BUTTON_0'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        OnBrowse, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_FILENAME'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_TEXT_STR' )then $
        OnTypeFilename, Event
    end
    Widget_Info(wWidget, FIND_BY_UNAME='WID_RUN_GIDEON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        OnRun, Event
    end
    else:
  endcase

end

pro WID_BASE_0, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

  Resolve_Routine, 'gideon1_eventcb',/COMPILE_FULL_FILE  ; Load event callback routines

  WID_BASE_0 = Widget_Base( GROUP_LEADER=wGroup, UNAME='WID_BASE_0'  $
      ,XOFFSET=5 ,YOFFSET=5, /col   $
      ,TITLE='Gideon' ,SPACE=3 ,XPAD=3 ,YPAD=3)

  base_1 = widget_base(wid_base_0, /row)
  base_2 = widget_base(wid_base_0, /row)
  base_2a = widget_base(base_2, /col)
  base_2b = widget_base(base_2)
 
  WID_BUTTON_0 = Widget_Button(base_1, UNAME='WID_BUTTON_0'  $
      , VALUE=' Browse ')

  WID_LABEL_0 = Widget_Label(base_1, UNAME='WID_LABEL_0'  $
     ,VALUE='   Filename: ')

  WID_FILENAME = Widget_Text(base_1, UNAME='WID_FILENAME'  $
      ,SCR_XSIZE=387, /editable, /ALL_EVENTS )

  WID_SPOT_ZOOM = Widget_Draw(base_2b, UNAME='WID_SPOT_ZOOM'  $
      ,SCR_XSIZE=256 ,SCR_YSIZE=256)

  base_2a1 = widget_base(base_2a, /row)
  base_2a2 = widget_base(base_2a, /row)
  WID_LABEL_1 = Widget_Label(base_2a1, UNAME='WID_LABEL_1'  $
      ,VALUE='Gamma: ')

  WID_GAMMA = Widget_Text(base_2a1, UNAME='WID_GAMMA' $
      ,/EDITABLE ,VALUE='5.E4'  ,XSIZE=20 )

  WID_LABEL_7 = Widget_Label(base_2a2, UNAME='WID_LABEL_7'  $
      ,VALUE='Mag:   ')

  WID_MAG = Widget_Text(base_2a2, UNAME='WID_MAG'  $
      ,/EDITABLE ,VALUE='6.12', XSIZE=20 )

  base_2a3 = widget_base(base_2a, /column, /align_center)

  WID_LABEL_2 = Widget_Label(base_2a3, UNAME='WID_LABEL_2'  $
      ,VALUE='  ')
  WID_LABEL_2 = Widget_Label(base_2a3, UNAME='WID_LABEL_2'  $
      ,VALUE='Spot data: ')

  base_3a = widget_base(base_2a, /column)
  base_3a1 = widget_base(base_3a, /row)
  base_3a2 = widget_base(base_3a, /row)
  base_3a3 = widget_base(base_3a, /row)
  base_3a4 = widget_base(base_3a, /row)

  WID_LABEL_4 = Widget_Label(base_3a1, UNAME='WID_LABEL_4'  $
      ,VALUE='Mean: ')

  WID_LABEL_5 = Widget_Label(base_3a2, UNAME='WID_LABEL_5'  $
      ,VALUE='Min:  ')

  WID_LABEL_3 = Widget_Label(base_3a3, UNAME='WID_LABEL_3'  $
      ,VALUE='Max:  ')

  WID_LABEL_6 = Widget_Label(base_3a4, UNAME='WID_LABEL_6'  $
      ,VALUE='SD:   ')


  WID_SPOT_MEAN = Widget_Text(base_3a1, UNAME='WID_SPOT_MEAN'  $
      , XSIZE=20)

  WID_SPOT_MIN = Widget_Text(base_3a2, UNAME='WID_SPOT_MIN'  $
      , XSIZE=20)

  WID_SPOT_MAX = Widget_Text(base_3a3, UNAME='WID_SPOT_MAX'  $
      , XSIZE=20)

  WID_SPOT_SD = Widget_Text(base_3a4, UNAME='WID_SPOT_SD'  $
      , XSIZE=20)


  base_4 = widget_base(wid_base_0, /row)
  base_4a = widget_base(base_4, /nonexclusive, /row)
  base_4b = widget_base(base_4, /row)
  

  WID_USE_DOSE_UNITS = Widget_Button(base_4a, /align_left, $
      UNAME='WID_USE_DOSE_UNITS', VALUE='Use Dose Units')

  WID_RUN_GIDEON = Widget_Button(base_4b, UNAME='WID_RUN_GIDEON'  $
      ,/ALIGN_CENTER ,VALUE='  Run Gideon  ')

  base_5 = widget_base(wid_base_0, /row, /nonexclusive)

  WID_KILL_EDGE = Widget_Button(base_5, UNAME='WID_KILL_EDGE'  $
      ,/ALIGN_LEFT ,VALUE='edge pic')


  WID_KILL_EDGE_ZOOM = Widget_Button(base_5,  $
      UNAME='WID_KILL_EDGE_ZOOM' ,/ALIGN_LEFT ,VALUE='edge zoom')


  WID_KILL_FULL = Widget_Button(base_5, UNAME='WID_KILL_FULL'  $
      ,/ALIGN_LEFT ,VALUE='full pic')

  WID_KILL_ZOOM = Widget_Button(base_5, UNAME='WID_KILL_ZOOM'  $
      ,/ALIGN_LEFT ,VALUE='zoom spot')


  Widget_Control, /REALIZE, WID_BASE_0

;code to make wKillFull initial checked insert after call to widget_control /realise line
  wKillFull=Widget_info(WID_BASE_0, find_by_uname="WID_KILL_FULL")
  widget_control, wKillFull, /SET_BUTTON
;end code to make wkillFull initial checked

  XManager, 'WID_BASE_0', WID_BASE_0, /NO_BLOCK

end
;
; Empty stub procedure used for autoloading.
;
pro gideon1, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_, magnification = magnification
    common gideon1_common_mag, mag
    mag =  (n_elements(magnification)eq 0) ? 0.1 : magnification *0.1
  WID_BASE_0, GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
