;    QS plot data
;
;    c_norm      - coordinate direction normal to plot plane
;    t1          - coordinate for plot x axis
;    t1          - coordinate for plot y axis
;    zslice[3]   - plot plane default z-location for three coordinates
;    flip        - flag that plot is flipped from right-handed orientation
;    polar       - flag that plot is in polar coordinates
;    lc1to1      - flag to plot with 1 to 1 aspect ratio
;    lccond      - flag to include conductors on plots
;    lcgrid      - flag to include grid on plots
;    lcbcnd      - flag to include boundary conditions on plots
;    lcdiag      - flag to include diagnostics on plots
;    lcslic      - flag to include slice locations on plots
;    lcurse      - cursor position active
;    binclude[*] - flag to include block in plot
;    xcurse      - 
;    xlabl       - x axis label
;    ycurse      - 
;    ylabl       - y axis label
;    zrange[2,3] - range in three coordinate directions
;
;    Define colors

     RED = 1
     GREEN = 2
     BLUE = 3
     MAGENTA = 4
     ORANGE = 5
     CYAN = 6
     YELLOW = 7

     common qsplotpars, c_norm, zslice, flip, polar, $
            lc1to1, lccond, lcgrid, lcbcnd, lcdiag, lcslic, $
            lcdiel, $
            binclude, xlabl, ylabl, $
            lcurse, xcurse, ycurse, $
            draw, slice, cur_win, old_win, qsinstr, curoper, $
            arr, narray, tempx, tempy, t1, t2, zrange
