; ------------------------------------------------------------------------ 
; $Id: pdb_open_only.pro,v 1.4 2007/06/06 19:45:14 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro pdb_open_only, p1, lstr, mode, ndset, pid, error
;
; open a pdb file
;
;
@pdbcom.dat
      on_error, 1
;

      lstr = 192L
      error = 0L
      ndset = 0L
      pid = 0L
      if n_elements(mode) eq 0 then mode = 1L else mode = long(mode)

      str2byt, p1, p3, lstr
;
      if initpdb eq 1 then begin
; HP
        junk = call_external(PDB_EXE, 'pdb_open', p3, lstr, mode, ndset, error)
      endif else if initpdb eq 2 then begin
; Sun
        junk = call_external(PDB_EXE, 'pdb_open_', p3, lstr, mode, ndset, error)
      endif else if initpdb eq 4 then begin
; WIN
       junk = call_external(PDB_EXE, '_PDB_OPEN@8', p3, lstr, mode, ndset, error)
      endif else if initpdb eq 5 then begin
; MAC
       junk = call_external(PDB_EXE, 'pdb_open', p3, lstr, mode, ndset, error)
      endif
      if error gt 0 then pid = error
      end
