; ------------------------------------------------------------------------ 
; $Id: endgif.pro,v 1.6 2009/11/03 16:51:47 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro endgif
;+
;  Revert to previous settings
;     If a BIGWIN was called, the PIXMAP is deleted.
;-
on_error,1 
   common big_window_common, big_window
   common swap_common, lcswap

   common switchgif,xythicksave,thicksave,oldthick,oldxythick,oldfont, $
      gif_file, font_default, no_swap, character_size, file_number, $
      lc_gif_output, old_character_size
   if n_elements(lcswap) eq 0 then lcswap = 0
   if n_elements (big_window) eq 1 && big_window ne 0 then begin
     wdelete
;    set flag to 0 to avoid multiple deletes
     big_window=0
   endif
   if n_elements(lc_gif_output) eq 0 then lc_gif_output= 0
   if lc_gif_output eq 0 then begin
     print, '% ENDGIF: Device is not in gif output mode. ENDGIF is ignored.'
     print, '          Use STARTGIF to put into GIF,TIFF, and PICT mode'
     return
   endif

   lc_gif_output = 0
   if !d.name eq 'X' or !d.name eq 'TEK' or !d.name eq 'WIN' $
         or !d.name eq 'MAC' then begin
     !x.thick= oldxythick
     !y.thick= oldxythick
     !z.thick= oldxythick
     !p.thick= oldthick
     !p.font = oldfont
     device, set_character_size = old_character_size
   endif
   if (no_swap eq 0 ) then invertct, /reset else $
     if no_swap lt 0 then swap 
   if  not lcswap then begin
     temp = !p.color
     !p.color = !p.background
     !p.background = temp
   endif
   end
