; ------------------------------------------------------------------------ 
; $Id: ps2x.pro,v 1.5 2010/09/17 21:20:35 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro ps2x
;+
;   switch from a postscript file to X windows
;
;   format: ps2x
;        sets the output device to xwindows
;-
;
@switchpost.com
common swap_common, lcswap

on_error, 1
   if n_elements (lcopen) eq 0 then lcopen = 0
   if n_elements(lcswap) eq 0 then lcswap = 0
   if lcopen eq 0 then begin
     print, ' Use SET_PLOT, "x" no PostScript Files are open'
     return
   endif
   if !d.name eq 'PS' then begin
     get_ps_device_param, xsize = xsize, ysize =ysize, orientation = orientation, $
       xoffset = xoffset, yoffset = yoffset
     if orientation eq 'Portrait' then begin
       p_xoffset = xoffset
       p_yoffset = yoffset
       p_xsize = xsize
       p_ysize = ysize
     endif else begin
       l_xoffset = xoffset 
       l_yoffset = yoffset
       l_xsize = xsize 
       l_ysize = ysize
     endelse
   endif
   if !d.name ne olddevice then $
     set_plot, olddevice, copy = oldcopy, interpolate = oldinterpolate
   if n_elements(noloadsave) eq 0 then noloadsave = 0
   if noloadsave eq 0 then loadxyct
   if lcswap then begin
     temp = !p.color
     !p.color = !p.background
     !p.background = temp
   endif

   !x.thick= oldxythick
   !y.thick= oldxythick
   !z.thick= oldxythick
   !p.thick= oldthick
   !p.font = oldfont
   end

