; ------------------------------------------------------------------------ 
; $Id: delete_tqpnts.pro,v 1.3 2007/06/06 20:12:40 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 PRO  delete_tqpnts, array
;
;  Common Blocks
;
@pfidltq.com
;
@tqeditevent.com
;
      on_error, 1
      ncon = cond.ncon
      if lcsegment lt 1 or lcsegment gt ncon then message, $
        'Bad conductor segment - '+ strtrim(lcsegment, 2) + string(ncon)
        old_cond = cond
      if lcmode eq 'COND' then begin
        loc = cond.locx
        np = loc(lcsegment)-loc(lcsegment-1)
        del = array(1)- array(0)
        if del lt 0 then begin
          array = [array(1), array(0)]
          del = -del
        endif
        if np -del lt 3 then begin
          winformation, ' Cannot delete a conductor to less than 2 points'
          return
        endif
        xxx = cond.x
        yyy = cond.y
        xx = cond.x(loc(lcsegment-1):loc(lcsegment)-1)
        yy = cond.y(loc(lcsegment-1):loc(lcsegment)-1)
        if array(0) eq 0 then begin
          xx = xx(array(1)+1: *)
          yy = yy(array(1)+1: *)
        endif else if array(1) lt  np-1  then begin
          xx = [xx(0:array(0)-1), xx(array(1)+1:*)]
          yy = [yy(0:array(0)-1), yy(array(1)+1:*)]
        endif else begin
          xx = xx (0:array(0)-1)
          yy = yy (0:array(0)-1)
        endelse
        array2pack, lcsegment, ncon, loc, np-del, xxx, xx, yyy, yy
        cond = {ncon:ncon, lcfit:0, x:xxx, y:yyy, locx:loc, $
             ix:cond.ix, iy:cond.iy, loci:cond.loci, iplotx:cond.iplotx, $
             iploty:cond.iploty, locp:cond.locp, $
             badxy:cond.badxy, locb:cond.locb, nbad:cond.nbad }
      endif else begin
        loc = cond.loci
        np = loc(lcsegment)-loc(lcsegment-1)
        del = array(1)- array(0)
        if del lt 0 then begin
          array = [array(1), array(0)]
          del = -del
        endif
        if np -del lt 3 then begin
          winformation, ' Cannot delete a conductor to less than 2 points'
          return
        endif
        xxx = cond.ix
        yyy = cond.iy
        xx = cond.ix(loc(lcsegment-1):loc(lcsegment)-1)
        yy = cond.iy(loc(lcsegment-1):loc(lcsegment)-1)
        if array(0) eq 0 then begin
          xx = xx(array(1)+1: *)
          yy = yy(array(1)+1: *)
        endif else if array(1) lt  np-1  then begin
          xx = [xx(0:array(0)-1), xx(array(1)+1:*)]
          yy = [yy(0:array(0)-1), yy(array(1)+1:*)]
        endif else begin
          xx = xx (0:array(0)-1)
          yy = yy (0:array(0)-1)
        endelse
        array2pack, lcsegment, ncon, loc, np-del, xxx, xx, yyy, yy
        cond = {ncon:ncon, lcfit:cond.lcfit, x:cond.x, y:cond.y, $
             locx:cond.locx, ix:xxx, iy:yyy, loci:loc, iplotx:cond.iplotx, $
             iploty:cond.iploty, locp:cond.locp, $
             badxy:cond.badxy, locb:cond.locb, nbad:cond.nbad }
        get_tqplotpnts
        get_tqbad
      endelse
      return
      end
