; ------------------------------------------------------------------------ 
; $Id: get_tqgrid.pro,v 1.3 2007/06/06 20:12:41 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function get_tqgrid , xp, yp
; get closest grid point to xp, yp
@pfidltq.com
 on_error, 1
 if n_elements (xp) eq 0 or n_elements(yp) eq 0 then message, $
    'Input parameters must be defined.'
 if n_elements (gx) eq 0 or n_elements(gy) eq 0 then message, $
    'Grid parameters must be defined.'
 junk = min(abs(gx-xp), i)
 junk = min(abs(gy-yp), j)
 return, [i, j]
 end
