; ------------------------------------------------------------------------ 
; $Id: get_tqstring.pro,v 1.6 2010/09/29 20:59:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro get_tqstring_event, event

    common get_tqstr_com, sel_offset

     on_error, 1 
    but = event.value
    widget_control, event.top, get_uvalue = info, /no_copy
    case but of 

 'QUIT' : BEGIN
          quitit = 1
          varname = ''
          comment = ''
          END
 'OK' : BEGIN
          quitit = 0
          widget_control,info.var, get_value = varname 
          widget_control, event.top, tlb_get_offset = sel_offset
          END
     ELSE: Print, ' Not a known event'
     endcase
     value = {varname: varname, quit: quitit}
     widget_control, info.ptr, set_uvalue = value, /no_copy
     widget_control, event.top, /destroy
     end

 Pro get_tqstring, lcquit, Prompt, string2, xsize = xsize , title = title, $
           group = group, modal = modal, offset = offset
     on_error, 1 
     common get_tqstr_com, sel_offset
     if n_elements (xsize) eq 0 then xsize = 60
     if n_elements(title) eq 0 then title = 'Conductor Parameters'
     if n_elements (group) eq 0 then group = 0
     base = widget_base(/column, title= title, group = group, modal = modal)
     lcquit = 1
     if n_elements(offset) eq 0 then begin
       offset = [10,10]
       if n_elements(sel_offset) eq 0 then sel_offset = offset
     endif else sel_offset = offset
     if n_elements (prompt) eq 0 then message, ' Prompt must be provided'
     if n_elements (string2) eq 0 then string2 = ''
     Var = cw_field(base, title= prompt, xsize = xsize, $
           value = string2)
     menu = make_array(2, /string)
     menu(0) = '            OK           ' 
     menu(1) = ' Quit Without Saving '
     but = cw_bgroup(base,menu,/row, /NO_RELEASE,button_uvalue =['OK','QUIT'])
     ptr = widget_base(group = group)

     if n_elements(sel_offset) eq 0 then begin
       if !d.window lt 0 then sel_offset = [10, 20] else begin
         device, get_window_position = sel_offset
       endelse
     endif

     WIDGET_CONTROL, base, /REALIZE, tlb_set_xoffset = sel_offset[0], $
            tlb_set_yoffset = sel_offset[1]
     widget_control, base, tlb_get_offset = offset_real
     offset_shift= sel_offset-offset_real
     info = {var: var,  ptr:ptr}
     widget_control, base, set_uvalue = info
     value = {varname:'',  quit:0}
     widget_control, ptr, set_uvalue = value
     xmanager, 'get_tqstring', base
     widget_control, ptr, get_uvalue = value
     widget_control, ptr, /destroy
     lcquit = value.quit
     string2 = strtrim(value.varname, 2)
     sel_offset = sel_offset + offset_shift
     offset = sel_offset
     return
     end
