; ------------------------------------------------------------------------ 
; $Id: mk_block_textstr.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Function mk_block_textstr,block
;
; convert block limits to a string
; assume block of the form: block(2,3, nblock)
       on_error, 1

      nel = n_elements(block)
      if nel eq 0 then return, '0'
      nblock = nel/6
      str = make_array(nblock, /string)
      for i =0, nblock-1 do $
      str(i) = string(format='(a, t13, a, t25, a, t37, a, t49, a, t61, a)', $
           strtrim(block(0, 0, i), 2), strtrim(block(0, 1, i), 2), $
           strtrim(block(0, 2, i), 2), strtrim(block(1, 0, i), 2), $
           strtrim(block(1, 1, i), 2), strtrim(block(1, 2, i), 2)) 
      return, str
      end
