; ------------------------------------------------------------------------ 
; $Id: copyright_notice.pro,v 1.3 2007/05/30 21:48:35 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro copyright_notice_event, event
 widget_control, event.top, /destroy
 end


 pro copyright_notice

common copyright_common, copyright_init
      on_error, 1
catch, TheError
if TheError eq 0 then copyright_init = widget_base(/col, $
 title = 'PFIDL Copyright Notice')
if n_elements(copyright_init) eq 0 then copyright_init = 1L
catch, /cancel
if TheError ne 0 then begin
  print, ' '
  print, $
' Copyright 2007, Sandia Corporation. Under the terms of'
  print, $
' Contract DE-AC04-94AL85000, there is a non-exclusive license'
  print, $
' for use of this work by or on behalf of the U.S. Government.'
  print, $
' Export of this data may require a license from the'
  print, $
' United States Government.'
  print, ' '
  return
endif

; Remove comment from the next line to eliminate copyright notice.
; if copyright_init gt 0 then return


base = widget_base(copyright_init, frame = 6, /column)
text = widget_label(base, /align_left, value =  $
'Copyright 2007, Sandia Corporation. Under the terms of')
text = widget_label(base, /align_left, value =  $
'Contract DE-AC04-94AL85000, there is a non-exclusive license')
text = widget_label(base, /align_left, value =  $
'for use of this work by or on behalf of the U.S. Government.')
text = widget_label(base, /align_left, value =  $
'Export of this data may require a license from the')
text = widget_label(base, /align_left, value =  $
'United States Government.')
text = widget_label(base,  value = '') 
basen = widget_base(base, /column, frame = 3)
text = widget_label(basen, /align_center, value =  $
' NOTICE: ')
text = widget_label(basen,/align_left,  value =  $
'Neither the United States Government nor the United States')
text = widget_label(basen, /align_left, value =  $
'Department of Energy, nor Sandia Corporation, nor any of their')
text = widget_label(basen, /align_left, value =  $
'employees makes any warranty, express or implied, or assumes')
text = widget_label(basen, /align_left, value =  $
'any legal liability or responsibilitity for the accuracy,')
text = widget_label(basen, /align_left, value =  $
'completeness, or usefulness of any information, apparatus,')
text = widget_label(basen, /align_left, value =  $
'product, or process disclosed, or represents that its use')
text = widget_label(basen, /align_left, value =  $
'would not infringe privately owned rights.')
text = widget_label(basen,  value = '') 

base_two = widget_base(base, /column, frame= 1)
text = widget_label(base_two,  value =  $
'To elimintate this copyright notice from future PFIDL sessions,')
text = widget_label(base_two,  value =  $
'put "ACCEPT_COPYRIGHT" in the IDL_STARTUP file')

but = widget_button(copyright_init , value = '   I ACCEPT   ')
widget_control, copyright_init , /realize
xmanager, 'copyright_notice', copyright_init 
end
