; ------------------------------------------------------------------------ 
; $Id: get_dxvalue.pro,v 1.3 2007/06/06 19:34:27 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function get_dxvalue, percent
;
@mitl_common.com
;
  on_error, 2

 if n_elements (percent) eq 0 then percent = 0.1
 dx = str.pos(1:str.npos-1)- str.pos(0:str.npos-2)
 dzvac = (str.zvac(1:str.npos-1)- str.zvac(0:str.npos-2))/str.zvac(0:str.npos-2)
 okz = where (dzvac gt 1.0e-5, nokz)
 if nokz gt 0 then  $
   return,  min(dx(okz)/dzvac(okz))*percent $
 else return, (str.pos(str.npos-1)-str.pos(0))*percent
 end
