; ------------------------------------------------------------------------ 
; $Id: get_float_value.pro,v 1.2 2007/06/06 19:34:28 lpmix Exp $
; ------------------------------------------------------------------------ 
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 pro get_float_value_event, event
   on_error, 1
   widget_control, event.id, get_uvalue = uval
   if uval eq 'VAL' then return
   widget_control, event.top, get_uvalue = ptr
   widget_control, (*ptr).wbut, get_value = val
   (*ptr).val = val
   widget_control, event.top, /destroy
   end
   
 pro get_float_value, value, instructions = instruc, title = title
   on_error, 1
   if n_elements(title) eq 0 then title = 'Enter Desired Value'
   
   tlb = widget_base(title = title, /column)
   if keyword_set(instruc) then $
     winst= widget_label(tlb, value = instruc)
   val = 0.0
   wfield = cw_field(tlb, /floating, title='Enter Value', $
            uvalue = 'VAL', value  = val )
   wdone = widget_button(tlb, value = '  D O N E  ', uvalue = 'DONE')
   widget_control, tlb, /realize
   ptr = ptr_new({wbut:wfield, val:val})
   widget_control, tlb, set_uvalue = ptr
   xmanager, 'get_float_value', tlb
   value = (*ptr).val
   ptr_free, ptr
   end
