; ------------------------------------------------------------------------ 
; $Id: get_save_array.pro,v 1.5 2007/06/06 19:34:29 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Function  Get_Save_array, wdf1, wdf2, new = new, all = all
;
;+
;     This procedure returns a valid save array in the function
;      wdf1 is tried first, then an unused WDF array, then 
;      WDF2 is the default.
;-
;
 COMPILE_OPT hidden
@com.dat
;
      
      if n_elements (wdf1) ne 0 and not keyword_set(new) then begin
        if wdf1(0) gt 0 and wdf1(0) le maxwdfarray then return, wdf1
      endif
      ok = where (wdfnp eq 0, nok)
      if keyword_set(all) then return, ok+1
      if nok gt 0 then return, (ok(0)+1) else return, wdf2
      end
