; ------------------------------------------------------------------------ 
; $Id: get_wdf_comment.pro,v 1.3 2007/06/06 19:34:29 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function get_wdf_comment, option, node, x, y 
;+
; get data from common block to  use for the save command
;
;-
;
opt = round(option)
if n_elements (option) eq 0 then return, ''
if (opt mod 2) eq 1 then comm= ', Node '+strtrim(node, 2) else comm = ''

; Bit 2
opt = opt/2
if (opt mod 2) eq 1 then comm=comm+ ', X = '+strtrim(x, 2)


; Bit 3
opt = opt/2
if (opt mod 2) eq 1 then comm=comm+ ', Pt = ( '+strtrim(x, 2) +', ' +  $
   strtrim(y,2) + ')'
m = strlen(comm)
if m gt 0 then comm= strmid(comm, 2, m)
return, comm
end
