; ------------------------------------------------------------------------ 
; $Id: get_zoom_values.pro,v 1.3 2007/06/06 19:34:29 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro get_zoom_values, info, x1, x2, maximum = maximum
@mitl_common.com
;
   x1 = 0.0
   x2 = 0.0
 if str.np lt 2 then return
 xmin = min(str.x, max = xmax)
;
 if keyword_set(maximum) then begin
   widget_control, info.zoommin, set_value =[xmin, xmin, xmax]
   widget_control, info.zoommax, set_value = [xmax, xmin, xmax]
   return
 endif
 widget_control, info.zoommin, get_value = x1
 widget_control, info.zoommax, get_value = x2
 if x1 eq x2 then begin
   del = max(abs([xmin, xmax]))*0.001
   x1= x1-del> xmin
   x2= x2+del< xmax
 endif
 if x1 eq xmin and x2 eq xmax then begin
   x1 = 0.0
   x2 = 0.0
   widget_control, info.zoommin, set_value =[xmin, xmin, xmax]
   widget_control, info.zoommax, set_value = [xmax, xmin, xmax]
   return
 endif
 widget_control, info.zoommin, set_value =[x1, xmin, x2]
 widget_control, info.zoommax, set_value = [x2, x1, xmax]
 return
 end
