; ------------------------------------------------------------------------ 
; $Id: remove_control.pro,v 1.3 2007/06/06 19:34:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

function remove_control, str_var
;
; remove control characters from a string variable
;
 on_error, 2
  varb = string(str_var)
  varb = byte(temporary(varb))
  ok = where (varb ge 32B, nok)
  if nok gt 0 then return, string(varb[ok]) else return , ''
end
