; ------------------------------------------------------------------------ 
; $Id: resolve_it.pro,v 1.6 2007/06/06 19:34:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

pro resolve_it, current

 COMPILE_OPT hidden

on_error, 2

if  strmatch(current, '/.automount/*') eq 0b then return

;  user files
if strmatch(current, '/.automount/*/users*/*') then begin
  if strmatch(current,'/.automount/sadl16274/archive/archive/users*') then begin
    current = '/archive/users'+strmid(current, 43)
    return
  endif 
  i = strpos(current, 'users')
  j = strpos(current, '/', i+5)
  current = '/remote'+strmid(current, j)
  return
endif

; RSI files
if strmatch(current, '/.automount/sonic/opt/rsi*') then begin
  current = strmid(current,strpos(current, '/opt/rsi'))
  return
endif

; qsvm
if strmatch(current, '/.automount/luigi/qsvm*') then begin
  current = strmid(current,strpos(current, '/qsvm'))
  return
endif

;pff_data
if strmatch(current, '/.automount/sahp3021/disk?/pff_data*') then begin
  current = strmid(current,strpos(current, '/pff_data'))
  return
endif

; atheta files
if strmatch(current, '/.automount/luigi/opt/atheta*') then begin
  current = strmid(current,strpos(current, '/opt/atheta'))
  return
endif

end


