; ------------------------------------------------------------------------ 
; $Id: str2byt.pro,v 1.3 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  pro str2byt, p1, p2, L
;     this routine converts a character string, p1, to a byte string, p2, of 
;        length, L
      p2 = make_array(L, /byte, value = 32b)
      i = strlen(p1)
      if i eq 0 then return
      if (i le L) then $
        p2(0:i-1) =byte(p1) else $
        p2 = byte (strmid(p1, 0, L))
      return
      end
