; ------------------------------------------------------------------------ 
; $Id: get_analysis_values.pro,v 1.3 2007/06/06 20:13:43 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
;

PRO get_anal_values_event, Event

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 

  'RUN/QUIT': BEGIN
      widget_control, event.top, get_uvalue= ptr, tlb_get_offset= offset
      CASE Event.value OF
      0: Begin
         fields = (*ptr).field
         values = (*ptr).values
         nfields = (*ptr).nfield
         for i = 0, nfields-1 do begin
           widget_control, fields[i], get_value = val
           values[i]= val
         endfor
         (*ptr).values = values
         (*ptr).offset = offset
         widget_control, event.top, /destroy
         END

      1: Begin
         (*ptr).lcquit = 1
         widget_control, event.top, /destroy
         End
      ENDCASE
      END
    ELSE: 
  ENDCASE
END


PRO get_analysis_values,lcquit, labels, values,  offset, $
     title = title, instructions = instructions, GROUP=Group


  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  if n_elements(title) eq 0 then title='Enter Analysis Values'

  tlb= WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1,  MAP=1, TITLE= title)
  nval = min([ n_elements(labels),n_elements(values)])
  field = make_array(nval, /long)

  BASE17 = WIDGET_BASE(tlb, COLUMN=1, $
      FRAME=4, MAP=1)

  if n_elements(instructions) gt 0 then $
    LABEL14 = WIDGET_LABEL( BASE17, VALUE= instructions)
  
  for i = 0, nval -1 do $
   field[i] = CW_FIELD( BASE17,VALUE=values[i], $
      ROW=1, $
      float=1, $
      TITLE=labels[i]+':', $
      UVALUE='FIELD'+string(i))


  BASE21 = WIDGET_BASE(tlb, $
      ROW=1, $
      MAP=1, $
      UVALUE='BASE21')

  Btns557 = [ '   Run  ', '  QUIT  ' ]

  BGROUP22 = CW_BGROUP( BASE21, Btns557, $
      ROW=1, $
      SPACE=100, $
      UVALUE='RUN/QUIT')

  if n_elements (offset) lt 2  then offset = [10, 10] else $
    offset = (offset(0:1)> 0)
  WIDGET_CONTROL, tlb, /REALIZE, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)

   ptr = ptr_new({lcquit:0, field: field, nfield : nval, $
           values:values, offset:offset})
   widget_control, tlb, set_uvalue = ptr


     widget_control, tlb, tlb_get_offset= offset_real
     offset_real = offset  - offset_real

  XMANAGER, 'get_anal_values', tlb
  lcquit = (*ptr).lcquit
  if lcquit eq 0 then begin
    values = (*ptr).values
    offset = (*ptr).offset  + offset_real
  endif
  ptr_free, ptr
  end
