 Pro calculate_bvalue, volt, energy, D, eff, B, c4
  np = n_elements(energy)
  emax = 1.05*energy[np-1]
  ss = size(eff)
; we have one less harmonics than columns
  harmonics = 2+findgen(ss[1]-1)
  b =double( volt/c4)
  for i = np-1, 0, -1 do begin
    vv = energy[i]*harmonics
    ok = where (vv lt emax, nok)
    if nok gt 0  then begin
      vv = vv[ok]
      v = findex(energy, vv) 
      iv = floor(v) 
      frac = v-iv
      if (iv[nok-1] eq np-1) then begin
        iv[nok-1] = np-2
        frac[nok-1] = frac[nok-1]+1.0
      endif
      for ii = 0, nok-1 do $
        b[i]=b[i]-(b[iv[ii]] +frac[ii]*(b[iv[ii]+1]-b[iv[ii]]))*eff[ii+1, i]
    endif
    b[i]=b[i]/eff[0, i]
;    d[*, i]=b[i]*eff[*, i]
  endfor
  end
