

pro Exray_BASE_event, Event, exrayptr


  wWidget =  Event.top
  Widget_Control, wWidget, get_uvalue = exraystr

;***********************Printer Selection (on unix)*****************************
  if (!Version.OS_FAMILY eq 'unix') then $
  if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
     printer=''
     widget_control,Event.id,get_uvalue = printer
     if (n_elements(printer) ne 0) then $
     for i=0,n_elements(exraystr.printers)-1 do begin
       if (printer eq 'Printer #'+strtrim(string(i),2)) then begin
         set_printer,dest=exraystr.printers(i)
         exraystr.activeprinter=i
        endif
     endfor
  endif
;*******************************************************************************


  case Event.id of

;**************************** Options Handling ************************************
    Widget_Info(wWidget, FIND_BY_UNAME='GraphOps_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_graphopt,wWidget
        Widget_Control,wWidget,get_uvalue=exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='FitOps_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_scaleopt,wWidget
        Widget_Control,wWidget,get_uvalue=exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RayOps_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_rayopt,wWidget
        Widget_Control,wWidget,get_uvalue=exraystr
      endif
    end
;**************************** Calculations Handling ************************************
    Widget_Info(wWidget, FIND_BY_UNAME='Filter_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_filter,wWidget
        widget_control,wWidget,get_uvalue=exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='D2I_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_d2iwidget,wWidget
        widget_control,wWidget,get_uvalue=exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Eff_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_effwidget,wWidget
        widget_control,wWidget,get_uvalue=exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='ScaleCalc_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (exraystr.plotflag ge 3) then begin
           if (exraystr.plotflag eq 3) then $
              xfr,exraystr.datawdf(exraystr.activedata),104 $
           else $
              xfr,exraystr.scaledwdf(exraystr.activedata),104
           xfr,104,105
           exray_scalermath,wWidget
        endif
        widget_control,wWidget,get_uvalue=exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Polynomial_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_reltranswidget,wWidget
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='BackCurve_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_backdivide,wWidget
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Batch_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_batchwidget,wWidget
        Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
    ;**************************** File Handling ************************************
    Widget_Info(wWidget, FIND_BY_UNAME='OpenSession_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        goto, openjump1
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='OpenData_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        goto, openjump2
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Open_InputFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        openjump1:
        exray_openfile, wWidget
        widget_control,wWidget,get_uvalue=exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Open_DataFile_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        openjump2:
        exray_opendata, exraystr
        if (exraystr.datafile(exraystr.activedata) ne 'none') then begin
           index = where(exraystr.datafile ne 'none')
           widget_control,exraystr.widget.DataFile,SET_VALUE=exraystr.datafile(index)
           widget_control,exraystr.widget.DataFile,SET_DROPLIST_SELECT=exraystr.activedata
           exraystr.dataOK = 1
           ;Add the data option to the plotting list
           exraystr.plotflag=2 ;force the plotter to re-calculate the plot range
           index=where(exraystr.scaleflag eq 1)
           if (index(0) lt 0) then $
              widget_control,exraystr.widget.plotlist,SET_VALUE= $
                 [ 'Ray-Tracing','Dispersion','Resolution','Data' ]
           widget_control,exraystr.widget.plotlist,set_droplist_select=3
           widget_control,exraystr.widget.plotlist,send_event=$
              { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:wWidget, $
              HANDLER:wWidget, INDEX:3 }
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Data_Filename'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
        if exraystr.dataOK eq 1 then $
         for i=0,9 do begin
            if (Event.index eq i) then begin
               exraystr.activedata=i
               exraystr.plotflag = 2 ;force the plotter to re-calculate the plot-range
               widget_control,wWidget,set_uvalue=exraystr
               widget_control,exraystr.widget.plotlist,set_droplist_select = 3
               widget_control,exraystr.widget.plotlist,send_event=$
                 { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:wWidget, $
                 HANDLER:wWidget, INDEX:3 }
            endif
         endfor
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='CloseData_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (exraystr.datafile(exraystr.activedata) ne 'none') then begin
           exraystr.datafile(exraystr.activedata) = 'none'
           exraystr.scaleflag(exraystr.activedata) = 0
           exraystr.numdata = exraystr.numdata-1
           for i=exraystr.activedata,8 do begin
              exraystr.datafile(i)=exraystr.datafile(i+1)
              exraystr.datawdf(i)=exraystr.datawdf(i+1)
              exraystr.scaledwdf(i)=exraystr.scaledwdf(i+1)
              exraystr.scaleflag(i) = exraystr.scaleflag(i+1)
           endfor
           exraystr.activedata=0
           index = where(exraystr.datafile ne 'none')
           if (index(0) lt 0) then begin
              exraystr.dataOK = 0
              widget_control,exraystr.widget.plotlist,SET_VALUE= $
                 [ 'Ray-Tracing','Dispersion','Resolution']
              widget_control,exraystr.widget.plotlist,set_droplist_select= exraystr.plotflag
              widget_control,exraystr.widget.DataFile,SET_VALUE=['none']
           endif else begin
              index2=where(exraystr.scaleflag eq 1)
              if (index2(0) lt 0) then begin
                 widget_control,exraystr.widget.plotlist,SET_VALUE= $
                    [ 'Ray-Tracing','Dispersion','Resolution','Data' ]
                 widget_control,exraystr.widget.plotlist,set_droplist_select= exraystr.plotflag
              endif
              widget_control,exraystr.widget.DataFile,SET_VALUE=exraystr.datafile(index)
              widget_control,exraystr.widget.DataFile,SET_DROPLIST_SELECT=exraystr.activedata
              if (exraystr.plotflag eq 3) then begin
                 widget_control,exraystr.widget.plotlist,set_droplist_select=3
                 exraystr.plotflag = 2 ;force the plotter to re-calculate the plot-range
                 widget_control,exraystr.widget.plotlist,send_event=$
                    { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:wWidget, $
                    HANDLER:wWidget, INDEX:3 }
              endif
           endelse
        endif
      endif
    end
;********************************************************************************
    Widget_Info(wWidget, FIND_BY_UNAME='Elliptical_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        Widget_Control, exraystr.widget.convex, MAP=0
        Widget_Control, exraystr.widget.elliptical, MAP=1
        exray_initial,wWidget
        widget_control,wWidget,get_uvalue=exraystr
        exraystr.convexflag=0
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Convex_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        Widget_Control, exraystr.widget.elliptical, MAP=0
        Widget_Control, exraystr.widget.convex, MAP=1
        exray_convex_initial,wWidget
        widget_control,wWidget,get_uvalue=exraystr
        exraystr.convexflag=1
      endif
    end

;******************* Elliptical Data input Controls *****************************
    Widget_Info(wWidget, FIND_BY_UNAME='Config_DROPLIST'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
         if (Event.index eq 0) then exray_config,exraystr,/dds $
         else if (Event.index eq 1) then exray_config,exraystr,/ss $
         else if (Event.index eq 2) then exray_config,exraystr,/ts $
         else if (Event.index eq 3) then exray_config,exraystr,/us $
         else if (Event.index eq 4) then exray_config,exraystr,/xs $
         else if (Event.index eq 5) then exray_config,exraystr,/dde $
         else if (Event.index eq 6) then exray_config,exraystr,/ve $
         else if (Event.index eq 7) then exray_config,exraystr,/xe $
         else if (Event.index eq 8) then exray_config,exraystr,/new
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Xstal_DROPLIST'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
         if (Event.index eq 0) then exray_xstal,exraystr,/adp $
         else if (Event.index eq 1) then exray_xstal,exraystr,/kap $
         else if (Event.index eq 2) then exray_xstal,exraystr,/mica $
         else if (Event.index eq 3) then exray_xstal,exraystr,/pet $
         else if (Event.index eq 4) then exray_xstal,exraystr,/quartz1010 $
         else if (Event.index eq 5) then exray_xstal,exraystr,/quartz1011 $
         else if (Event.index eq 6) then exray_xstal,exraystr,/new
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='EditGroups_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_groupwidget,wWidget
        Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Order1_FIELD'): begin
           tmp = long(0)
           widget_control,exraystr.widget.Order1,GET_VALUE=tmp
           exraystr.wsource(*).n(0)=tmp(0)
    end
    Widget_Info(wWidget, FIND_BY_UNAME='AutoConfig_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.autoflag = 0
           Widget_Control,exraystr.widget.EditGroups,SENSITIVE=1
           Widget_Control,exraystr.widget.Lambda1,SENSITIVE=1
           Widget_Control,exraystr.widget.Beta1,SENSITIVE=1
           Widget_Control,exraystr.widget.Series1,SENSITIVE=1
           Widget_Control,exraystr.widget.Specific1,SENSITIVE=1
        endif else begin
           exraystr.autoflag = 1
           exraystr.lamset(0) = 0
           exraystr.serset(0) = 1
           exraystr.wsource(*).lambda(*,*)=0.
           exraystr.wxstal(*).beta(*,*)=0.
           exraystr.wxstal(*).beta(0,0)=exraystr.wxstal(*).betamin
           exraystr.wxstal(*).beta(0,1)=exraystr.wxstal(*).betamax
           exraystr.wxstal(*).beta(0,2)= $
              (exraystr.wxstal(*).betamax-exraystr.wxstal(*).betamin)/exraystr.wnumlambda
           exraystr.groupOK = 1
           Widget_Control,exraystr.widget.EditGroups,SENSITIVE=0
           Widget_Control,exraystr.widget.Lambda1,SENSITIVE=0
           Widget_Control,exraystr.widget.Beta1,SENSITIVE=0
           Widget_Control,exraystr.widget.Series1,SENSITIVE=0
           Widget_Control,exraystr.widget.Specific1,SENSITIVE=0
           Widget_Control,exraystr.widget.Beta1,SET_BUTTON = 1
           Widget_Control,exraystr.widget.Lambda1,SET_BUTTON = 0
           Widget_Control,exraystr.widget.Series1,SET_BUTTON = 1
           Widget_Control,exraystr.widget.Specific1,SET_BUTTON = 0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Lambda1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.lamset(0) = 0
        endif else begin
           exraystr.lamset(0) = 1
           Widget_Control,exraystr.widget.Beta1,SET_BUTTON = 0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Beta1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.lamset(0) = 1
        endif else begin
           exraystr.lamset(0) = 0
           Widget_Control,exraystr.widget.Lambda1,SET_BUTTON = 0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Series1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.serset(0) = 0
        endif else begin
           exraystr.serset(0) = 1
           Widget_Control,exraystr.widget.Specific1,SET_BUTTON = 0
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_group1widget,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Specific1_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.serset(0) = 1
        endif else begin
           exraystr.serset(0) = 0
           Widget_Control,exraystr.widget.Series1,SET_BUTTON = 0
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_group1widget,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='AtFocus_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.sorset(0) = 0
           exraystr.wsource(0).a = 0.
           exraystr.wsource(0).b = 0.
        endif else begin
           exraystr.sorset(0) = 1
           exraystr.wsource(0).a = -exraystr.wxstal(0).R0
           exraystr.wsource(0).b = 0.
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='AtXY_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           for i=1,exraystr.wnumsource-1 do begin
              exraystr.sorset(i) =0
              exraystr.wsource(i).a = 0.
              exraystr.wsource(i).b = 0.
           endfor
        endif else begin
           exray_source,wWidget
           Widget_Control,wWidget, get_uvalue = exraystr
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='EditSource_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_source,wWidget
        Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='JLine_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.wfilm.JFlag = 0
        endif else begin
           exraystr.wfilm.JFlag = 1
           Widget_Control,exraystr.widget.JLocus,SET_BUTTON = 0
           Widget_Control,exraystr.widget.FSpecific,SET_BUTTON = 0
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_film,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
           if (exraystr.dataOK eq 1) then $
              if (exraystr.scaleOK eq 1) then $
                 widget_control,exraystr.widget.plotlist,SET_VALUE= $
                 [ 'Ray-Tracing','Dispersion','Resolution','Data','Scaled Data' ] $
              else $
                 widget_control,exraystr.widget.plotlist,SET_VALUE= $
                 [ 'Ray-Tracing','Dispersion','Resolution','Data'] $
           else $
              widget_control,exraystr.widget.plotlist,SET_VALUE= $
              [ 'Ray-Tracing','Dispersion','Resolution']
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='JLocus_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.wfilm.JFlag = 0
           if (exraystr.dataOK eq 1) then $
              if (exraystr.scaleOK eq 1) then $
                 widget_control,exraystr.widget.plotlist,SET_VALUE= $
                 [ 'Ray-Tracing','Dispersion','Resolution','Data','Scaled Data' ] $
              else $
                 widget_control,exraystr.widget.plotlist,SET_VALUE= $
                 [ 'Ray-Tracing','Dispersion','Resolution','Data'] $
           else $
              widget_control,exraystr.widget.plotlist,SET_VALUE= $
              [ 'Ray-Tracing','Dispersion','Resolution']
        endif else begin
           exraystr.wfilm.JFlag = 2
           exraystr.filmOK = 1
           Widget_Control,exraystr.widget.JLine,SET_BUTTON = 0
           Widget_Control,exraystr.widget.FSpecific,SET_BUTTON = 0
           if (exraystr.dataOK eq 1) then $
              if (exraystr.scaleOK eq 1) then $
                 widget_control,exraystr.widget.plotlist,SET_VALUE= $
                 [ 'Ray-Tracing','Locus Points','Resolution','Data','Scaled Data' ] $
              else $
                 widget_control,exraystr.widget.plotlist,SET_VALUE= $
                 [ 'Ray-Tracing','Locus Points','Resolution','Data'] $
           else $
              widget_control,exraystr.widget.plotlist,SET_VALUE= $
              [ 'Ray-Tracing','Locus Points','Resolution']
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='FSpecific_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.wfilm.JFlag = 0
        endif else begin
           exraystr.wfilm.JFlag = 0
           Widget_Control,exraystr.widget.JLine,SET_BUTTON = 0
           Widget_Control,exraystr.widget.JLocus,SET_BUTTON = 0
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_film,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
           if (exraystr.dataOK eq 1) then $
              if (exraystr.scaleOK eq 1) then $
                 widget_control,exraystr.widget.plotlist,SET_VALUE= $
                 [ 'Ray-Tracing','Dispersion','Resolution','Data','Scaled Data' ] $
              else $
                 widget_control,exraystr.widget.plotlist,SET_VALUE= $
                 [ 'Ray-Tracing','Dispersion','Resolution','Data'] $
           else $
              widget_control,exraystr.widget.plotlist,SET_VALUE= $
              [ 'Ray-Tracing','Dispersion','Resolution']
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='EditFilm_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_film,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Xstal_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_xstalwidget,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Ellipse_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
        endif else begin
           exraystr.ellipset = 1
           Widget_Control,exraystr.widget.TREX,SET_BUTTON = 0
           exraystr.xrange=[-10,10]
           exraystr.yrange=[-10,10]
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='TREX_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.ellipset = 1
           exraystr.xrange=[-10,10]
           exraystr.yrange=[-10,10]
        endif else begin
           exraystr.ellipset = 0
           Widget_Control,exraystr.widget.EllipseXY,SET_BUTTON = 0
           exraystr.xrange=[-37,7]
           exraystr.yrange=[-6,36]
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='EditCoordinates_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
           exray_TREXwidget,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
;************************************************************************************

;***************************** Convex Data Input Controls ***************************
    Widget_Info(wWidget, FIND_BY_UNAME='RadiusC_FIELD'): begin
           tmp = long(0)
           widget_control,exraystr.widget.RadiusC,GET_VALUE=tmp
           exraystr.wxstal(0).rc=tmp(0)*2.54
    end
    Widget_Info(wWidget, FIND_BY_UNAME='RotationC_FIELD'): begin
           tmp = long(0)
           widget_control,exraystr.widget.RotationC,GET_VALUE=tmp
           exraystr.wxstal(0).chi=tmp(0)*!pi/180.
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Wedge_DROPLIST'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
         if (Event.index eq 0) then exray_convex_wedge,exraystr,/twenty8 $
         else if (Event.index eq 1) then exray_convex_wedge,exraystr,/thirty0 $
         else if (Event.index eq 2) then exray_convex_wedge,exraystr,/thirty9 $
         else if (Event.index eq 3) then exray_convex_wedge,exraystr,/forty2 $
         else if (Event.index eq 4) then exray_convex_wedge,exraystr,/fifty4 $
         else if (Event.index eq 5) then exray_convex_wedge,exraystr,/sixty4 $
         else if (Event.index eq 6) then exray_convex_wedge,exraystr,/seventy0 $
         else if (Event.index eq 7) then exray_convex_wedge,exraystr,/seventy6 $
         else if (Event.index eq 8) then exray_convex_wedge,exraystr,/eighty0 $
         else if (Event.index eq 9) then exray_convex_wedge,exraystr,/ninety0 $
         else if (Event.index eq 10) then exray_convex_wedge,exraystr,/tixtl $
         else if (Event.index eq 11) then exray_convex_wedge,exraystr,/new
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='XstalC_DROPLIST'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
         if (Event.index eq 0) then exray_convex_xstal,exraystr,/adp $
         else if (Event.index eq 1) then exray_convex_xstal,exraystr,/kap $
         else if (Event.index eq 2) then exray_convex_xstal,exraystr,/mica $
         else if (Event.index eq 3) then exray_convex_xstal,exraystr,/pet $
         else if (Event.index eq 4) then exray_convex_xstal,exraystr,/quartz1010 $
         else if (Event.index eq 5) then exray_convex_xstal,exraystr,/quartz1011 $
         else if (Event.index eq 6) then exray_convex_xstal,exraystr,/new
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='XstalCOther_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_convex_xstalwidget,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='EditGroupsC_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_groupwidget,wWidget
        Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Order1C_FIELD'): begin
           tmp = long(0)
           widget_control,exraystr.widget.Order1C,GET_VALUE=tmp
           exraystr.wsource(*).n(0)=tmp(0)
    end
    Widget_Info(wWidget, FIND_BY_UNAME='AutoConfigC_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.autoflag = 0
           Widget_Control,exraystr.widget.EditGroupsC,SENSITIVE=1
           Widget_Control,exraystr.widget.Lambda1C,SENSITIVE=1
           Widget_Control,exraystr.widget.Beta1C,SENSITIVE=1
           Widget_Control,exraystr.widget.Series1C,SENSITIVE=1
           Widget_Control,exraystr.widget.Specific1C,SENSITIVE=1
        endif else begin
           exraystr.autoflag = 1
           exraystr.groupOK = 1
           Widget_Control,exraystr.widget.EditGroupsC,SENSITIVE=0
           Widget_Control,exraystr.widget.Lambda1C,SENSITIVE=0
           Widget_Control,exraystr.widget.Beta1C,SENSITIVE=0
           Widget_Control,exraystr.widget.Series1C,SENSITIVE=0
           Widget_Control,exraystr.widget.Specific1C,SENSITIVE=0
           Widget_Control,exraystr.widget.Beta1C,SET_BUTTON = 1
           Widget_Control,exraystr.widget.Lambda1C,SET_BUTTON = 0
           Widget_Control,exraystr.widget.Series1C,SET_BUTTON = 1
           Widget_Control,exraystr.widget.Specific1C,SET_BUTTON = 0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Lambda1C_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.lamset(0) = 0
        endif else begin
           exraystr.lamset(0) = 1
           Widget_Control,exraystr.widget.Beta1C,SET_BUTTON = 0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Beta1C_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.lamset(0) = 1
        endif else begin
           exraystr.lamset(0) = 0
           Widget_Control,exraystr.widget.Lambda1C,SET_BUTTON = 0
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Series1C_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.serset(0) = 0
        endif else begin
           exraystr.serset(0) = 1
           Widget_Control,exraystr.widget.Specific1C,SET_BUTTON = 0
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_group1widget,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Specific1C_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.serset(0) = 1
        endif else begin
           exraystr.serset(0) = 0
           Widget_Control,exraystr.widget.Series1C,SET_BUTTON = 0
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_group1widget,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='DefaultC_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.sorset(0) = 0
           exraystr.wsource(0).a = 0.
           exraystr.wsource(0).b = 0.
        endif else begin
           selected=widget_info(exraystr.widget.Wedge,/Droplist_Select)
           exraystr.sorset(0) = 1
           if (selected eq 10) then $
              exraystr.wsource(0).a = -455.3 $
           else $
              exraystr.wsource(0).a = -640.
           exraystr.wsource(0).b = 1.
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='AtXYC_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           for i=1,exraystr.wnumsource-1 do begin
              exraystr.sorset(i) =0
              exraystr.wsource(i).a = 0.
              exraystr.wsource(i).b = 0.
           endfor
        endif else begin
           exray_source,wWidget
           Widget_Control,wWidget, get_uvalue = exraystr
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='EditSourceC_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exray_source,wWidget
        Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='CircleC_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.wfilm.circleFlag = 0
        endif else begin
           exraystr.wfilm.circleFlag = 1
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_convex_film,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='LineC_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if (Event.select eq 0) then begin
           exraystr.wfilm.circleFlag = 0
        endif else begin
           exraystr.wfilm.circleFlag = 0
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_convex_film,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
        endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='EditFilmC_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
           Widget_Control, wWidget, set_uvalue = exraystr
           exray_convex_film,wWidget
           Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
;************************************************************************************

;***************************** Plotting and Plot Controls ***************************
    Widget_Info(wWidget, FIND_BY_UNAME='Plot_DROPLIST'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DROPLIST' )then begin
         exray_plotlist,wWidget,Event
         Widget_Control, wWidget, get_uvalue = exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='ZoomOut_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if ((exraystr.plotOK eq 1) or (exraystr.dataOK eq 1)) then begin
           if (exraystr.zoomflag ne 1) then begin
              widget_control,exraystr.widget.zoomout,set_value=exraystr.images.zoomout_active,/bitmap
              if (exraystr.zoomflag eq 2) then $
                 widget_control,exraystr.widget.zoomin,$
                    set_value=exraystr.images.zoomin,/bitmap
              if (exraystr.rulerflag eq 1) then begin
                 widget_control,exraystr.widget.ruler,set_value=exraystr.images.ruler,/bitmap
                 exraystr.rulerflag = 0
              endif else if (exraystr.trimflag ne 0) then begin
                  widget_control,exraystr.widget.trimdata,$
                      set_value=exraystr.images.cut,/bitmap
                 exraystr.trimflag = 0
              endif
              exraystr.zoomflag=1
              exraystr.xsave=exraystr.xrange
              exraystr.ysave=exraystr.yrange
           endif else begin
              widget_control,exraystr.widget.zoomout,set_value=exraystr.images.zoomout,/bitmap
              exraystr.zoomflag=0
           endelse
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='ZoomIn_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if ((exraystr.plotOK eq 1) or (exraystr.dataOK eq 1)) then begin
           if (exraystr.zoomflag ne 2) then begin
              widget_control,exraystr.widget.zoomin,set_value=exraystr.images.zoomin_active,/bitmap
              if (exraystr.zoomflag eq 1) then $
                 widget_control,exraystr.widget.zoomout,$
                    set_value=exraystr.images.zoomout,/bitmap
              if (exraystr.rulerflag eq 1) then begin
                 widget_control,exraystr.widget.ruler,set_value=exraystr.images.ruler,/bitmap
                 exraystr.rulerflag = 0
             endif else if (exraystr.trimflag ne 0) then begin
                widget_control,exraystr.widget.trimdata,$
                    set_value=exraystr.images.cut,/bitmap
                exraystr.trimflag = 0
             endif
              exraystr.zoomflag=2
              exraystr.xsave=exraystr.xrange
              exraystr.ysave=exraystr.yrange
           endif else begin
              widget_control,exraystr.widget.zoomin,set_value=exraystr.images.zoomin,/bitmap
              exraystr.zoomflag=0
           endelse
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Original_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if ((exraystr.plotOK eq 1) or (exraystr.dataOK eq 1)) then begin
           exraystr.xsave=exraystr.xrange
           exraystr.ysave=exraystr.yrange
           ;advance the plotflag by 1 to force the x and y range back to original
             exraystr.plotflag=exraystr.plotflag+1
             widget_control,wWidget,set_uvalue=exraystr
           widget_control,exraystr.widget.plotlist,send_event=$
                { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:wWidget, $
                HANDLER:wWidget, INDEX:exraystr.plotflag-1 }
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='OverPlot_Button'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if ((exraystr.dataOK eq 1)) then begin
           if (exraystr.overflag eq 0) then begin
              exray_overplotwidget,wWidget
              widget_control,wWidget,get_uvalue=exraystr
    ;          if (exraystr.overflag ne 0) then begin
    ;             if (exraystr.plotflag gt 2) then $ ;overplotting only works for data sets
    ;                widget_control,exraystr.widget.overplot,$
    ;                     set_value=exraystr.images.overplot_active,/bitmap
    ;             index = where(exraystr.datafile ne 'none')
    ;             widget_control,exraystr.widget.DataFile,SET_VALUE=exraystr.datafile(index)
    ;             widget_control,exraystr.widget.DataFile,SET_DROPLIST_SELECT=exraystr.activedata
    ;             widget_control,exraystr.widget.plotlist,send_event=$
    ;                { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:wWidget, $
    ;                HANDLER:wWidget, INDEX:exraystr.plotflag }
    ;          endif
           endif else begin
              exraystr.overflag=0
              widget_control,exraystr.widget.overplot,set_value=exraystr.images.overplot,/bitmap
              widget_control,exraystr.widget.plotlist,send_event=$
                 { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:wWidget, $
                 HANDLER:wWidget, INDEX:exraystr.plotflag }
           endelse
        endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Undo_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        if ((exraystr.plotOK eq 1) or (exraystr.dataOK eq 1)) then begin
           exraystr.xrange=exraystr.xsave
           exraystr.yrange=exraystr.ysave
           widget_control,exraystr.widget.plotlist,send_event=$
                { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:wWidget, $
                HANDLER:wWidget, INDEX:exraystr.plotflag }
         endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='XYSpec_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        exraystr.xsave=exraystr.xrange
        exraystr.ysave=exraystr.yrange
        widget_control,wWidget,set_uvalue = exraystr
        exray_XYrange,wWidget
        widget_control,wWidget,get_uvalue = exraystr
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Ruler_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (exraystr.rulerflag ne 1) then begin
            widget_control,exraystr.widget.ruler,set_value=exraystr.images.ruler_active,/bitmap
            if (exraystr.zoomflag ne 0) then begin
               widget_control,exraystr.widget.zoomin,$
                    set_value=exraystr.images.zoomin,/bitmap
               widget_control,exraystr.widget.zoomout,$
                    set_value=exraystr.images.zoomout,/bitmap
               exraystr.zoomflag = 0
            endif else if (exraystr.trimflag ne 0) then begin
                widget_control,exraystr.widget.trimdata,$
                    set_value=exraystr.images.cut,/bitmap
               exraystr.trimflag = 0
            endif
            exraystr.rulerflag=1
            widget_control,exraystr.widget.Graphics,DRAW_MOTION_EVENTS=1
         endif else begin
            widget_control,exraystr.widget.ruler,set_value=exraystr.images.ruler,/bitmap
            exraystr.rulerflag=0
            widget_control,exraystr.widget.Graphics,DRAW_MOTION_EVENTS=0
         endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='TrimData_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
      if (exraystr.plotflag eq 3)or(exraystr.plotflag eq 4) then begin
      ;This button only works when the user is looking at a data set
         if (exraystr.trimflag ne 1) then begin
            widget_control,exraystr.widget.trimdata,set_value=exraystr.images.cut_active,/bitmap
            if (exraystr.zoomflag ne 0) then begin
               widget_control,exraystr.widget.zoomin,$
                    set_value=exraystr.images.zoomin,/bitmap
               widget_control,exraystr.widget.zoomout,$
                    set_value=exraystr.images.zoomout,/bitmap
               exraystr.zoomflag = 0
            endif else if (exraystr.rulerflag ne 0) then begin
                widget_control,exraystr.widget.ruler,$
                    set_value=exraystr.images.ruler,/bitmap
               exraystr.rulerflag = 0
            endif
            exraystr.trimflag=1
            widget_control,exraystr.widget.Graphics,DRAW_MOTION_EVENTS=1
         endif else begin
            widget_control,exraystr.widget.trimdata,set_value=exraystr.images.cut,/bitmap
            exraystr.trimflag=0
            widget_control,exraystr.widget.Graphics,DRAW_MOTION_EVENTS=0
         endelse
      endif
     endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Print_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
         goto, printgraph
    end
    Widget_Info(wWidget, FIND_BY_UNAME='PrintGraph_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
       printgraph:
       if (!Version.OS_FAMILY eq 'unix') then begin
         exray_printwhere,wWidget
       endif else begin
         ok=dialog_printersetup()
         if (ok eq 1) then begin
            printpic=tvrd(TRUE=1)
            currentdevice=!D.NAME
            fracpg=0.8
            set_plot,'printer'
            Device,/True_Color
            Device,Get_Page_Size=pgsize
            scale=pgsize(0)*fracpg/n_elements(printpic(0,*,0))
            Device,Scale_Factor=scale
            yoff=5.5+8.5/pgsize(0)*scale*n_elements(printpic(0,0,*))/2.
            Device,YOFFSET=yoff
            tv,printpic,TRUE=1
            Device,/Close_Document
            set_plot,currentdevice
            if (!p.background eq 0) then swap
         endif
       endelse
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='GRAPHICS_DRAW'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_DRAW' )then begin
         exray_plotcontrols,wWidget,Event
         Widget_Control,wWidget,get_uvalue=exraystr
      endif
    end
;************************************************************************************

;***************************** Data Scaling Controls ********************************
    Widget_Info(wWidget, FIND_BY_UNAME='PickRef_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (exraystr.plotflag eq 3) then begin
            exraystr.pick=1
            widget_control,exraystr.widget.Graphics,DRAW_MOTION_EVENTS=1
         endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='ScaleData_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (exraystr.plotflag eq 3) then begin
            if (exraystr.convexflag ne 1) then $
               exray_AutoScale,exraystr,doneOK $
            else $
               exray_convex_autoscale,exraystr,doneOK
            if (doneOK eq 1) then begin
               widget_control,exraystr.widget.plotlist,SET_VALUE= $
                  [ 'Ray-Tracing','Dispersion','Resolution','Data','Scaled Data' ]
               widget_control,exraystr.widget.plotlist,set_droplist_select=4
               widget_control,exraystr.widget.plotlist,send_event=$
                    { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:wWidget, $
                      HANDLER:wWidget, INDEX:4 }
            endif
         endif
      endif
    end
    Widget_Info(wWidget, FIND_BY_UNAME='SaveData_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
         if (exraystr.plotflag eq 3)or(exraystr.plotflag eq 4) then begin
            exray_savedata,exraystr
         endif else if (exraystr.plotflag eq 1) then begin
            exray_savedisp,exraystr
         endif
      endif
    end
;********************************************************************************

;************************** Session Control Buttons *****************************
    Widget_Info(wWidget, FIND_BY_UNAME='Write_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then $
        exray_writefile,wWidget
    end
    Widget_Info(wWidget, FIND_BY_UNAME='Quit_BUTTON'): begin
      if( Tag_Names(Event, /STRUCTURE_NAME) eq 'WIDGET_BUTTON' )then begin
        delwdf,[exraystr.datawdf,exraystr.scaledwdf]
        if (exraystr.swapflag eq 1) then swap
        ptr_free,ptr_valid()
        CLOSE, /FORCE, /ALL
        HEAP_GC, /VERBOSE
        widget_control, Event.top, /DESTROY
        return
      endif
    end
;********************************************************************************

    else:
  endcase


 ;********************************************************************************
 ;Check to see if enough parameters are set to allow plotting
 ;    -This check is done after every event
 ;********************************************************************************
  numsource=exraystr.wnumsource
  numxstals=exraystr.wnumxstals
  sorflag = 0
  xstalflag = 0
  for i=0,numsource-1 do $
     if (exraystr.sorset(i) eq 1) then sorflag = 1
  for i=0,numxstals-1 do $
     if (exraystr.xstalset(i) eq 1) then xstalflag = 1
  if (sorflag eq 1) and (xstalflag eq 1) and (exraystr.groupOK eq 1) $
     and (exraystr.filmOK eq 1) then begin
     Widget_Control,exraystr.widget.PlotList,SENSITIVE = 1
     exraystr.plotOK = 1
  endif else begin
;     Widget_Control,exraystr.widget.PlotList,SENSITIVE = 0
     exraystr.plotOK = 0
  endelse

  Widget_Control, wWidget, set_uvalue = exraystr

end


;*******************************************************************************************************
;*******************************************************************************************************
;*******************************************************************************************************

pro Exray_BASE, file=filename, dispersion=disp, resolution=resol,datas=data,$
                GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_

;********************************************************************************
; Make some initializations
;********************************************************************************
if n_elements(filename) eq 0 then filename = 'none'
datafile=strarr(10)
if (n_elements(data) eq 0) then datafile(*) ='none'
if (!Version.OS_FAMILY eq 'MacOS') then begin
   ;the Mac has a different way of defining paths... so set some values
;   sepchar=':'
   projpath='Rochau OS9:Applications (Mac OS 9):EXRAY:exray_0.2:'
   sepchar=':'
   path=':'
   ;set some variables to make the widget look nicer
   fieldsize=10
endif else if (!Version.OS_FAMILY eq 'unix') then begin
   projpath='/remote/garocha/IDL/exray/'
   sepchar='/'
   path='.'
   fieldsize=8
endif else begin
   projpath=''
   sepchar='/'
   path='.'
   fieldsize=8
endelse

  Exray_BASE = Widget_Base( GROUP_LEADER=wGroup,  $
      UNAME='Exray_BASE' ,XOFFSET=5 ,YOFFSET=5,MBAR=control_bar $
      ,TITLE='EXRAY 0.5' ,SPACE=3 ,XPAD=3 ,YPAD=3,Column=2)
;************************** Menu Button Widgets *********************************

;****File menu****
  File_MENU = WIDGET_BUTTON(control_bar, VALUE='File', /MENU)

  Open_MENU = Widget_BUTTON(File_MENU,  $
        UNAME='Open_MENU' ,VALUE='Open',/MENU)

  OpenSession_BUTTON = Widget_BUTTON(Open_MENU,  $
        UNAME='OpenSession_BUTTON' ,VALUE='Session File')

  OpenData_BUTTON = Widget_BUTTON(Open_MENU,  $
        UNAME='OpenData_BUTTON' ,VALUE='Data File')

  CloseData_BUTTON = Widget_BUTTON(File_MENU,  $
        UNAME='CloseData_BUTTON' ,VALUE='Close Data')

  PrintGraph_BUTTON = Widget_BUTTON(File_MENU,Value='Print Graphics'$
      ,UNAME='PrintGraph_BUTTON',/SEPARATOR)

  if (!Version.OS_FAMILY eq 'unix') then begin
     PrintList_BUTTON = Widget_BUTTON(File_MENU,  $
        UNAME='PrintList_BUTTON' ,VALUE='Printer Select',/MENU)
     spawn,'lpstat -a',a
     printers=strarr(n_elements(a))
     printnum=0
     for i=0,n_elements(a)-1 do begin
        temp=strsplit(a(i),' ',/extract)
        if temp(0) ne '' then begin
           printers(printnum)=temp(0)
           printer=widget_button(PrintList_BUTTON,value=temp(0), $
                 uvalue='Printer #'+strtrim(string(printnum),2))
           printnum=printnum+1
        endif
     endfor
  endif else printers='N/A'

  Save_BUTTON = Widget_BUTTON(File_MENU,VALUE='Save Session', $
       UNAME='Write_BUTTON',/SEPARATOR)
  Quit_BUTTON = Widget_BUTTON(File_MENU,VALUE='Quit',UNAME='Quit_BUTTON')

  ;****Options menu****
  Options_MENU = WIDGET_BUTTON(control_bar, VALUE='Options', /MENU)

  GraphOps_BUTTON = Widget_BUTTON(Options_MENU,VALUE='Graphics',UNAME='GraphOps_BUTTON')

  FitOps_BUTTON = Widget_BUTTON(Options_MENU,VALUE='Data Scaling',UNAME='FitOps_BUTTON')

  RayOps_BUTTON = Widget_BUTTON(Options_MENU,VALUE='Ray Tracing',UNAME='RayOps_BUTTON')

  ;****Calculate menu****
  Calculate_MENU = WIDGET_BUTTON(control_bar, VALUE='Calculate', /MENU)

  Filter_BUTTON =  Widget_Button(Calculate_MENU, SENSITIVE=0  $
      ,UNAME='Filter_BUTTON',VALUE='Filter')

  D2I_BUTTON = Widget_Button(Calculate_MENU, SENSITIVE=0  $
      ,UNAME='D2I_BUTTON',VALUE='Density -> Intensity')

  Eff_BUTTON = Widget_Button(Calculate_MENU, SENSITIVE=0  $
      ,UNAME='Eff_BUTTON',VALUE='Efficiency Correction')

  ScaleCalc_BUTTON = Widget_Button(Calculate_MENU, SENSITIVE=0  $
      ,UNAME='ScaleCalc_BUTTON',VALUE='Scaler Math')

  AbsTrans_MENU = Widget_BUTTON(Calculate_MENU,  $
        UNAME='AbsTrans_MENU' ,VALUE='Absolute Transmission',/MENU)

  Polynomial_BUTTON = Widget_Button(AbsTrans_MENU, SENSITIVE=0  $
      ,UNAME='RelTrans_BUTTON',VALUE='Fit Polynomial to Background')

  BackCurve_BUTTON = Widget_Button(AbsTrans_MENU, SENSITIVE=0  $
      ,UNAME='BackCurve_BUTTON',VALUE='Divide By Background Data')

  Batch_BUTTON = Widget_Button(Calculate_MENU, SENSITIVE=0  $
      ,UNAME='Batch_BUTTON',VALUE='Batch Process Lineouts')

;**************************************************************************
; Define the widget elements
;**************************************************************************
  Left_BASE = Widget_Base( Exray_Base,UNAME='Left_BASE',Column=1)

  Right_BASE = Widget_Base( Exray_BASE,UNAME='Right_BASE',Column=1)

  WhichSpect_LABEL = Widget_Label(Right_BASE,  $
      UNAME='WhichSpect_LABEL',/ALIGN_LEFT,VALUE='Spectrometer Geometry')

  WhichSpect_BASE = Widget_Base(Right_BASE, UNAME='WhichSpect_BASE',COLUMN=2)

  Elliptical_BUTTON = Widget_BUTTON(WhichSpect_BASE,UNAME='Elliptical_BUTTON' $
      ,Value='Elliptical',/FRAME,/ALIGN_CENTER)

  Convex_BUTTON = Widget_BUTTON(WhichSpect_BASE,UNAME='Convex_BUTTON' $
      ,Value='Convex',/FRAME)

  Spectrometer_BASE = Widget_BASE( Right_BASE,UNAME='Spectrometer_BASE')


;******************************** Active File Widgets **********************************

  File_BASE = Widget_Base(Left_BASE, UNAME='File_BASE',COLUMN=2)

  InputFile_LABEL = Widget_Label(File_BASE,  $
      UNAME='InputFile_LABEL' ,XOFFSET=13 ,SCR_XSIZE=237,SCR_YSIZE=13  $
      ,/ALIGN_LEFT ,VALUE='EXRAY Input Session File')

  Input_Filename = Widget_Text(File_BASE, UNAME='Input_Filename'  $
      ,FRAME=0.5 ,XOFFSET=11 ,YOFFSET=15 ,SCR_XSIZE=369,SCR_YSIZE=30 $
      ,/ALL_EVENTS ,XSIZE=20,YSIZE=1,VALUE=[filename])

  DataFile_LABEL = Widget_Label(File_BASE,  $
      UNAME='DataFile_LABEL' ,XOFFSET=11 ,YOFFSET=44,SCR_YSIZE=13 $
      ,/ALIGN_LEFT,VALUE='Elliptical Spectrometer Data File')

  if (!version.OS eq 'sunos') then begin
     Data_Filename = Widget_DropList(File_BASE, UNAME='Data_Filename'  $
         ,FRAME=0.5,VALUE='',/Align_Right,/Dynamic_Resize)
  endif else begin
     Data_Filename = Widget_DropList(File_BASE, UNAME='Data_Filename'  $
         ,FRAME=0.5 ,XOFFSET=11 ,YOFFSET=60 ,SCR_XSIZE=369,SCR_YSIZE=30 $
         ,XSIZE=20 ,YSIZE=1, VALUE='')
  endelse

  dummy1=widget_label(File_BASE,Value='',SCR_XSIZE=30,SCR_YSIZE=13)

  Open_InputFile_BUTTON = Widget_Button(File_BASE,  $
      UNAME='Open_InputFile_BUTTON',XOFFSET=389 ,YOFFSET=15,SCR_XSIZE=30,SCR_YSIZE=30  $
      ,/ALIGN_CENTER ,VALUE=projpath+'images'+sepchar+'open.bmp',/BITMAP)

  dummy2=widget_label(File_BASE,Value='',SCR_XSIZE=30,SCR_YSIZE=13)

  Open_DataFile_BUTTON = Widget_Button(File_BASE,  $
      UNAME='Open_DataFile_BUTTON' ,XOFFSET=389 ,YOFFSET=60,SCR_XSIZE=30,SCR_YSIZE=30 $
      ,/ALIGN_CENTER ,VALUE=projpath+'images'+sepchar+'open.bmp',/BITMAP)


;******************************** Graphics Widgets **********************************
if (!Version.OS_FAMILY eq 'MacOS') then begin
   ;set some sizes for buttons to make the widget look decent
   bsize=23
endif else if (!Version.OS_FAMILY eq 'unix') then $
   bsize=23 $
else bsize=23

  dummy_LABEL = Widget_Label(Left_BASE,Value='')

  Graphics_LABEL = Widget_Label(Left_BASE,  $
      UNAME='Graphics_LABEL' $
      ,/ALIGN_CENTER,VALUE='GRAPHICAL USER INTERFACE')

  Plot_BASE = Widget_Base(Left_BASE, UNAME='Plot_BASE',COLUMN=1,/FRAME)


  PlotControl_BASE = Widget_Base(Plot_BASE, UNAME='PlotControl_BASE' $
         ,COLUMN=10,SCR_YSIZE=30)

  Plot_DROPLIST = Widget_Droplist(PlotControl_BASE,  $
      UNAME='Plot_DROPLIST' ,XOFFSET=10 ,YOFFSET=89 ,SENSITIVE=0  $
      ,TITLE='Plot' ,VALUE=[ 'Ray-Tracing','Dispersion' $
      ,'Resolution'])

  Original_BUTTON = Widget_Button(PlotControl_BASE,  $
      UNAME='Original_BUTTON' ,FRAME=0,/ALIGN_CENTER,/BITMAP,xsize=bsize,ysize=bsize  $
      ,VALUE=projpath+'images'+sepchar+'reset.bmp')

  Undo_BUTTON = Widget_Button(PlotControl_BASE,  $
      UNAME='Undo_BUTTON' ,FRAME=0 ,XOFFSET=296  $
      ,YOFFSET=91 ,/ALIGN_CENTER,/BITMAP,xsize=bsize,ysize=bsize $
      ,VALUE=projpath+'images'+sepchar+'undo.bmp')

  ZoomOut_BUTTON = Widget_Button(PlotControl_BASE,  $
      UNAME='ZoomOut_BUTTON' ,FRAME=0 ,XOFFSET=320  $
      ,YOFFSET=91 ,/ALIGN_CENTER,/BITMAP,xsize=bsize,ysize=bsize  $
      ,VALUE=projpath+'images'+sepchar+'zoom_out.bmp')

  ZoomIn_BUTTON = Widget_Button(PlotControl_BASE,  $
      UNAME='ZoomIn_BUTTON' ,FRAME=0 ,XOFFSET=343  $
      ,YOFFSET=91 ,/ALIGN_CENTER,/BITMAP,xsize=bsize,ysize=bsize  $
      ,VALUE=projpath+'images'+sepchar+'zoom_in.bmp')


  XYSpec_BUTTON = Widget_Button(PlotControl_BASE,  $
      UNAME='XYSpec_BUTTON' ,FRAME=0 ,XOFFSET=366  $
      ,YOFFSET=91 ,/ALIGN_CENTER,/BITMAP,xsize=1.5*bsize,ysize=bsize  $
      ,VALUE=projpath+'images'+sepchar+'x_y.bmp')

  OverPlot_Button = Widget_Button(PlotControl_BASE, UNAME='OverPlot_Button'  $
      ,/ALIGN_Center,/BITMAP,xsize=bsize,ysize=bsize $
      ,VALUE=projpath+'images'+sepchar+'overplot.bmp')

  Ruler_BUTTON = Widget_Button(PlotControl_BASE,  $
      UNAME='Ruler_BUTTON' ,FRAME=0 ,/ALIGN_CENTER,/BITMAP,xsize=bsize,ysize=bsize  $
      ,VALUE=projpath+'images'+sepchar+'ruler.bmp')

  TrimData_BUTTON = Widget_Button(PlotControl_BASE,  $
      UNAME='TrimData_BUTTON' ,FRAME=0 ,/ALIGN_CENTER,/BITMAP,xsize=bsize,ysize=bsize  $
      ,VALUE=projpath+'images'+sepchar+'cut.bmp')

  Print_BUTTON = Widget_Button(PlotControl_BASE,  $
      UNAME='Print_BUTTON' ,FRAME=0 ,/ALIGN_CENTER,/BITMAP,xsize=bsize,ysize=bsize  $
      ,VALUE=projpath+'images'+sepchar+'print.bmp')


  Graphics_DRAW = Widget_Draw(Plot_BASE, UNAME='GRAPHICS_DRAW'  $
      ,XOFFSET=12 ,YOFFSET=117 ,SCR_XSIZE=404 ,SCR_YSIZE=377 $
      ,XSIZE=404,YSIZE=377,FRAME=0.5,/BUTTON_EVENTS)


;******************************** Data Control Widgets **********************************

  Data_BASE = Widget_Base(Left_BASE, UNAME='Data_BASE', COLUMN = 3,/FRAME)

  PickRef_BUTTON = Widget_Button(Data_BASE, SENSITIVE=0  $
      ,UNAME='PickRef_BUTTON' ,XOFFSET=0 ,YOFFSET=1 ,SCR_XSIZE=135  $
      ,SCR_YSIZE=20 ,/ALIGN_CENTER ,VALUE='Pick Reference',Frame=0.5)

  ScaleData_BUTTON = Widget_Button(Data_BASE, SENSITIVE=0 $
      ,UNAME='ScaleData_BUTTON' ,XOFFSET=134 ,YOFFSET=1 ,SCR_XSIZE=135  $
      ,SCR_YSIZE=20 ,/ALIGN_CENTER ,VALUE='Scale Data',Frame=0.5)

  SaveData_BUTTON = Widget_Button(Data_BASE, SENSITIVE=0  $
      ,UNAME='SaveData_BUTTON' ,XOFFSET=268 ,YOFFSET=1 ,SCR_XSIZE=135  $
      ,SCR_YSIZE=20 ,/ALIGN_CENTER ,VALUE='Save Data',Frame=0.5)

;*************************** Elliptical Geometry Widgets *********************************

  Elliptical_BASE = Widget_Base( Spectrometer_Base,UNAME='Elliptical_BASE',$
         COLUMN=1,MAP=1,/FRAME)

  Config_BASE = Widget_Base(Elliptical_BASE, UNAME='Config_BASE',ROW=1)

  Config_DROPLIST = Widget_Droplist(Config_BASE,  $
      UNAME='Config_DROPLIST' ,XOFFSET=450 ,YOFFSET=19 ,SENSITIVE=1  $
      ,TITLE='Config' ,VALUE=[ 'dds','s', 't', 'u', $
      'xs', 'dd', 'v', 'x','New' ],/ALIGN_RIGHT)

  Xstal_DROPLIST = Widget_Droplist(Config_BASE,  $
      UNAME='Xstal_DROPLIST' ,XOFFSET=475 ,YOFFSET=65 ,SENSITIVE=1  $
      ,TITLE='Crystal ' ,VALUE=[ 'ADP','KAP', 'Mica', 'PET' $
      ,'Quartz (1010)','Quartz (1011)','New'],/ALIGN_RIGHT)

  basize=Widget_Info(Elliptical_BASE,/Geometry)

  Xstal_BUTTON = Widget_Button(Elliptical_BASE,  $
      UNAME='Xstal_BUTTON' ,XOFFSET=439 ,YOFFSET=448 ,SCR_XSIZE=basize.scr_xsize-10  $
      ,SCR_YSIZE=31 ,/ALIGN_CENTER ,VALUE='CRYSTAL PROPERTIES',FRAME = 0.5)

  Group1_LABEL = Widget_Label(Elliptical_BASE,  $
      UNAME='Group1_LABEL' ,XOFFSET=439 ,YOFFSET=110 ,/ALIGN_CENTER  $
      ,VALUE='WAVELENGTH/BETA GROUP 1')

  WaveBeta_BASE = Widget_BASE(Elliptical_BASE,UNAME='WaveBeta_BASE'$
      ,COLUMN=1,/FRAME)

  Order1_Field = CW_Field(WaveBeta_BASE,UNAME='Order1_FIELD' $
                        ,Title='Order #',/All_Events,/long,xsize=fieldsize $
                        ,Value=[1])

  AutoConfig_BASE = Widget_Base(WaveBeta_BASE, UNAME='AutoConfig_BASE'  $
      ,COLUMN=1 ,/NONEXCLUSIVE,/ALIGN_CENTER)

  AutoConfig_Button = Widget_Button(AutoConfig_BASE, UNAME='AutoConfig_BUTTON'  $
      ,/ALIGN_CENTER,/SENSITIVE ,VALUE='Auto Configuration')

  Group1_BASE = Widget_Base(WaveBeta_BASE, UNAME='Group1_BASE',COLUMN=2)

  Group1Button_BASE = Widget_Base(Group1_BASE, UNAME='Group1Button_BASE'  $
      ,COLUMN=1 ,/NONEXCLUSIVE,scr_xsize=basize.scr_xsize-65)

  Lambda1_Button = Widget_Button(Group1Button_BASE, UNAME='Lambda1_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Wavelengths')


  Beta1_Button = Widget_Button(Group1Button_BASE, UNAME='Beta1_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Betas')


  Series1_Button = Widget_Button(Group1Button_BASE, UNAME='Series1_Button'  $
       ,/SENSITIVE ,VALUE='Series')


  Specific1_Button = Widget_Button(Group1Button_BASE, UNAME='Specific1_Button'  $
       ,/SENSITIVE ,VALUE='Specific')


  EditGroups_BUTTON = Widget_Button(Group1_BASE,  $
      UNAME='EditGroups_BUTTON' ,XOFFSET=555 ,YOFFSET=150 $
      ,SCR_YSIZE=104 ,/ALIGN_CENTER ,VALUE='Edit',FRAME = 1,scr_xsize=45)


  Source_LABEL = Widget_Label(Elliptical_BASE,  $
      UNAME='Source_LABEL' ,XOFFSET=439 ,YOFFSET=263 ,/ALIGN_CENTER  $
      ,VALUE='SOURCE LOCATION(s)')

  Source_BASE = Widget_Base(Elliptical_BASE, UNAME='Source_BASE',COLUMN=2,/FRAME)

  SourceButton_BASE = Widget_Base(Source_BASE, UNAME='SourceButton_BASE'  $
      ,XOFFSET=439 ,YOFFSET=278 ,COLUMN=1 ,/NONEXCLUSIVE $
      ,scr_xsize=basize.scr_xsize-65)

  AtFocus_Button = Widget_Button(SourceButton_BASE, UNAME='AtFocus_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='At Focus')


  AtXY_Button = Widget_Button(SourceButton_BASE, UNAME='AtXY_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Other')

  EditSource_BUTTON = Widget_Button(Source_BASE,  $
      UNAME='EditSource_BUTTON' ,XOFFSET=555 ,YOFFSET=278 ,SCR_XSIZE=45  $
      ,SCR_YSIZE=56 ,/ALIGN_CENTER ,VALUE='Edit',FRAME = 1)


  Film_LABEL = Widget_Label(Elliptical_BASE,  $
      UNAME='Source_LABEL' ,XOFFSET=439 ,YOFFSET=343 ,/ALIGN_CENTER  $
      ,VALUE='FILM PARAMETERS')

  Film_BASE = Widget_Base(Elliptical_BASE, UNAME='Film_BASE',COLUMN=2,/FRAME)

  FilmButton_BASE = Widget_Base(Film_BASE, UNAME='FilmButton_BASE'  $
      ,XOFFSET=439 ,YOFFSET=358 ,COLUMN=1 ,/NONEXCLUSIVE $
      ,scr_xsize=basize.scr_xsize-65)

  JLine_Button = Widget_Button(FilmButton_BASE, UNAME='JLine_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Johann Line')

  JLocus_Button = Widget_Button(FilmButton_BASE, UNAME='JLocus_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Johann Locus')

  FSpecific_Button = Widget_Button(FilmButton_BASE, UNAME='FSpecific_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Specify Custom')

  EditFilm_BUTTON = Widget_Button(Film_BASE,  $
      UNAME='EditFilm_BUTTON' ,XOFFSET=555 ,YOFFSET=358 ,SCR_XSIZE=45  $
      ,SCR_YSIZE=80 ,/ALIGN_CENTER ,VALUE='Edit',FRAME = 1)


  Coordinates_LABEL = Widget_Label(Elliptical_BASE,  $
      UNAME='Coordinates_LABEL' ,XOFFSET=439 ,YOFFSET=487 ,/ALIGN_CENTER  $
      ,VALUE='COORDINATE SYSTEM')

  Coordinates_BASE = Widget_Base(Elliptical_BASE, UNAME='Coordinates_BASE' $
      ,COLUMN=2, /FRAME)

  CoordinateButton_BASE = Widget_Base(Coordinates_BASE, UNAME='CoordinateButton_BASE'  $
      ,XOFFSET=439 ,YOFFSET=500 ,COLUMN=1 ,/NONEXCLUSIVE $
      , scr_xsize=basize.scr_xsize-65)

  Ellipse_Button = Widget_Button(CoordinateButton_BASE, UNAME='Ellipse_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Ellipse')

  TREX_Button = Widget_Button(CoordinateButton_BASE, UNAME='TREX_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='TREX')

  EditCoordinates_BUTTON = Widget_Button(Coordinates_BASE,  $
      UNAME='EditCoordinates_BUTTON' ,XOFFSET=555 ,YOFFSET=500 ,SCR_XSIZE=45  $
      ,SCR_YSIZE=50,/ALIGN_CENTER ,VALUE='Edit',FRAME = 1)

;********************** Convex Geometry Widgets ***************************

  Convex_BASE = Widget_Base( Spectrometer_Base,UNAME='Convex_BASE' $
      ,COLUMN=1,MAP=0,/FRAME)

  ConfigC_BASE = Widget_Base(Convex_BASE, UNAME='ConfigC_BASE',ROW=1)

  Wedge_DROPLIST = Widget_Droplist(ConfigC_BASE,  $
      UNAME='Wedge_DROPLIST' ,XOFFSET=450 ,YOFFSET=19 ,SENSITIVE=1  $
      ,TITLE='Wedge' ,VALUE=[ '28','30','39','42','54' $
      ,'64','70', '76','80','90','TIXTL','New' ],/ALIGN_RIGHT)

  XstalC_DROPLIST = Widget_Droplist(ConfigC_BASE,  $
      UNAME='XstalC_DROPLIST' ,XOFFSET=475 ,YOFFSET=65 ,SENSITIVE=1  $
      ,TITLE='Crystal ' ,VALUE=[ 'ADP','KAP', 'Mica', 'PET' $
      ,'Quartz (1010)','Quartz (1011)','New'],/ALIGN_RIGHT)

  XstalC_LABEL = Widget_Label(Convex_BASE,  $
      UNAME='XstalC_LABEL',/ALIGN_CENTER,VALUE='CRYSTAL PROPERTIES')

  XstalC_BASE = Widget_BASE(Convex_BASE,UNAME='WaveBetaC_BASE'$
      ,COLUMN=1,/FRAME,/BASE_ALIGN_RIGHT)

  RadiusC_Field = CW_Field(XstalC_BASE,UNAME='RadiusC_FIELD' $
                        ,Title='Crystal Radius (in.) =',/All_Events,/float,xsize=fieldsize $
                        ,Value=[1.])

  RotationC_Field = CW_Field(XstalC_BASE,UNAME='RotationC_FIELD' $
                        ,Title='Crystal Rotation (deg) =',/All_Events,/float,xsize=fieldsize $
                        ,Value=[0.])
  basize=widget_info(Convex_BASE,/Geometry)

  XstalCOther_BUTTON = Widget_Button(XstalC_BASE,  $
      UNAME='XstalCOther_BUTTON' ,SCR_XSIZE=basize.scr_xsize-10  $
      ,SCR_YSIZE=20 ,/ALIGN_CENTER ,VALUE='Other Parameters',FRAME = 0.5)

  Group1C_LABEL = Widget_Label(Convex_BASE,  $
      UNAME='Group1C_LABEL',/ALIGN_CENTER,VALUE='WAVELENGTH/BETA GROUP 1')

  WaveBetaC_BASE = Widget_BASE(Convex_BASE,UNAME='WaveBetaC_BASE'$
      ,COLUMN=1,/FRAME)

  Order1C_Field = CW_Field(WaveBetaC_BASE,UNAME='Order1C_FIELD' $
                        ,Title='Order #',/All_Events,/long,xsize=fieldsize $
                        ,Value=[1])

  AutoConfigC_BASE = Widget_Base(WaveBetaC_BASE, UNAME='AutoConfigC_BASE'  $
      ,COLUMN=1 ,/NONEXCLUSIVE,/ALIGN_CENTER)

  AutoConfigC_Button = Widget_Button(AutoConfigC_BASE, UNAME='AutoConfigC_BUTTON'  $
      ,/ALIGN_CENTER,/SENSITIVE ,VALUE='Auto Configuration')

  Group1C_BASE = Widget_Base(WaveBetaC_BASE, UNAME='Group1C_BASE',COLUMN=2)

  Group1CButton_BASE = Widget_Base(Group1C_BASE, UNAME='Group1CButton_BASE'  $
      ,COLUMN=1 ,/NONEXCLUSIVE, scr_xsize=basize.scr_xsize-65)

  Lambda1C_Button = Widget_Button(Group1CButton_BASE, UNAME='Lambda1C_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Wavelengths')


  Beta1C_Button = Widget_Button(Group1CButton_BASE, UNAME='Beta1C_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Betas')


  Series1C_Button = Widget_Button(Group1CButton_BASE, UNAME='Series1C_Button'  $
       ,/SENSITIVE ,VALUE='Series')


  Specific1C_Button = Widget_Button(Group1CButton_BASE, UNAME='Specific1C_Button'  $
       ,/SENSITIVE ,VALUE='Specific')

  EditGroupsC_BUTTON = Widget_Button(Group1C_BASE,  $
      UNAME='EditGroupsC_BUTTON' ,SCR_XSIZE=45  $
      ,SCR_YSIZE=104 ,/ALIGN_CENTER ,VALUE='Edit',FRAME = 1)

  SourceC_LABEL = Widget_Label(Convex_BASE,  $
      UNAME='Source_LABEL' ,/ALIGN_CENTER,VALUE='SOURCE LOCATION(s)')

  SourceC_BASE = Widget_Base(Convex_BASE, UNAME='SourceC_BASE',COLUMN=2,/FRAME)

  SourceCButton_BASE = Widget_Base(SourceC_BASE, UNAME='SourceCButton_BASE'  $
       ,COLUMN=1 ,/NONEXCLUSIVE, scr_xsize=basize.scr_xsize-65)

  DefaultC_Button = Widget_Button(SourceCButton_BASE, UNAME='DefaultC_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Default (-640,1)')


  AtXYC_Button = Widget_Button(SourceCButton_BASE, UNAME='AtXYC_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Other')

  EditSourceC_BUTTON = Widget_Button(SourceC_BASE,  $
      UNAME='EditSourceC_BUTTON' ,SCR_XSIZE=45  $
      ,SCR_YSIZE=50 ,/ALIGN_CENTER ,VALUE='Edit',FRAME = 1)

  FilmC_LABEL = Widget_Label(Convex_BASE,  $
      UNAME='Source_LABEL' ,/ALIGN_CENTER,VALUE='FILM PARAMETERS')

  FilmC_BASE = Widget_Base(Convex_BASE, UNAME='FilmC_BASE',COLUMN=2,/FRAME)

  FilmCButton_BASE = Widget_Base(FilmC_BASE, UNAME='FilmCButton_BASE'  $
      ,COLUMN=1 ,/EXCLUSIVE,scr_xsize=basize.scr_xsize-65)

  CircleC_Button = Widget_Button(FilmCButton_BASE, UNAME='CircleC_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Circle')

  LineC_Button = Widget_Button(FilmCButton_BASE, UNAME='LineC_Button'  $
      ,/ALIGN_LEFT,/SENSITIVE ,VALUE='Line')

  EditFilmC_BUTTON = Widget_Button(FilmC_BASE,  $
      UNAME='EditFilmC_BUTTON' ,SCR_XSIZE=45,SCR_YSIZE=50 $
      ,/ALIGN_CENTER ,VALUE='Edit',FRAME = 1)



;**************************************************************************
; Define the input data structures
;**************************************************************************

  wnumsource=long(6)    ;the maximum allowed source points
  wnumorders=long(5)    ;the maximum allowed group definitions
  wnumlambda=long(1000)  ;the maximum allowed wavelengths/betas per group
  wnumxstals=long(4)    ;the maximum allowed crystal definitions

  formats = {NAME: 'Formatting',$
             fieldsize:fieldsize}

  widget = {NAME: 'Widgets', $
            Elliptical:Elliptical_BASE,$
            Convex:Convex_BASE,$
            Graphics: Graphics_DRAW, $
            InFile: Input_Filename, $
            DataFile: Data_Filename, $
            Configs: Config_DROPLIST, $
            Xstals: Xstal_DROPLIST, $
            PickRef: PickRef_BUTTON, $
            ScaleData: ScaleData_BUTTON, $
            SaveData: SaveData_BUTTON, $
            d2i:D2I_BUTTON,$
            eff:Eff_BUTTON,$
            scalecalc:ScaleCalc_BUTTON,$
            filter:Filter_BUTTON,$
            Polynomial:Polynomial_BUTTON,$
            BackCurve:BackCurve_BUTTON,$
            batch:Batch_BUTTON,$
            ZoomOut: ZoomOut_BUTTON, $
            ZoomIn: ZoomIn_BUTTON, $
            Overplot: Overplot_BUTTON,$
            Ruler: Ruler_BUTTON, $
            TrimData: TrimData_BUTTON, $
            Undo: Undo_BUTTON, $
            XYSpec:XYSpec_BUTTON, $
            PrintGraph:Print_BUTTON,$
            Order1: Order1_FIELD, $
            Auto: AutoConfig_BUTTON, $
            Lambda1: Lambda1_BUTTON, $
            Beta1: Beta1_BUTTON,$
            Series1: Series1_BUTTON,$
            Specific1:Specific1_BUTTON, $
            EditGroups:EditGroups_BUTTON, $
            AtFocus:AtFocus_BUTTON,$
            AtXY:AtXY_BUTTON,$
            JLine: JLine_BUTTON, $
            JLocus: JLocus_BUTTON, $
            FSpecific: FSpecific_BUTTON,$
            EllipseXY: Ellipse_BUTTON, $
            PlotList: Plot_DROPLIST,$
            TREX: TREX_BUTTON,$
            Wedge:Wedge_DROPLIST,$
            XstalC:XstalC_DROPLIST, $
            RadiusC:RadiusC_FIELD,$
            RotationC:RotationC_FIELD,$
            Order1C: Order1C_FIELD, $
            AutoC: AutoConfigC_BUTTON, $
            Lambda1C: Lambda1C_BUTTON, $
            Beta1C: Beta1C_BUTTON,$
            Series1C: Series1C_BUTTON,$
            Specific1C:Specific1C_BUTTON, $
            EditGroupsC:EditGroupsC_BUTTON,$
            DefaultC:DefaultC_BUTTON,$
            AtXYC:AtXYC_BUTTON,$
            LineC:LineC_BUTTON,$
            CircleC:CircleC_BUTTON}

  wsource={NAME: 'WIDGET SOURCE VARIABLES',$
        lambda:dblarr(wnumorders,wnumlambda),$ ;the wavelengths to calculate
        n:lonarr(wnumorders),$ ;the order number to consider
        a:double(0),$ ;the source x position
        b:double(0)} ;the source y position

  wsource=replicate(wsource,wnumsource)

  wxstal={NAME: 'WIDGET CRYSTAL VARIABLES',$
       twod:double(0),$ ;twice the crystal plane spacing
       beta:dblarr(wnumorders,wnumlambda),$ ;the user-defined beta values
       R0:double(0),$ ;the focal length of the crystal
       h:double(0),$ ;the henke h parameter
       ecc:double(0),$ ;the crystal eccentricity
       betamin:double(0),$ ;the minimum beta angle for the crystal
       betamax:double(0),$ ;the maximum beta angle for the crystal
       chi:double(0.),$ ;the convex crystal rotation
       p:double(0.),$ ;diffraction plane rotation
       rc:double(0.)} ;the convex crystal radius

  wxstal=replicate(wxstal,wnumxstals)

  wfilm={NAME: 'WIDGET FILM VARIABLES',$
      JFlag:long(0),$ ;a flag to indicate a Johann Crossover Detector
      circleFlag:long(0),$ ;a flag to indicate a circular detection plane about rf
      interpolFlag:long(1),$ ;a flag to determine the type of interpolation in d2i
      filmtype:long(1),$ ;the type of film to use in d2i
      tension:double(1.),$ ;the film tension to use in d2i
      fog:double(0.),$ ;the film fog (developing residue) to use in d2i
      fogfile:string('none'),$ ;the file containing film fog data
      fogflag:long(0),$ ;a flag to indicate scaler or vector fog data
      fogwdf:long(0),$ ;the wdf array containing vector fog data
      filter:lonarr(3),$ ;array containing filter indices from drop-down menus in effwidget
      filtwidth:dblarr(3),$ ;the thickness of the filters in effwidget (in microns)
      slit:double(0),$ ;the slit width used in the spectrometer configuration
      mag:double(0),$ ;the magnification of the spectrometer configuration
      lineout:double(0),$ ;the width (in microns) of the lineout being converted in effwidget
      filtflag:long(0),$ ;a flag to indicate whether to include filters in the efficiency calc
      geoflag:long(0),$ ;a flag to indicate whether to include geometry in the efficiency calc
      xstalflag:long(0),$ ;flag to determine whether to include crystal reflectivity in eff calc
      refflag:long(0),$ ;flag to determine which crystal reflectivity model to use
      mcpflag:long(0),$ ;flag to determine whether or not to include MCP QE in eff calc
      photocath:long(0),$ ;integer containing photocathode index from drop-down menus in effwidget
      units:long(0),$ ;integer containing unit index from drop-down menu in effwidget
      rf:double(0),$ ;the radius of the film location
      phi:double(0),$ ;the rotation of the film location (for convex, this is pi-wedge angle)
      mu: double(0),$ ;the rotation of the film about its center
      L: double(0)} ;the length of the film

  images={NAME: 'IMAGE STRUCTURE',$
        open:projpath+'images'+sepchar+'open.bmp',$
        open_active:projpath+'images'+sepchar+'open_active.bmp',$
        zoomin:projpath+'images'+sepchar+'zoom_in.bmp',$
        zoomin_active:projpath+'images'+sepchar+'zoom_in_active.bmp',$
        zoomout:projpath+'images'+sepchar+'zoom_out.bmp',$
        zoomout_active:projpath+'images'+sepchar+'zoom_out_active.bmp',$
        undo:projpath+'images'+sepchar+'undo.bmp',$
        undo_active:projpath+'images'+sepchar+'undo_active.bmp',$
        reset:projpath+'images'+sepchar+'reset.bmp',$
        reset_active:projpath+'images'+sepchar+'reset_active.bmp',$
        print:projpath+'images'+sepchar+'print.bmp',$
        x_y:projpath+'images'+sepchar+'x_y.bmp',$
        x_y_active:projpath+'images'+sepchar+'x_y_active.bmp',$
        ruler:projpath+'images'+sepchar+'ruler.bmp',$
        ruler_active:projpath+'images'+sepchar+'ruler_active.bmp',$
        cut:projpath+'images'+sepchar+'cut.bmp',$
        cut_active:projpath+'images'+sepchar+'cut_active.bmp',$
        overplot:projpath+'images'+sepchar+'overplot.bmp',$
        overplot_active:projpath+'images'+sepchar+'overplot_active.bmp'}
  ;get the defined atomic transitions
  exray_transitions,element,projpath
  ;determine the "as realized" size of the graphics window
  graphicsize=widget_info(Graphics_DRAW,/geometry)

  exraystr = {base:Exray_Base,$
              formats:formats,$ ;special platform-dependent formatting values
              widget:widget, $ ;the widget id #s
              wsource:wsource,$ ;the widget level source variables
              wxstal:wxstal,$ ;the widget level crystal variables
              wfilm:wfilm,$ ;the widget level film variables
              images:images,$ ;the button bitmap images
              element:element,$ ;the known/calculated atomic level transitions
              filename:filename,$ ;session file names
              datafile:datafile,$ ;data file names
              batchfile:'',$ ;batch job file
              path:path,$ ;current user path
              projpath:projpath,$ ;the path to the users project file
              sepchar:sepchar,$ ;folder seperator on this platform
              wnumsource:wnumsource,$ ;widget level number of sources
              wnumorders:wnumorders,$ ;widget level number of wavelength/beta groups
              wnumxstals:wnumxstals,$ ;widget level number of crystals
              wnumlambda:wnumlambda,$ ;widget level number of wavelengths/betas per group
              printers:printers,$ ;List of printers available to unix system
              activeprinter:long(0), $ ;The index of the active UNIX printer
              xrange:dblarr(2),$ ;xrange for the plot window
              yrange:dblarr(2),$ ;yrange for the plot window
              xzoom:dblarr(2),$ ;xrange for zooming window
              yzoom:dblarr(2),$ ;yrange for zooming window
              lamset:lonarr(wnumorders),$ ;Flag to determine if a lambda or beta values specified
              serset:lonarr(wnumorders),$ ;Flag to determine if series or specific data is entered
              sorset:lonarr(wnumsource),$ ;Flag to determine what sources are set
              xstalset:lonarr(wnumxstals),$ ;Flag to determine what xstals are set
              groupOK:long(0),$ ;Flag which is set when a valid group has been specified
              filmOK:long(0),$ ;Flag which is set when valid film parameters are set
              autoflag:long(0),$ ;Flag which is set if automatic group configuration is selected
              plotflag:long(-1),$ ;Flag to say which plot was last chosen (for range changing)
              plotOK:long(0),$ ;Flag to say if enough parameters exist for ray-tracing plotting
              dataOK:long(0),$ ;Flag to say that the data can be plotted
              ellipset:long(1),$ ;Flag to determine whether in elliptical or TREX coordinates
              convexflag:long(0),$ ;Flag to determine whether in elliptical or convex geometry
              pick:long(0),$ ;Flag to determine if user has asked to pick a reference point on the data
              scaleOK:long(0),$ ;Flag to determine if a valid reference point has been picked
              scaleflag:lonarr(10),$ ;Flag to determine if the current data has been scaled
              wLOS:double(0.),$ ;TREX Origin coordinates
              LOSFlag:long(0),$ ;Flag to say if end-on (1) of side-on (0) TREX location
              wrot:double(0.),$ ;Addition crystal rotation in TREX coordinates
              xref:double(0.),$ ;Film reference position
              lamref:double(0.),$ ;Corresponding reference wavelength
              fitorder:long(5),$ ;Polynomial order to fit to dispersion curve
              fitflag:long(0),$ ;Flag to say what range to use for scaling calculations
              minwave:double(0.),$ ;The minimum wavelength to consider for scaling
              maxwave:double(0.),$ ;The maximum wavelength to consider for scaling
              intwave:double(0.),$ ;The wavelength interval to consider for scaling
              orderef:long(1), $ ;Corresponding reference diffraction order
              scaledwdf:lonarr(10), $ ;wdf arrays containing the scaled data
              datawdf:lonarr(10), $ ;wdf arrays containing the data
              overwdf:long(0), $ ;wdf array containing the overplot data set
              activedata:long(0), $ ;index of which dataset is being analyzed
              numdata:long(0), $ ;the number of open data files
              xzoomfac:float(2.), $ ;x zoom factor for plotting
              yzoomfac:float(2.), $ ;y zoom factor for plotting
              xsave:dblarr(2),$ ;previous x-range for plotting
              ysave:dblarr(2),$ ;previous y-range for plotting
              rulerflag:long(0),$ ;Flag to determine if the ruler button was selected
              rulerflag2:long(0),$ ;Flag to determine if the first ruler point was selected
              trimflag:long(0),$ ;Flag to determine if the trim button was selected
              zoomflag:long(0),$ ;Flag to say which zoom is selected (if any)
              overflag:long(0),$ ;Flag to say if data overplotting is active
              zoomsquare:long(0),$ ;Flag to say if zoom area should be kept square
              printwaves:long(1),$ ;Flag to say whether to print wavelengths on plot
              limitrays:long(0),$ ;Flag to say whether to limit diffraction to crystal dimensions
              overplot:long(0),$ ;Flag to overplot ray-tracing
              transflag:long(0),$ ;Flag to overplot known transitions
              showtrans:long(0),$ ;Flag to snap cursor clicks to known transitions
              whichelements:lonarr(element(0).numelements),$ ;Which elements does the user want
              whichtrans:lonarr(element(0).numelements,4),$ ;Which atomic transitions does the user want
              image:bytarr(3,graphicsize.xsize,graphicsize.ysize),$ ;background image (dimensions = Graphics_DRAW pixel sizes)
              swapflag:long(0)} ;Flag to determine of user's background color was swapped

;**********************************************************************************
;Initialze the variables
;**********************************************************************************
  exray_config,exraystr,/dds
  exray_xstal,exraystr,/adp
  exraystr.lamset(*)=1
  exraystr.serset(*)=0
  exraystr.wsource(*).n(*)=1
  exraystr.xrange=[-10,10]
  exraystr.yrange=[-10,10]
  widget_control,Ellipse_Button,SET_BUTTON=1
  widget_control,FSpecific_Button,SET_BUTTON=1
  index=where(datafile ne 'none')
  if (index(0) lt 0) then $
     widget_control,Data_Filename,SET_VALUE=datafile(0) $
  else $
     widget_control,Data_Filename,SET_VALUE=datafile(index)

  if (!p.background eq 0) then begin
     swap
     exraystr.swapflag=1
  endif

  maxwdf=get_maxwdf()
  if maxwdf lt 105 then $
     set_maxwdfarray,105
  exraystr.datawdf=findgen(10)+83
  exraystr.scaledwdf=findgen(10)+93
  exraystr.overwdf=82
  exraystr.wfilm.fogwdf=81

  Widget_Control, /REALIZE, Exray_BASE

  Widget_Control, Exray_BASE, set_uvalue = exraystr


  XManager, 'Exray_BASE', Exray_BASE,/No_Block

end
;
; Empty stub procedure used for autoloading.
;
pro exray_05, file=filename, dispersion=disp, resolution=resol,datas=data,$
           GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
  ;********these items for the binary version only*******
;  device, pseudo =8, bypass=0
;  color_init
;  plotfld,/set,cn=2
;  loadxyct
;  swap
;  ACCEPT_COPYRIGHT
  ;*********end binary dependent items************
  Exray_BASE, file=filename, dispersion=disp, resolution=resol,datas=data,$
           GROUP_LEADER=wGroup, _EXTRA=_VWBExtra_
end
