PRO exray_rescale, MainWidget, degree=deg, rescale=res1, bins=numb, poisson=poisson

Widget_Control, MainWidget, get_uvalue = exraystr
widget_control,exraystr.widget.Graphics,GET_VALUE=winID
wset,winID

lim1= !x.crange(0)
lim2= !x.crange(1)

;-save a copy of the data in case user not satisified with result
if (exraystr.plotflag eq 4) then begin
   w2i,xorig,yorig,exraystr.scaledwdf(exraystr.activedata)
   xfr,exraystr.scaledwdf(exraystr.activedata),61
endif else begin
   w2i,xorig,yorig,exraystr.datawdf(exraystr.activedata)
   xfr,exraystr.datawdf(exraystr.activedata),61
endelse

lim,61,lim1,lim2
w2i,x1,y1,61
fit=poly_fit(x1,y1,deg)
y2=y1*0.+fit(0)
for i=1,deg do y2=y2+fit(i)*x1^i
i2w,x1,y2,62
plo,[61,62],/ov,leg=-1,/xs,head=0,col=[0,1],line=[0,0]
wait,1.0

sub,61,62,63
add,63,0,total(y1)/n_elements(y1)
plo,[61,63],/ov,leg=-1,/xs,head=0,col=[0,1],line=[0,0]
wait,1.0

w2i,xn,yn,63
exray_makehist,xn,yn,/findrf,numb=numb, poisson=poisson, rescale=res1

ans=dialog_message('Would you like to rescale the data?',/question)
if (ans eq 'Yes') then begin
   if (exraystr.plotflag eq 4) then begin
      mul,exraystr.scaledwdf(exraystr.activedata),0,res1
   endif else begin
      mul,exraystr.datawdf(exraystr.activedata),0,res1
   endelse
endif

   plotflag=exraystr.plotflag
   exraystr.plotflag = 0
   widget_control,MainWidget,set_uvalue=exraystr
   widget_control,exraystr.widget.plotlist,send_event=$
      { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:MainWidget, $
         HANDLER:MainWidget, INDEX:plotflag }

Widget_Control, MainWidget, set_uvalue = exraystr

return
end