PRO exray_convex_initial,MainWidget

Widget_Control,MainWidget,get_uvalue=exraystr

;set the default xstal type, radius, rotation, and wedge angle
exraystr.xstalset(*)=0
exraystr.wxstal(*).rc = 0.
exraystr.wxstal(*).chi = 0.
exraystr.wxstal(*).p = 0.

exraystr.xstalset(0)=1
exraystr.wxstal(0).rc = 1.*2.54
exraystr.wxstal(0).chi = 19.5*!pi/180.
exray_convex_wedge,exraystr,/tixtl
exray_convex_xstal,exraystr,/KAP

;re-initialize the source values
exraystr.wsource(*).a = 0.
exraystr.wsource(*).b = 0.
exraystr.sorset(*) = 0
exraystr.wsource(*).n(*)=1
exraystr.wsource(*).lambda(*,*)=0.
exraystr.wxstal(*).beta(*,*)=0.
exraystr.serset(*) = 0
exraystr.lamset(*) = 1

;make-sure that proper flags are set
exraystr.filmOK = 1
exraystr.plotflag=-1
exraystr.plotok = 0
exraystr.crystalset = 0

;set the appropriate widget values
widget_control,exraystr.widget.wedge,set_droplist_select=0
widget_control,exraystr.widget.xstalc,set_droplist_select=1
widget_control,exraystr.widget.radiusc,set_value=exraystr.wxstal(0).rc/2.54
widget_control,exraystr.widget.rotationc,set_value= exraystr.wxstal(0).chi*180./!pi
widget_control,exraystr.widget.linec,set_button=1
widget_control,exraystr.widget.defaultc,set_button=0
widget_control,exraystr.widget.atxyc,set_button=0
widget_control,exraystr.widget.autoc,set_button=0
widget_control,exraystr.widget.lambda1c,set_button=0,sensitive=1
widget_control,exraystr.widget.beta1c,set_button=0,sensitive=1
widget_control,exraystr.widget.series1c,set_button=0,sensitive=1
widget_control,exraystr.widget.specific1c,set_button=0,sensitive=1
widget_control,exraystr.widget.editgroupsc,sensitive=1
widget_control,exraystr.widget.infile,set_value=['none']
widget_control,exraystr.widget.LOSC,set_button=0
widget_control,exraystr.widget.Crystal,set_button=1


if (exraystr.dataOK eq 1) then begin
   widget_control,exraystr.widget.plotlist,send_event=$
     { WIDGET_DROPLIST, ID:exraystr.widget.plotlist, TOP:MainWidget, $
     HANDLER:MainWidget, INDEX:3 }
endif
widget_control,exraystr.widget.plotlist,sensitive=0

widget_control,MainWidget,set_uvalue=exraystr

return
end