PRO Exray_Johann_ResCalc,exraystr,windID=winID

wset,winID

tempstr=replicate(exraystr,1)
tempstr.lamset(*)=0
tempstr.wsource(*).lambda(*,*)=0.
tempstr.serset(0)=1
tempstr.xstalset(*)=0
tempstr.xstalset(0)=1
tempstr.wxstal(*).beta(*,*)=0.
tempstr.wxstal(*).beta(0,0)=tempstr.wxstal(0).betamin
tempstr.wxstal(*).beta(0,1)=tempstr.wxstal(0).betamax
tempstr.wxstal(*).beta(0,2)= $
       (tempstr.wxstal(0).betamax-tempstr.wxstal(0).betamin)/tempstr.wnumlambda
exray_buildptr,tempstr,temptr

(*temptr).numsource=1
(*temptr).source(0).a=-(*temptr).xstal(0).R0
(*temptr).source(0).b=0.
exray_go,50,temptr,windID=winID

w2i,xJ,yJ,50
lambda=dblarr(n_elements(xJ))
lambda=(*temptr).source(0).lambda(0,*)
deltax=dblarr(n_elements(xJ)-1)
deltalam=dblarr(n_elements(xJ)-1)
avglam=dblarr(n_elements(xJ)-1)
for i=0,n_elements(xJ)-2 do begin
   deltax(i)=sqrt((xJ(i+1)-xJ(i))^2+(yJ(i+1)-yJ(i))^2)
   deltalam(i)=lambda(i+1)-lambda(i)
   avglam(i)=(lambda(i+1)+lambda(i))/2.
endfor

disp=deltalam/deltax
res=avglam/(disp*1.e-4*100.)

exraystr.xrange=[min(avglam),max(avglam)]
exraystr.yrange=[min(res),max(res)]

plot,avglam,res,col=0,xtitle='Wavelength (A)',ytitle='Resolution',charsize=1.2,psym=0 $
    ,xstyle=1,ystyle=1,xrange=exraystr.xrange,yrange=exraystr.yrange, pos=[0.15,0.1,0.95,0.957]
legend,['Resolution'],col=[0,1],line=[0,0]

delwdf,[50]

ptr_free,temptr
return
end