PRO exray_savedisp, exraystr

nametemp = ''
path=''
nametemp = dialog_pickfile(title='Save As:', /WRITE, $
                           filter='*.ufo',path=exraystr.path,get_path=path)
if (nametemp eq '') then return $
else if (strpos(nametemp,'.ufo') eq -1) then nametemp=nametemp+'.ufo'
exraystr.path=path

widget_control,/hourglass
widget_control,exraystr.widget.Graphics,GET_VALUE=winID
   xstalnum=0
   for i=0,exraystr.wnumxstals-1 do $
   if (exraystr.xstalset(i) eq 1) then $
      xstalnum=xstalnum+1
   wdfa=findgen(xstalnum)+50

   tempstr=replicate(exraystr,1)
   tempstr.autoflag = 1
   if (exraystr.convexflag ne 1) then begin
      exray_buildptr,tempstr,temptr
      exray_go,wdfa,temptr,xrange=exraystr.xrange,yrange=exraystr.yrange,$
          windID=winID
   endif else begin
      exray_convex_buildptr,tempstr,temptr
      exray_convex_go,wdfa,temptr,xrange=exraystr.xrange,yrange=exraystr.yrange,$
          windID=winID
   endelse
    if (exraystr.plotflag ne 1) then begin
        ;find the max and min of the data
        w2i,x,y,wdfa(0)
        exraystr.xrange=[min(x),max(x)]
        exraystr.yrange=[min(y),max(y)]
        for i=1,n_elements(wdfa)-1 do begin
           w2i,x,y,wdfa(i)
           if (min(x) lt exraystr.xrange(0)) then exraystr.xrange(0)=min(x)
           if (max(x) gt exraystr.xrange(1)) then exraystr.xrange(1)=max(x)
           if (min(y) lt exraystr.yrange(0)) then exraystr.yrange(0)=min(y)
           if (max(y) gt exraystr.yrange(1)) then exraystr.yrange(1)=max(y)
        endfor
    endif
    exraystr.plotflag=1
    if (exraystr.wfilm.JFlag eq 2) then begin
       ylabel='Y Position (cm)'
       xlabel='X Position (cm)'
    endif else begin
       ylabel='Wavelength (A)'
       xlabel='Film Position (cm)'
    endelse
    plo,wdfa,col=[0,1,2],line=[0,0,0],xtitle=xlabel,psym=0,$
       ytitle=ylabel,leg=-1,charsize=1.2,pos=[0.15,0.1,0.95,0.957], $
       xrange=exraystr.xrange,yrange=exraystr.yrange,xstyle=1,ystyle=1
    for i=0,xstalnum-1 do begin
       xstalstring='crystal #'+string(i+1)
       xstalstring=strcompress(xstalstring)
       legend,xstalstring,col=i,line=0,pos=[0.69,0.9-i*0.05],/normal,charsize=0.8
    endfor
    ptr_free,temptr

if (n_elements(wdfa) gt 1) then $
   whoops=dialog_message('Only writing dispersion for crystal #1',/Warning)

w2i,x,y,wdfa(0)

wufo,x,y,file=nametemp

return
end
