; ------------------------------------------------------------------------ 
; $Id: atfunin.pro,v 1.2 2005/03/09 22:21:39 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2005 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro atfunin, nc, clabl, x, y, np, xlabl, ylabl, max_atf, wda
;
; store one or more functions in wdf arrays
;
common at_fun
;
lb = 0
for m=0, nc-1 do begin
  lf = lb + np - 1
  wda(m) = n_atf mod max_atf + 1
  i2w, x, y(lb:lf), wda(m), clabel=clabl(m), xlabel=xlabl, ylabel=ylabl, $
  /xydata
  lb = lb + np
  n_atf = n_atf + 1
endfor
return
end
