; ------------------------------------------------------------------------ 
; $Id: atstartup.pro,v 1.3 2010/12/16 21:33:04 dbseide Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2005 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro atstartup
;
; ATHETA-specific initialization
;
 common at_colr, $
       at_bgc, at_fgc
 common at_axes, $
       at_xr, at_yr, at_xlabel, at_ylabel, at_title
 common at_fld, $
       at_fmin, at_fmax
 common at_grid, grid_nx, grid_ny, grid_x, grid_y
 common at_cell, cell_dz, cell_dr, cell_index
 common at_matl, mat_nm, mat_clr, mat_sig
 common at_part, $
       part_nc, part_x, part_y, part_l, part_n, $
       part_cl, part_lw
 common at_coil, $
       coil_nc, coil_x, coil_y, coil_l, coil_n, $
       coil_cl, coil_mk
 common at_curv, $
       curv_nc, curv_x, curv_y, curv_l, curv_n, $
       curv_cl
 common at_temp, $
       temp_nc, temp_x, temp_y, temp_l, temp_n, $
       temp_cl, temp_ls, temp_lw, temp_mk
 common at_fun, n_atf
;
; Define color table, background color, and foreground color
;
loadxyct
at_bgc = 0
at_fgc = 8
;
; Define user symbol "circle"
;
mksymbol,1
;
; Initialize # ATHETA WDF functions
;
n_atf = 0
;
; Turn off command line editing (^ character for TIO)
;
!edit_input = 0
;
; Turn off exception checking
;
!except = 0
return
end
