; ------------------------------------------------------------------------
; $Id $
; ------------------------------------------------------------------------
;
; Copyright 2005 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro moveit, save = save
  ls, '*.txt', current = current, /quiet
  if n_elements(current) eq 1 then begin
    if (strlen(current[0]) eq 0) then begin
      print, '% MOVEIT: No files found'
      return
    endif
  endif
  n = n_elements (current)
  if n ge get_maxwdf() then begin
    newmax = ( n/64L +2)*64
    set_maxwdfarray, newmax
  endif
; Read the text files
  for i = 0, n-1 do  reasc, current[i],1,  i+1, forma= 0, /xydata


; Write the hdf file
  writehdf, wdf = 1+indgen(n), save 

end
