; ------------------------------------------------------------------------ 
; $Id: savect.pro,v 1.3 2007/06/06 20:03:53 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro savect, file = filename
;
;+
;    save a color table in a file
;    special command to restore the bottom 8 colors and scale the others
;    to fill the table
;    format: savect, file = filename
;-
  on_error, 1

  if n_elements(filename) eq 0 then filename = 'idl_color_table.dat'
;
  tvlct, /get , r, g, b
  save, file = filename, r, g, b
  return
  end
