; ------------------------------------------------------------------------ 
; $Id: blocks.pro,v 1.3 2007/06/06 20:11:32 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro blocks, range , color = color , thick = thick, printit = pr

if n_elements(thick) eq 0 then thick = 2
if n_elements(color) eq 0 then color = 2

ss = size(range) 
nblo = ss[3]-1

for i = 1, nblo do begin

  xx = [range[0,0,i], range[1,0,i],range[1,0,i],range[0,0,i],range[0,0,i]]
  yy = [range[0,1,i], range[0,1,i],range[1,1,i],range[1,1,i],range[0,1,i]]
  oplot, xx, yy, thick = thick, color = color
  if keyword_set(pr) then xyouts, (range[0,0,i]+ range[1,0,i])*0.5, $
    (range[0,1,i]+range[1,1,i])*0.5, strtrim(i, 2), align=0.5
endfor
end
