; ------------------------------------------------------------------------ 
; $Id: get_markers.pro,v 1.4 2010/09/29 20:59:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro get_markers_event, event
    but = event.value
    widget_control, event.top, get_uvalue = info, /no_copy
    case but of 

 'QUIT' : BEGIN
          quitit = 1
          varname = ''
          labname = ''
          END
 'OK' : BEGIN
          quitit = 0
          widget_control,info.var, get_value = varname 
          widget_control,info.label, get_value = labname 
          END
     ELSE: Print, ' Not a known event'
     endcase
     value = {varname: varname, labname:labname, quit: quitit}
     widget_control, info.ptr, set_uvalue = value, /no_copy
     widget_control, event.top, /destroy
     end
 Pro get_markers, lcquit, string1, string2, xsize = xsize
     on_error, 1
     if n_elements (xsize) eq 0 then xsize = 60
     base = widget_base(/column, title= 'Marker Parameters')
     lcquit = 1
     if n_elements (string1) eq 0 then string1 = ''
     if n_elements (string2) eq 0 then string2 = ''
     label = cw_field(base, title= 'Marker ID', xsize = xsize/3, $
           value = string1)
     Var = cw_field(base, title= 'Marker Comment', xsize = xsize, $
           value = string2)
     menu = make_array(2, /string)
     menu(0) = '             OK            ' 
     menu(1) = ' Quit Without Saving Marker'
     but = cw_bgroup(base, menu,/row,/no_release,button_uvalue =['OK','QUIT'])
     ptr = widget_base()
     widget_control, base, /realize
     info = {var: var, label:label,  ptr:ptr}
     widget_control, base, set_uvalue = info
     value = {varname:'', labname:string1,  quit:0}
     xmanager, 'get_markers', base,/modal
     widget_control, ptr, get_uvalue = value
     widget_control, ptr, /destroy
     lcquit = value.quit
     string1 = strtrim(value.labname, 2)
     string2 = strtrim(value.varname, 2)
     return
     end
