; ------------------------------------------------------------------------ 
; $Id: get_tqmark.pro,v 1.4 2010/09/29 20:59:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function get_tqmark , xp, yp
; get closest marker point to xp, yp
@pfidltq.com
 on_error, 1
 if n_elements (xp) eq 0 or n_elements(yp) eq 0 then message, $
    'Input parameters must be defined.'
 nm = n_elements (markx)
 if nm eq 0 then message, $
    'Marker parameters must be defined.'
 marky = marky(0:nm-1)
 junk = min((gx(markx)-xp)^2 +(gy(marky)-yp)^2, j)
 return,  j
 end
