; ------------------------------------------------------------------------ 
; $Id: qs_del_pnts.pro,v 1.4 2010/09/29 20:59:14 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro qs_del_pnts, axis, xin, ier
;
@pfidltq.com
      on_error, 1
      ier = 1
      if axis eq 0 then begin 
        nel = n_elements(x)-1
        if nel gt 1 then begin
          dist = min (abs(xin-x), j)
          if dist gt abs(dx(j)+dx(j)) then begin
            wmessage, 'No grid at this location'
            return
          endif
          if j eq 0 then begin
            x = x(1:*)
            dx = dx(1:*)
            xgridtype = xgridtype(1:*)
          endif else if j eq nel then begin
            x = x(0:nel-1)
            dx = dx(0:nel-1)
            xgridtype = xgridtype(0:nel-1)
          endif else begin
            x = [x(0:j-1), x(j+1:*)]
            dx = [dx(0:j-1), dx(j+1:*)]
            xgridtype = [xgridtype(0:j-1), xgridtype(j+1:*)]
          endelse
          ier = 0
        endif else wmessage, 'Cannot reduce below 2 points'
     endif else begin
       nel = n_elements(y)-1
         if nel gt 1 then begin
           dist = min (abs(xin-y), j)
           if dist gt abs(dy(j)+dy(j)) then begin
             wmessage, 'No grid at this location'
             return
           endif
           if j eq 0 then begin
             y = y(1:*)
             dy = dy(1:*)
             ygridtype = ygridtype(1:*)
           endif else if j eq nel then begin
             y = y(0:nel-1)
             dy = dy(0:nel-1)
             ygridtype = ygridtype(0:nel-1)
           endif else begin
             y = [y(0:j-1), y(j+1:*)]
             dy = [dy(0:j-1), dy(j+1:*)]
             ygridtype = [ygridtype(0:j-1), ygridtype(j+1:*)]
           endelse
           ier = 0
        endif else wmessage, 'Cannot reduce below 2 points'
      endelse
      return 
      end


