; ------------------------------------------------------------------------ 
; $Id: tqsplit_cond.pro,v 1.3 2007/06/06 20:12:43 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro tqsplit_cond, i, n
; split conductor
;
@pfidltq.com
;
@tqeditevent.com
      old_cond = cond
      xx = cond.x
      yy = cond.y
      loc = cond.locx
      if n+2 gt loc (i)- loc(i-1) or n eq 0 then begin
        winformation, $
           'Cannot split a conductor with less than 2 points in each'
        return
      endif
      x1 = xx(loc(i-1):loc(i-1)+n)
      y1 = yy(loc(i-1):loc(i-1)+n)
      x1(n) = x1(n) - 6.0e-5*(x1(n)-x1(n-1))
      y1(n) = y1(n) - 6.0e-5*(y1(n)-y1(n-1))
      x2 = xx(loc(i-1)+n:loc(i)-1)
      y2 = yy(loc(i-1)+n:loc(i)-1)
      x2(0) = x2(0) + 6.0e-5 * (x2(1) -x2(0))
      y2(0) = y2(0) + 6.0e-5 * (y2(1) -y2(0))
      n1 = n_elements(x1)
      n2 = n_elements(x2)
      ncon= cond.ncon
      array2pack, i, ncon, loc, n1, xx, x1, yy, y1
      loc = [loc(0:ncon), n2+loc(ncon)]
      xx = [xx(0:loc(ncon)-1), x2]
      yy = [yy(0:loc(ncon)-1), y2]
      ncon = ncon+1
;
      loci = cond.loci
      nel = n_elements(loci)
      loci = [loci, loci(nel-1)]
      locp = cond.locp
      nel = n_elements(locp)
      locp = [locp, locp(nel-1)]
      locb = cond.locb
      nel = n_elements(locb)
      locb = [locb, locb(nel-1)]
      cond = {ncon:ncon, lcfit:0, x:xx, y:yy, locx:loc, $
             ix:cond.ix, iy:cond.iy, loci:loci, iplotx:cond.iplotx, $
             iploty:cond.iploty, locp:locp, $
             badxy:cond.badxy, locb:locb, nbad:cond.nbad }
      return
      end
