; ------------------------------------------------------------------------ 
; $Id: clear_wdfarray.pro,v 1.3 2007/06/06 19:34:26 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro  clear_wdfarray, wdf
;
;+
;  clear the data values from a wdf array
;-
;
;
@com.dat
;
      if wdf lt 1 or wdf gt maxwdfarray then begin
        print, 'wdf array must be greater than 0 and </=', maxwdfarray
        return
      endif
;
      wm= wdf-1
      if wdfarraycom(wm) gt 0 then handle_value, wdfarraycom(wm),  0.0, /set
      wdfnp(wm)= 0
      wdfcomment(wm) = ''
      wdffile(wm) = ''
      wdfxlabel(wm) = ''
      wdfylabel(wm) = ''
      return
      end
