; ------------------------------------------------------------------------ 
; $Id: my_wshow.pro,v 1.3 2010/11/18 17:52:51 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro my_wshow ,win, verbose = verbose, iconic = iconic
Catch, error_status
IF Error_status NE 0 THEN BEGIN 
  if keyword_set(verbose) then begin
      PRINT, 'Error index: ', Error_status 
      PRINT, 'Error message: ', !ERROR_STATE.MSG 
  endif
; Handle the error by RETURN 
  CATCH, /CANCEL
  RETURN
ENDIF
if n_elements(iconic) eq 0 then iconic = 0
wshow, win, 1, iconic = iconic
end
