; ------------------------------------------------------------------------ 
; $Id: pick_one.pro,v 1.4 2007/06/06 19:34:31 lpmix Exp $ 
; ------------------------------------------------------------------------ 
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 pro pick_one_event, event
   on_error, 1
   widget_control, event.id, get_uvalue = uval
   if uval eq 'LIST' then return
   widget_control, event.top, get_uvalue = ptr
   widget_control, (*ptr).wbut, get_value = val
   (*ptr).val = val
   widget_control, event.top, /destroy
   end
   
 pro pick_one, list, pick, instructions = instruc, title = title

   on_error, 1
   nel = n_elements(list)
   if nel le 1 then begin
     pick =0
     return
   endif
   val= nel-1
   if n_elements(title) eq 0 then title = 'Select Shot Description'
   tlb = widget_base(title = title, /column)
   if keyword_set(instruc) then $
     winst= widget_label(tlb, value = instruc)
   wbut = cw_bgroup(tlb, list, /column, /exclusive, /no_release, $
      uvalue = 'LIST', set_value = val)
   wdone = widget_button(tlb, value = '  D O N E  ', uvalue = 'DONE')
   widget_control, tlb, /realize
   ptr = ptr_new({wbut:wbut, val:val})
   widget_control, tlb, set_uvalue = ptr
   xmanager, 'pick_one', tlb
   pick = (*ptr).val
   ptr_free, ptr
   end
