; ------------------------------------------------------------------------ 
; $Id: qsstruct_init.pro,v 1.4 2007/06/06 19:34:31 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 Pro qsstruct_init
;+
;  Initialize structure storage variables and arrays
;-
on_error, 1
 COMPILE_OPT hidden
@qsstrcom.dat
;
common copyright_common, copyright_init
;
@draw_defaults.com
; common draw_defaults, rrratio, bigsize, medsize, dualsize, smallsize

      if n_elements (copyright_init) eq 0 then copyright_notice
      if n_elements (rrratio) eq 0 then set_drawsize, /init

      if n_elements (structinit) eq 1 then begin
        if structinit ne 0 then return
      endif
      if n_elements(maxstructure) eq 0 then maxstructure = 82
      comment = make_array(maxstructure, /string, value = '')
      strarraycom = make_array(maxstructure, /long, value = 0L)
      lcvalidstr = make_array(maxstructure, value=0)
      structinit = 1
      userqsinit
      return
      end
