; ------------------------------------------------------------------------ 
; $Id: strarr2byt.pro,v 1.3 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function strarr2byt, stringarr, length, nelem
;
;+ 
;   convert an array of strings to a byte array
;-
    bytarray = make_array(nelem*length, /byte, value = 32b)
    for i = 0, nelem-1 do begin
      str2byt, stringarr(i), temp, length
      bytarray(i*length:(i+1)*length-1) = temp
    endfor
    return, bytarray
    end

