; ------------------------------------------------------------------------ 
; $Id: thin_date.pro,v 1.4 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

 function thin_date, par, short = short
;
; Return the current date in the form:
;   'Mar 8 07:51 2001'
; If keyword short is set, return the current date in the form:
;   'Mar 8 2001'
;
 COMPILE_OPT hidden
 thindate = (n_elements(par) eq 0) ? systime(0) : systime(0, par)
; thindate = strmid(thindate, 4, 12)+ strmid(thindate, 19, 5)
 if keyword_set(short) then $
   return, strcompress(strmid(thindate, 4, 6)+','+ strmid(thindate, 19, 5))
 return, strcompress(strmid(thindate, 4, 12)+ strmid(thindate, 19, 5))
 end 
