pro get_shot_los_event, event
  common get_tgs_param_common, offset , offset_real, data_directory
 widget_control, event.id, get_uvalue = uvalue
 widget_control, event.top, get_uvalue = info
 id =-1
 Case uvalue of 
  'LOS': id = info.losw
  'SHOT_NUMBER': BEGIN
      id = info.shotw
      widget_control, id, get_value = val
      widget_control, id, set_value = val
      END

  'EXIT': BEGIN
      widget_control, info.losw, get_value = val
      (*(info.ptr)).los = val
      widget_control, info.shotw, get_value = val
      (*(info.ptr)).shotnum = val
      widget_control, event.top, tlb_get_offset = offset
      offset = offset+offset_real
      (*(info.ptr)).quit = 0
      widget_control, event.top, /destroy
      END

  'QUIT': BEGIN
      (*(info.ptr)).quit = 1
      widget_control, event.top, /destroy
      END
  
 else: print, 'not covered' 
 endcase
end

pro get_shot_los_param, lcquit, shotnum, lostype

common get_tgs_param_common

on_error, 1

dum = 0
if n_elements(offset) lt 2 then offset = [10,10]
if  n_elements(group) eq 0  then group = 0


tlb = widget_base(group_leader = group, /column, /map, $
        title ='TGS Unfold')

tlbb = widget_base(tlb, frame = 2, /map, /column)
if n_elements (shotnum) eq 0 then shotnum  = 0L
shotw = cw_field(tlbb, value = shotnum, /row, /return, xsize = 6, $
        title='Shot Number', /long, uvalue = 'SHOT_NUMBER') 

if n_elements(lostype) eq 0 then lostype = 0 
btns = [ $
         'LOS 5/6', $
         'LOS 17/18', $
         'LOS 29/30' ] 
tlba = widget_base(tlb, frame = 2, /map, /column)
losw = CW_BGROUP( tlba, Btns, $
      set_value = lostype, $
      COLUMN=1, $
      EXCLUSIVE=1, /NO_RELEASE, $
      LABEL_TOP='Line of Sight', $
      UVALUE='LOS')

bbase = widget_base(tlb, /row, /map, frame=2)
wread = widget_button(bbase, value = '  Q U I T  ', uvalue = 'QUIT')
wread = widget_button(bbase, value = ' F I N I S H E D ', uvalue = 'EXIT')

  widget_control, tlb, /realize, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)
  widget_control, tlb, tlb_get_offset= offset_real
  offset_real = offset - offset_real
  str = { los:lostype, shotnum:shotnum, quit:0}
  ptr = ptr_new(str)
  info={ptr:ptr, losw:losw, shotw:shotw}
  
  widget_control, tlb, set_uvalue = info
  XMANAGER, 'get_shot_los', tlb
  lcquit = (*ptr).quit 
  if lcquit eq 1 then return
  lostype = (*ptr).los
  shotnum = (*ptr).shotnum
  lcquit = 0
end
