; ------------------------------------------------------------------------ 
; $Id: bending.pro,v 1.2 2005/03/09 22:21:19 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2005 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro bending
;
spawn,'wc p-traj.dat',result
reads, result, nval
;
r = make_array(nval,/float)
t = make_array(nval,/float)
z = make_array(nval,/float)
;
openr, 10, 'p-traj.dat'
for n=0, nval-1 do begin
  readf, 10, rr, tt, zz, vr, vt, vz
  r[n] = rr
  t[n] = tt
  z[n] = zz
endfor
rt = r*t
i2w,z,rt,2,clab='Applied-B bending',xlab='z',ylab='r-theta',/xydata
plo,2
;
close, 10
return
end
