; ------------------------------------------------------------------------ 
; $Id: atgeoin.pro,v 1.2 2005/03/09 22:21:39 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2005 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro atgeoin, lbl, nc, x, y, l, n, cl, ls, lw, mk
;
common at_part
common at_coil
common at_curv
common at_temp
;
case lbl of
'part': begin
        part_nc = temporary(nc)
        part_x = temporary(x)
        part_y = temporary(y)
        part_l = temporary(l)
        part_n = temporary(n)
        part_cl = temporary(cl)
        if n_params() gt 8 then part_lw = temporary(lw)
        end
'coil': begin
        coil_nc = temporary(nc)
        coil_x = temporary(x)
        coil_y = temporary(y)
        coil_l = temporary(l)
        coil_n = temporary(n)
        coil_cl = temporary(cl)
        coil_mk = temporary(mk)
        end
'curv': begin
        curv_nc = temporary(nc)
        curv_x = temporary(x)
        curv_y = temporary(y)
        curv_l = temporary(l)
        curv_n = temporary(n)
        curv_cl = temporary(cl)
        end
 else : begin
        temp_nc = temporary(nc)
        temp_x = temporary(x)
        temp_y = temporary(y)
        temp_l = temporary(l)
        temp_n = temporary(n)
        temp_cl = temporary(cl)
        temp_ls = temporary(ls)
        temp_lw = temporary(lw)
        temp_mk = temporary(mk)
        end
endcase
return
end
