pro qs_plotsetup
;
;  Set up parameters for new plot
;
@qs_enums.com
@qs_data.com
@qsplotpars.com
;
crdflg = qs_grid.spare[0]

polar = 0
;
if c_norm eq I_DIR then begin
  no = I_DIR
  if flip then begin 
    t1 = K_DIR
    t2 = J_DIR
  endif else begin
    t1 = J_DIR
    t2 = K_DIR
  endelse
endif else if c_norm eq J_DIR then begin
  no = J_DIR
  if crdflg eq SPHERICAL then begin
    t1 = I_DIR
    t2 = K_DIR
    polar = 1
  endif else if flip then begin 
    t1 = I_DIR
    t2 = K_DIR
  endif else begin
    t1 = K_DIR
    t2 = I_DIR
  endelse
endif else if c_norm eq K_DIR then begin
  no = K_DIR
  if (crdflg eq CYLINDRICAL) or (crdflg eq SPHERICAL) then begin
    t1 = I_DIR
    t2 = J_DIR
    polar = 1
  endif else if flip then begin 
    t1 = J_DIR
    t2 = I_DIR
  endif else begin
    t1 = I_DIR
    t2 = J_DIR
  endelse
endif else begin
  print, '% Invalid normal flag'
endelse

return
end
