; ------------------------------------------------------------------------ 
; $Id: close_pdb.pro,v 1.4 2007/06/06 19:45:14 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  pro close_pdb, pid, ier
;
;   Close a pdb file with file id equal to PID.
  on_error, 1
;
@pdbcom.dat
; PDB common block
;
   on_error, 1
;
   ier = 0L
   if pid eq 0 then return
   if initpdb eq 1  then begin
; HP
        junk = call_external(PDB_EXE,'pdb_close',pid,ier)
   endif else if initpdb eq 2 then begin
; Sun
        junk = call_external(PDB_EXE,'pdb_close_',pid,ier)
   endif else if initpdb eq 4  then begin
; WIN
        junk = call_external(PDB_EXE,'_PDB_CLOSE@8',pid,ier)
   endif
   end
