; ------------------------------------------------------------------------ 
; $Id: add_rsi_help.pro,v 1.2 2007/06/06 20:03:44 lpmix Exp $
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Pro add_rsi_help
;
;+
; Name: ADD_RSI_HELP
; 
; Description:
;       Add the RSI routines to the LHELP command
;       Caution: Some of the help routines are over 10 years old and 
;                the routines have changed or added new keywords.
;                These HELP files are no longer supported by RSI.
;
; Format: add_rsi_help
;
;-
 sep = path_sep()
 search = path_sep(/search_path)
 b = get_pfidl_directory()
 !help_path = b+'help'+sep+'rsi_help_files'+search+!help_path
end
