; ------------------------------------------------------------------------ 
; $Id: swap.pro,v 1.4 2010/09/17 21:23:38 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
  Pro swap
;+ 
; Name:         swap.pro
; Purpose:      Reverses background and drawing colors for future plots
;               Note: Does not change color table so existing plots are 
;                     not modified
;               See swapct.pro to modify color table
; Format: swap
; Technique: switches !p.color and !p.background
;-
on_error, 1
common swap_common, lcswap
  if n_elements (lcswap) eq 0 then lcswap = 0
  temp = !p.color
  !p.color = !p.background
  !p.background = temp
  lcswap = (lcswap) ? 0 : 1
  end
