; ------------------------------------------------------------------------ 
; $Id: whatsnew.pro,v 1.3 2007/06/06 20:03:56 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro whatsnew
;+
; NAME:
;	WHATSNEW
;
; PURPOSE:
;	Provides an acrobat interface to the Whats New file.
;
; CATEGORY:
;	Help documentation
; FORMAT:
;       WhatsNew
;
; COMMON BLOCKS:
;	None.
; MODIFICATION HISTORY:
;       Original version July 5, 2001
;-
;
;
on_error, 1
         b  = !DIR
         fam = strmid(strupcase(!version.os_family), 0, 3)
         if fam eq 'UNI' then $
           spawn, 'acroread '+ b+'/docs/whatsnew.pdf &'  $
             else $
           spawn, b+'\docs\whatsnew.pdf', /hide, /nowait
       end
