; ------------------------------------------------------------------------ 
; $Id: add_label.pro,v 1.3 2007/06/06 20:12:25 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro add_label, i, label, name
 on_error, 1
 if n_elements(i) eq 0 then begin
   print, '% ADD_LABEL: Element must be defined.
   return
 endif

 if i lt 1 or i gt nlab+1 then begin
   print, '% ADD_LABEL: Unable to add label: ', i, nlab
   return
 endif

 if n_elements (name) eq 0 then name = strtrim(i, 2)

 nlab= n_elements(label)
 if i eq 1 then begin
   if nlab eq 1 then label = name else label = [name, label[2,*]]
   return
 endif

 if i eq (nlab+1) then label = [label, name] else $
   if i eq nlab then label = [label [0:nlab-2], name]  else $
     label = [label[0:i-2],name, lab[i:*]]
 end 
