; ------------------------------------------------------------------------ 
; $Id: delete_label.pro,v 1.3 2007/06/06 20:12:25 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 pro delete_label, i, label
 on_error, 1
 if n_elements(i) eq 0 then begin
   print, '% DELETE_LABEL: Element must be defined.
   return
 endif

 if i lt 1 or i gt nlab then begin
   print, '% DELETE_LABEL: Unable to delete label: ', i, nlab
   return
 endif

 nlab= n_elements(label)
 if nlab le 1 then begin
   label = ''
   return
 endif

 if i eq 1 then label = label [1:*] else $
   if i eq nlab then label = label [0:nlab-2] else $
     label = [label[0:i-2], lab[i:*]]
 end 
