; ------------------------------------------------------------------------ 
; $Id: add_tqmrk.pro,v 1.3 2007/06/06 20:12:40 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 PRO  add_tqmrk, coord, str2, str1
;
;  Common Blocks
;
@pfidltq.com
      lcquit = 0
      nm = N_elements(markx)
      if nm eq 1 then if markx(0) eq -1 then nm = 0
      if n_elements(str1) eq 0 then str1 = 'marker'+strtrim(nm,2)
      if n_elements(str2) eq 0 then begin
        get_markers, lcquit, str1, str2
        if lcquit eq  1 then return
      endif
;
      i = fix(coord(0))
      j = fix(coord(1))
      new = make_array(3, /string)
      new(0) ='# Marker at the locations ( '+ strtrim(string(gx(i)), 2) +$
        ' ,  ' + strtrim(string(gy(j)), 2) +' )'
      if strlen(str2) gt 78 then str2 = strmid(str2, 0, 78)
      new(1)= '# '+str2
      if strlen(str1) gt 20 then str1 = strmid(str1, 0, 78)
      new(2)= '^Gdefine  '+str1+"  '"+strtrim(i+2,2)+' '+strtrim(j+2,2)+"'"
      nm = N_elements(markx)
      if nm  gt 1 then begin
          markx = [markx, i ]
          marky = [marky, j ]
          markerstring = [markerstring, new]
      endif else if nm eq 0 then begin
          markx = I
          marky = j
          markerstring = new
      endif else if markx(0) eq -1 then begin
          markx = I
          marky = j
          markerstring = new
      endif else begin
          markx = [markx, i ]
          marky = [marky, j ]
          markerstring = [markerstring, new]
      endelse
;
      return
      end
