; ------------------------------------------------------------------------ 
; $Id: move_tqpnts.pro,v 1.3 2007/06/06 20:12:42 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 PRO  move_tqpnts, ival, coord
;
;  Common Blocks
;
; ival is the insertion point
; coord is the spatial point in 'COND' mode and the ij grid point in 
;  'INPUT' mode
@pfidltq.com
;
@tqeditevent.com
      on_error, 1
      ncon = cond.ncon
      if lcsegment lt 1 or lcsegment gt ncon then message, $
        'Bad conductor segment - '+ strtrim(lcsegment, 2) + string(ncon)
        old_cond = cond
      if lcmode eq 'COND' then begin
        ival = cond.locx(lcsegment-1)+ival
        cond.x (ival) = coord(0)
        cond.y (ival) = coord(1)
      endif else begin
        ival = cond.loci(lcsegment-1)+ival
        cond.ix (ival) = coord(0)
        cond.iy (ival) = coord(1)
        get_tqplotpnts
        get_tqbad
      endelse
      return
      end
