; ------------------------------------------------------------------------ 
; $Id: get_save_str.pro,v 1.4 2007/06/06 19:34:29 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 Function  Get_Save_str, wdf1, wdf2
;
;+
;     format: save = get_save_str (str1, str2)
;     This procedure returns a valid save structure in the function
;      str1 is tried first, then an unused structure array, then 
;      str2 is the default.
;-
;
 COMPILE_OPT hidden
on_error, 1
@qsstrcom.dat
;
      if n_elements (wdf1) ne 0 then begin
        ss = size(wdf1) 
        if ss(ss(0)+1) gt 4 then begin
          print,'% GET_SAVE_STR: A valid sturcture array number must be entered.'
          return, wdf2
        endif
        wdf1 = round(wdf1)
        if wdf1 gt 0 and wdf1 le maxstructure then return, wdf1
      endif 
;
      ok = where ( lcvalidstr eq 0, nok)
      if nok gt 0 then return, (ok[0]+1) else return, wdf2
      end
