; ------------------------------------------------------------------------ 
; $Id: get_wdf_labels.pro,v 1.3 2007/06/06 19:34:29 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;

Pro get_wdf_labels_event, event
widget_control, event.top, get_uvalue = info
widget_control, info.clab, get_value = clab
widget_control, info.xlab, get_value = xlab
widget_control, info.ylab, get_value = ylab
widget_control, info.flab, get_value = flab
 *(info.ptr) = strtrim([clab, xlab, ylab, flab], 2)
widget_control, event.top, /destroy
end

pro get_wdf_labels, clabel, xlabel, ylabel, file, text = text,  $
        modal = modal, group = group

on_error, 2
tlb = widget_base(/column, modal = modal, group = group)

if n_elements(text) eq 0 then text = $
     'Enter the Dataset Comment, X and Y labels, and file name for this data'

txt = widget_label(tlb, value = text)

clab = cw_field (tlb, /string, value = '', /frame, xsize = 50, $
         title = 'Comment Label:')
xlab = cw_field (tlb, /string, value = '', /frame, xsize = 50, $
         title = 'X Label:')
ylab = cw_field (tlb, /string, value = '', /frame, xsize = 50, $
         title = 'Y Label:')
flab = cw_field (tlb, /string, value = '', /frame, xsize = 50, $
         title = 'File Name:')

but = widget_button(tlb, /frame, value = ' Finished / Exit ')
widget_control, tlb, /realize

ptr = ptr_new(make_array(4, value = '', /string))
info = {clab:clab, xlab:xlab, ylab:ylab, flab:flab, ptr: ptr}
widget_control, tlb, set_uvalue = info
xmanager, 'get_wdf_labels', tlb
clabel = (*ptr)[0]
xlabel = (*ptr)[1]
ylabel = (*ptr)[2]
file = (*ptr)[3]

ptr_free, ptr
 end
