; ------------------------------------------------------------------------ 
; $Id: lpmtest.pro,v 1.4 2007/06/06 19:34:30 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
pro lpmtest
 COMPILE_OPT hidden
dx = 0.02
dy = 0.025
x = findgen(101)*dx
y = findgen(101)*dy
arr2str,1,dist(101),x,y,clab='Test Plot',ylab='Dist',xlab='Dist', $
   dx = dx, dy = dy
dx = 0.00500
dy = 0.00625
x = findgen(401)*dx
y = findgen(401)*dy
arr2str,2,dist(401),x,y,clab='Big Test Plot',ylab='Dist',xlab='Dist', $
   dx = dx, dy = dy
dx = 0.05
a = findgen(101)*dx
b = a*exp(1-a)
put_wdfarray, [0.,dx,b], 1,  clab = 'Test Plot', ylab='Y Dist', xlab='X Dist'
 dx = 0.01
 a = findgen(501)*dx
; half width given implies c value given below
 half_width = 0.75
 c = half_width/sqrt(-alog(0.5))
 b = exp(-((a-2.5)/c)^2)
put_wdfarray, [0, dx, b], 2, clab='gaus=exp(-(x-2.5)^2)', xlab = 'X'
end
