; ------------------------------------------------------------------------
; $Id: plotfld_defaults.com,v 1.6 2011/07/06 15:35:11 lpmix Exp $
; ------------------------------------------------------------------------
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
; common block for plotfld
;
common plotfld_defaults, HEADER_SAVE, COLOR_SAVE, INDEX_SAVE, LEVELS_SAVE, $
                  XRANGE_SAVE, YRANGE_SAVE, NLEVEL_SAVE, THERMOMETER_SAVE, $
                  ASPECT_SAVE, CNTOUR_SAVE, PIXPLOT_SAVE, TRUNCATE_SAVE, $
                  C_RANGE_SAVE, OLD_BYTVL, ALWAYS_PLOT_SAVE
;
      if keyword_set(unset) or n_elements(c_range_save) eq 0 then begin
        if n_elements (fldcolor) eq 0 then fldcolor = -1
        COLOR_SAVE  = fldcolor
        C_RANGE_SAVE= $
          (!d.table_size lt 20) ? [!p.color, !p.color] : [9, !d.table_size-2]
        XRANGE_SAVE = 0
        YRANGE_SAVE = 0
        NLEVEL_SAVE = 20
        LEVELS_SAVE = 0
        INDEX_SAVE  = 0
        THERMOMETER_SAVE = 0
        HEADER_SAVE = 1
        ASPECT_SAVE = 0
        CNTOUR_SAVE = 4
        TRUNCATE_SAVE = 0
        PIXPLOT_SAVE = 0
        POLARPLOT = 0
        OLD_BYTVL = 0
        ALWAYS_PLOT_SAVE = 0
      endif

