; ------------------------------------------------------------------------ 
; $Id: winstruction.pro,v 1.3 2007/06/06 19:34:33 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
 function winstruction, message, offset = offset
;+
; This is the procedure that creates a information widget.
; format:
;       win= winstruction, message, offset = offset
;            message may be a sting array
;            win is  the widget number 
; example;
;     put the message up to 'Select a conductor', 'to edit of modify'
;      win = winstruction, ['Select a conductor', 'to edit of modify']
;-
messbase = WIDGET_BASE(TITLE = '   Instruction    ', $
        /COLUMN )

wdflabel = WIDGET_LABEL(messbase, VALUE = ' ' )
if n_elements (message) gt 0 then begin
  for i = 0, n_elements (message)-1 do $
     wdrlabel = WIDGET_LABEL(messbase, VALUE = message(i))
endif else wdrlabel = WIDGET_LABEL(messbase, VALUE = message)
wdrlabel = WIDGET_LABEL(messbase, VALUE = ' ')

 if n_elements (offset) lt 2  then begin
    offset = [0, 0]
    WIDGET_CONTROL, messbase, /REALIZE
  endif else $
  WIDGET_CONTROL, messBASE, /REALIZE, tlb_set_xoffset = offset(0)> 10, $
       tlb_set_yoffset= offset(1) > 10

return, messbase
end

