; ------------------------------------------------------------------------ 
; $Id: wwarning.pro,v 1.3 2007/06/06 19:34:34 lpmix Exp $ 
; ------------------------------------------------------------------------ 
;
; Copyright 2007 Sandia Corporation.
; Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
; license for use of this work by or on behalf of the U.S. Government.
;
PRO wwarning, message, offset = offset

;+
; This procedure issues a warning
; format:
;     wwarning, message
;         message may be a string array
; Example
;     wwarning, ['This is a real crazy request' , $
;             'Please consider another choice']
;-
; This is the procedure that creates a message widget.
messbase = WIDGET_BASE(TITLE =  'C A U T I O N', $
	/COLUMN )

; A widget for instructional text is created

wdrlabel = WIDGET_LABEL(messbase, $
    VALUE = '* * * * * * * * * WARNING * * * * * * * * *')
if n_elements (message) gt 0 then begin
  for i = 0, n_elements (message)-1 do $
     wdrlabel = WIDGET_LABEL(messbase, VALUE = message(i))
endif else wdrlabel = WIDGET_LABEL(messbase, VALUE = message)
wdrlabel = WIDGET_LABEL(messbase, $
    VALUE = '* * * * * * * * * WARNING * * * * * * * * *')
;
button = WIDGET_BUTTON(messbase, VALUE = 'OK', UVALUE = 'DONE')

 WIDGET_CONTROL, messbase, /REALIZE
 if n_elements(offset) gt 1 then widget_control, messbase, $
   tlb_set_xoffset = offset[0], tlb_set_yoffset=offset[1]
  event = WIDGET_EVENT (messbase)
  WIDGET_CONTROL, event.top, /DESTROY
end
