pro get_tgs_parameters_event, event
  common get_tgs_param_common, offset , offset_real, data_directory
 widget_control, event.id, get_uvalue = uvalue
 widget_control, event.top, get_uvalue = info
 id =-1
 Case uvalue of 
  'SHOT_TYPE': BEGIN
      (*(info.ptr)).hohl = event.value
     widget_control, info.bbb, map = event.value-1
     widget_control, info.ccc, map = event.value 
     END
  'FRACTION': BEGIN
      id = info.shotf
      widget_control, id, get_value = val
      widget_control, id, set_value = val
      END
  'THETA': BEGIN
      id = info.shott
      widget_control, id, get_value = val
      widget_control, id, set_value = val
      END
  'PHI': BEGIN
      id = info.shotp
      widget_control, id, get_value = val
      widget_control, id, set_value = val
      END
  'SI_BROWSE': BEGIN
      widget_control, info.wsi, get_value =b
      a = dialog_pickfile(/read, /must_exist, path = data_directory)
      if !version.os eq 'linux' then resolve_it, a
      if strlen(a) le 1 then a = temporary(b)
      widget_control, info.wsi, set_value =a
      END
  'DET_BROWSE': BEGIN
      widget_control, info.wsidet, get_value =b
      a = dialog_pickfile(/read, /must_exist, path = data_directory)
      if !version.os eq 'linux' then resolve_it, a
      if strlen(a) le 1 then a = temporary(b)
      widget_control, info.wsidet, set_value =a
      END
  'GRAT_BROWSE': BEGIN
      widget_control, info.wgrat, get_value =b
      a = dialog_pickfile(/read, /must_exist, $
        path = data_directory+'grating_eff'+path_sep())
      if !version.os eq 'linux' then resolve_it, a
      if strlen(a) le 1 then a = temporary(b)
      widget_control, info.wgrat, set_value =a
      END
  'SIO2_BROWSE': BEGIN
      widget_control, info.wsio2, get_value =b
      a = dialog_pickfile(/read, /must_exist, path = data_directory)
      if !version.os eq 'linux' then resolve_it, a
      if strlen(a) le 1 then a = temporary(b)
      widget_control, info.wsio2, set_value =a
      END
  'DEAD': BEGIN
      id = info.deadt
      widget_control, id, get_value = val
      widget_control, info.deplt, get_value = val2
      if ((val lt 0) or (val2 lt 0)) then begin
         widget_control, info.detf, map=1, sensitive = 1
         widget_control, info.sibase, map=0, sensitive =0
         widget_control, info.detf, /map, sensitive = 1
      endif else begin
         widget_control, info.detf, map=0, sensitive =0
         widget_control, info.sibase, map=1, sensitive =1
         widget_control, info.wsio2, sensitive = 1, /map
         widget_control, info.wsi, sensitive = 1, /map
      endelse
      widget_control, id, set_value = val
      END
  'DEPL': BEGIN
      id = info.deplt
      widget_control, id, get_value = val
      widget_control, info.deadt, get_value = val2
      if ((val lt 0) or (val2 lt 0)) then begin
         widget_control, info.detf, map=1, sensitive = 1
         widget_control, info.sibase, map=0, sensitive =0
         widget_control, info.detf, /map, sensitive = 1
      endif else begin
         widget_control, info.detf, map=0, sensitive =0
         widget_control, info.sibase, map=1, sensitive =1
         widget_control, info.wsio2, sensitive = 1, /map
         widget_control, info.wsi, sensitive = 1, /map
      endelse
      widget_control, id, set_value = val
      END
  'EXIT': BEGIN
      widget_control, info.shotf, get_value = val
      (*(info.ptr)).frac_pinch = val
      widget_control, info.shott, get_value = val
      (*(info.ptr)).theta = val
      widget_control, info.deadt, get_value = val
      (*(info.ptr)).zdead = val
      widget_control, info.deplt, get_value = val
      (*(info.ptr)).zdepl = val
      widget_control, info.wsidet, get_value = val
      (*(info.ptr)).detsens = val[0]
      widget_control, info.wsi, get_value = val
      (*(info.ptr)).sif = val[0]
      widget_control, info.wsio2, get_value = val
      (*(info.ptr)).sio2f = val[0]
      widget_control, info.wgrat, get_value = val
      (*(info.ptr)).grating = val[0]
      widget_control, event.top, tlb_get_offset = offset
      offset = offset+offset_real

      (*(info.ptr)).quit = 0
      widget_control, event.top, /destroy
      END

  'QUIT': BEGIN
      (*(info.ptr)).quit = 1
      widget_control, event.top, /destroy
      END
  
 else: BEGIN
      print, 'Event not covered' 
      help, /str, event
      END
 endcase
end

pro get_tgs_parameters, lcquit, frac_pinch, theta, phi, $
    zdead, zdepl, si_f, sio2_f, detsens, grating, $
    hohlraum = hohlraum, group = group, modal = modal

common get_tgs_param_common

on_error, 2

if n_elements(data_directory) eq 0 then begin
  pfidldir = get_pfidl_directory()
  sep = path_sep()
  if (strpos(pfidldir, sep, /reverse_search) +1 lt strlen(pfidldir)) then $
  pfidldir =pfidldir+sep
  data_directory = pfidldir+'pfidl'+sep+'xrd'+sep+'data'+sep
endif

offset_real = 0
if n_elements(offset) lt 2 then offset = [10,10]
if  n_elements(group) eq 0  then group = 0


tlb = widget_base(group_leader = group, /column, /map, $
        title ='TGS Unfold Parameters')

tlbb = widget_base(tlb, frame = 2, /map, /column)

if n_elements (frac_pinch) eq 0 then frac_pinch = 0.5
hohl = (keyword_set(hohlraum)) ? 1 : 0
tlbba = widget_base (tlbb, /align_center)
butf = cw_bgroup(tlbba, ['Pinch', 'Hohlraum'], /exclusive, /frame, /row, $
       set_value = hohl, uvalue = 'SHOT_TYPE', /no_release)
tlbbtot = widget_base(tlbb)
tlbbb = widget_base (tlbbtot, map= 1-hohl)
tlbbc = widget_base (tlbbtot, map= hohl)
if n_elements (phi) eq 0 then phi = 0.0
shotp = cw_field(tlbbc, value = phi, /row, /return, $
       title = 'Azim Viewing Angle (deg)', /float, uvalue = 'PHI')
shotf = cw_field(tlbbb, value = frac_pinch, /row, /return, $
       title = 'Pinch Fraction', /float, uvalue = 'FRACTION')

if n_elements (theta) eq 0 then theta = 12.0
shott = cw_field(tlbb, value = theta, /row, /return, $
       title = 'Vert Viewing Angle (deg)', /float, uvalue = 'THETA')

detb = widget_base(tlb, /col, /map, frame =1)

text = widget_label(detb, value='** PIN Parameters **')
if n_elements (zdepl) eq 0 then zdepl = 15.
deplt = cw_field(detb, value = zdepl, /row, /return, $
       title = 'Si Absorbing Layer (Microns)', /float, uvalue = 'DEPL')
if n_elements (zdead) eq 0 then zdead = 60.
deadt = cw_field(detb, value = float(zdead), /row, /return, $
       title = 'SiO2 Dead Layer (Angstroms)', /float, uvalue = 'DEAD')
text = widget_label(detb, value='Enter negative thickness to use table')

sens = (zdead lt 0 or zdepl lt 0) ? 1:0
detff = widget_base(detb, /frame)
if n_elements(detsens) eq 0 then detsens= '' else detsens= strtrim(detsens, 2)
if strlen(detsens) eq 0 then $
    detsens = data_directory +'detsens.txt'
detf =  widget_base(detff, /col, map= sens, frame =1, sensitive = sens)
wread = widget_button(detf, value = ' BROWSE ', uvalue = 'DET_BROWSE')
wsidet = widget_text(detf, /scroll, xsize = 60, value = detsens)
           
senc = (sens) ? 0:1
sibase = widget_base(detff, /column, map= senc, frame = 1, sensitive= senc )
text = widget_label(sibase, value='Hit button to select Silicon file')
if n_elements(si_f) eq 0 then si_f= '' else si_f= strtrim(si_f, 2)
if strlen(si_f) eq 0 then si_f = data_directory +'si.txt'
wread = widget_button(sibase, value = ' BROWSE ', uvalue = 'SI_BROWSE')
wsi = widget_text(sibase, /scroll, xsize = 60, value = si_f)

text = widget_label(sibase, value='Hit button to select Silicon Dioxide file')
if n_elements(sio2_f) eq 0 then sio2_f= '' else sio2_f= strtrim(sio2_f, 2)
if strlen(sio2_f) eq 0 then sio2_f = data_directory +'sio2.txt'
wread = widget_button(sibase, value = ' BROWSE ', uvalue = 'SIO2_BROWSE')
wsio2 = widget_text(sibase, /scroll, xsize = 60, value = sio2_f)

gratbase = widget_base(tlb, /column, /map, frame = 1)
text = widget_label(gratbase, value='Hit button to select grating eff file')
if n_elements(grating) eq 0 then grating= '' else grating= strtrim(grating, 2)
if strlen(grating) eq 0 then $
      grating = data_directory +'grating_eff'+path_sep()+'hs14_z_curves.txt'
wread = widget_button(gratbase, value = ' BROWSE ', uvalue = 'GRAT_BROWSE')
wgrat = widget_text(gratbase, /scroll, xsize = 60, value = grating)

bbase = widget_base(tlb, /row, /map, frame=2)
wread = widget_button(bbase, value = '   Q U I T   ', uvalue = 'QUIT')
wread = widget_button(bbase, value = '  F I N I S H E D  ', uvalue = 'EXIT')

  widget_control, tlb, /realize, tlb_set_xoffset = offset(0), $
       tlb_set_yoffset= offset(1)
  widget_control, tlb, tlb_get_offset= offset_real
  offset_real = offset - offset_real
  str = { frac_pinch:frac_pinch, theta:theta, phi:phi, $
        zdead:zdead, zdepl:zdepl, detsens:detsens, grating:grating, $
         sif:si_f, sio2f: sio2_f, quit:0, hohl:hohl } 
  ptr = ptr_new(str)
  info={ptr:ptr, shotf:shotf, shott:shott, $
         shotp:shotp, sibase:sibase, bbb:tlbbb, ccc:tlbbc,   $
       deadt:deadt, deplt:deplt, detf:detf, wsi:wsi, wsio2:wsio2, $
       wsidet:wsidet, wgrat:wgrat, sif:si_f, sio2f:sio2_f}
  
  widget_control, tlb, set_uvalue = info
  XMANAGER, 'get_tgs_parameters', tlb
  lcquit = (*ptr).quit 
  if lcquit eq 1 then return
  frac_pinch = (*ptr).frac_pinch
  theta = (*ptr).theta
  phi = (*ptr).phi
  zdead = (*ptr).zdead
  zdepl = (*ptr).zdepl
  detsens = (*ptr).detsens
  grating =  (*ptr).grating
  si_f = (*ptr).sif
  sio2_f = (*ptr).sio2f
  hohlraum = (*ptr).hohl
  lcquit = 0
  
end
