pro  tgs_funct, e, a, f, pder
; a = [t1, t2, a1, a2]
; a = [t1, a1] 
; a = [t1] 
on_error, 1
 common tgs_common, e3, area_1

; a1, t1, a2, t2

 r1 = E/a[0]
 d1 = exp(r1)
 m =  (5.045e-6*E3)
 term1 = m/(d1 - 1.)
 na = n_elements(a)
 if na eq 1 then begin
;  a = [t1] 
   f = area_1*term1
   pder = term1/(d1-1.0)*d1*r1*(area_1/a[0])
 endif else if na eq 2 then begin
;  a = [t1, a1] 
   pder = make_array (n_elements(e), 2, /double)
   f = a[1]*term1
   pder[*, 1]= term1
   pder[*, 0]=term1/(d1-1.0)*d1*r1*(a[1]/a[0])
 endif else if na eq 3 then begin
;  a = [t1, t2, a2]
   r2 = E/a[1]
   d2 = exp(r2)
   term2 = m/(d2 - 1.)
   pder = make_array (n_elements(e), 3, /double)
   f = area_1*term1+a[2]*term2
   pder[*, 2]= term2
   pder[*, 0]=term1/(d1-1.0)*d1*r1*(area_1/a[0])
   pder[*, 1]=term2/(d2-1.0)*d2*r2*(a[2]/a[1])
 endif else begin
;  a = [t1, t2, a1, a2]
   r2 = E/a[1]
   d2 = exp(r2)
   term2 = m/(d2 - 1.)
   pder = make_array (n_elements(e), 4, /double)
   f = a[2]*term1+a[3]*term2
   pder[*, 2]= term1
   pder[*, 3]= term2
   pder[*, 0]=term1/(d1-1.0)*d1*r1*(a[2]/a[0])
   pder[*, 1]=term2/(d2-1.0)*d2*r2*(a[3]/a[1])
 endelse
end
